﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen.Cls_00_Def
Imports NM_Ahnen.Cls_02_DB
Imports NM_Ahnen.Cls_02_DB_Person_Read
Imports NM_Ahnen.Cls_04_Util
Imports NM_Ahnen.Cls_09_Mask_Person
Imports NM_Ahnen.Cls_90_Mask_801
Imports NM_Ahnen.My.Resources
Public Class NM_Ahnen_Orte
    Private Sub NM_Ahnen_Orte_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Call Mask_Pos_801
        Me.cbx_t08_Event.DropDownStyle = ComboBoxStyle.DropDownList
        Me.cbx_t08_Ort.DropDownStyle = ComboBoxStyle.DropDownList
        Me.cbx_t08_Event.DataSource = str_Tab_Event
        Me.cbx_t08_Ort.DataSource = str_Para_Ort1_Bez

    End Sub

    Private Sub Bt_t08_Neu_Click(sender As Object, e As EventArgs) Handles bt_t08_Neu.Click
        Call Person_Read_Orte()
    End Sub

    Private Sub Bt_t08_Go_Click(sender As Object, e As EventArgs) Handles bt_t08_Go.Click
        Call Ort_t08_Select()
    End Sub

    Private Sub Bt_t08_Cancel_Click(sender As Object, e As EventArgs) Handles bt_t08_Cancel.Click
        Me.Close()
    End Sub

    Public Sub Person_Read_Orte()
        int_Info_Type = 2
        NM_Ahnen_Info.Show()
        Me.Cursor = Cursors.WaitCursor
        mySelect.Connection = con
        mySelect.CommandText = "delete * from t08_Orte"
        Call DB_Execute()
        ' Alle IDs sammeln in Tabelle
        Call ID_Tab_Fuell()
        ' Einzelsätze lesen

        For i77 = 0 To int_Ged_Anz
            int_GOrt = 0
            int_TOrt = 0
            int_SOrtx = 0
            int_BOrt = 0
            int_EOrt1 = 0
            int_EOrt2 = 0

            dbl_ID = lng_ID(i77)
            Call Person_Read_t01_Basis()

            ' Ermitteln Orte
            If p_str_GOrt <> "" Then
                Call Ort_Search(p_str_GOrt)
                int_GOrt = int_XOrt
            End If

            If p_str_SOrt <> "" Then
                Call Ort_Search(p_str_SOrt)
                int_SOrtx = int_XOrt
            End If

            Call Person_Read_t02()
            If p_str_TOrt <> "" Then
                Call Ort_Search(p_str_TOrt)
                int_TOrt = int_XOrt
            End If

            Call Person_Read_t03()
            If p_str_BOrt <> "" Then
                Call Ort_Search(p_str_BOrt)
                int_BOrt = int_XOrt
            End If

            Call Person_Read_t04()
            Call Person_Read_EheDaten()
            If p_str_EOrt1 <> "" Then
                Call Ort_Search(p_str_EOrt1)
                int_EOrt1 = int_XOrt
            End If
            If p_str_EOrt2 <> "" Then
                Call Ort_Search(p_str_EOrt2)
                int_EOrt2 = int_XOrt
            End If

            If int_GOrt > 0 Then Call Ort_t08_Insert(int_GOrt, 1, dbl_ID, p_str_GDat)
            If int_SOrtx > 0 Then Call Ort_t08_Insert(int_SOrtx, 3, dbl_ID, p_str_SDat)
            If int_TOrt > 0 Then Call Ort_t08_Insert(int_TOrt, 2, dbl_ID, p_str_TDat_JJ + p_str_TDat_MM + p_str_TDat_TT)
            If int_BOrt > 0 Then Call Ort_t08_Insert(int_BOrt, 4, dbl_ID, p_str_BDat_JJ + p_str_BDat_MM + p_str_BDat_TT)
            If int_EOrt1 > 0 Then Call Ort_t08_Insert(int_EOrt1, 5, dbl_ID, p_str_EDat1_JJ + p_str_EDat1_MM + p_str_EDat1_TT)
            If int_EOrt2 > 0 Then Call Ort_t08_Insert(int_EOrt2, 6, dbl_ID, p_str_Edat2_JJ + p_str_EDat2_MM + p_str_EDat2_TT)
        Next
        NM_Ahnen_Info.Close()
        Me.Cursor = Cursors.Default
    End Sub

    Public Sub Ort_Search(ByVal str_VOrt As String)
        For i801 = 0 To int_AnzOrte
            If str_VOrt = str_Para_Ort1_Bez(i801) Then int_XOrt = i801 : Exit Sub
        Next
    End Sub

    Public Sub Ort_t08_Insert(ByVal i_Ort As Integer, i_Event As Integer, dbl_PN As Double, EvDat As String)
        Call DB_Tab_High("t08_ID", "t08_Orte")
        dbl_Max_ID += 1
        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t08 anlegen                           *
        REM *--------------------------------------------------------*
        str_DBD_t08 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t08 += "'" + i_Ort.ToString + "',"
        str_DBD_t08 += "'" + i_Event.ToString + "',"
        str_DBD_t08 += "'" + dbl_PN.ToString + "',"
        str_DBD_t08 += "'" + EvDat + "')"

        mySelect.CommandText = "insert into t08_Orte " & str_DBS_t08 & str_DBD_t08
        Call DB_Execute()
    End Sub

    Public Sub Ort_t08_Select()
        Dim str_t08_where As String
        str_t08_where = " where t08_a04_ID = " & int_Sel_Ort.ToString
        If int_Sel_Event < 7 Then str_t08_where += " and t08_Event = " & int_Sel_Event.ToString
        Dim int_AnzSel As Integer = GetNumberOfRecordsTyp(con, "t08_Orte", str_t08_where)
        Me.Text = "NM_Ahnen_Ortsindex  / Treffer: " & int_AnzSel.ToString

        ReDim int_a04_PID(int_AnzSel)
        ReDim int_a04_Event(int_AnzSel)
        ReDim str_t08_Datum(int_AnzSel)
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        Dim str_HDat1 As String
        Dim str_HDat2 As String
        mySelect.Connection = con
        mySelect.CommandText = "select * from t08_Orte" + str_t08_where
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            int_a04_PID(int_i5) = reader.Item("t08_t01_ID")
            int_a04_Event(int_i5) = reader.Item("t08_Event")
            myNull = IsDBNull(reader.Item("t08_Datum"))
            If myNull = False Then
                str_t08_Datum(int_i5) = reader.Item("t08_Datum")
            Else
                str_t08_Datum(int_i5) = "00000000"
            End If
            int_i5 += 1
        Loop
        reader.Close()

        Dim int_HID As Integer = 0
        For int_i3 = 0 To int_i5 - 1
            If int_a04_PID(int_i3) <> int_HID Then
                int_HID = int_a04_PID(int_i3)
                dbl_ID = int_HID
                Call Person_Read_t01_Basis()
            End If
            str_HDat1 = str_t08_Datum(int_i3)
            str_HDat2 = Mid(str_HDat1, 7, 2) + "." + Mid(str_HDat1, 5, 2) + "." + Mid(str_HDat1, 1, 4)
            With dgv_Orte.Rows
                .Add(dbl_ID.ToString("##0"), str_Tab_Event(int_a04_Event(int_i3)), p_str_Name, p_str_Vorname, str_HDat2)
            End With
        Next
    End Sub

    Private Sub Cbx_t08_Ort_SelectedIndexChanged_1(sender As Object, e As EventArgs) Handles cbx_t08_Ort.SelectedIndexChanged
        int_Sel_Ort = Me.cbx_t08_Ort.SelectedIndex
    End Sub

    Private Sub Cbx_t08_Event_SelectedIndexChanged_1(sender As Object, e As EventArgs) Handles cbx_t08_Event.SelectedIndexChanged
        int_Sel_Event = Me.cbx_t08_Event.SelectedIndex
        str_Sel_Event = Me.cbx_t08_Event.SelectedItem
        int_Sel_Event += 1

    End Sub
    Private Sub Dgv_Orte_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Orte.CellClick
        dbl_Sel_ID = dgv_Orte.CurrentRow.Cells(0).Value
        dbl_ID = dbl_Sel_ID
        Me.Close()
        Call Person_Read_01()
    End Sub

End Class