﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_60_Info
Imports NM_Ahnen.cls_03_DB_Bilder
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_50_Daten_14
Imports NM_Ahnen.cls_50_Daten_15
Imports NM_Ahnen.My.Resources

Class Cls_06_Person_Konsistenz

    REM **************************************************************
    REM *  Laden der Personendaten (Tabelle t01)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_98_01()
        Dim reader As OleDbDataReader
        Dim int_MaxK98 As Integer = GetNumberOfRecords(con, "t01")

        ReDim GM_str_NR(int_MaxK98)
        int_GM1 = 0
        If dbl_ID <> lng_ID(int_Zeig_Pers) Then Call Ermitteln_TabPos()

        'For int_98_lfd = 0 To int_MaxK98

        mySelect.CommandText = "select * from t01"
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item(0))
                If myNull = False Then GM1_Nr = reader.Item(0).ToString
                GM_str_NR(int_GM1) = GM1_Nr
Int:            int_GM1 += 1

            Loop
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        Call Person_Read_98_t01_Basis()

        REM *--------------------------------------------------------*
        REM *  Dazulesen der Eltern                                  *
        REM *--------------------------------------------------------*
        Call Person_Read_98_Vater()
        Call Person_Read_98_Mutter()

        REM *--------------------------------------------------------*
        REM *  Dazulesen der Tauftabelle                             *
        REM *--------------------------------------------------------*
        Call Person_Read_98_t02()

        REM *--------------------------------------------------------*
        REM *  Dazulesen der Beerdigungstabelle                      *
        REM *--------------------------------------------------------*
        Call Person_Read_98_t03()

        REM *--------------------------------------------------------*
        REM *  Dazulesen der Ehetabelle                              *
        REM *--------------------------------------------------------*
        Call Person_Read_98_t04()
        Call Person_Read_EheDaten()

        REM *--------------------------------------------------------*
        REM *  Alle gelesenen Datein in Output-Felder übertragen     *
        REM *--------------------------------------------------------*
        'Call Mask_Out_Person()

        'Call Change_Button(myNein)

    End Sub


    REM **************************************************************
    REM *  Ermitteln der aktuellen Position in ID-Tab                *
    REM **************************************************************
    Public Shared Sub Ermitteln_TabPos()

        Dim i88 As Integer
        For i88 = 0 To dbl_Max
            If dbl_ID = lng_ID(i88) Then
                int_Zeig_Pers = i88
                Exit For
            End If
        Next

    End Sub

    REM **************************************************************
    REM *  Lesen der Personenbasisdaten = Tabelle t01                *
    REM **************************************************************
    Public Shared Sub Person_Read_98_t01_Basis()

        Dim reader As OleDbDataReader
        Dim int_GM3 As Integer = 0

        For int_GM3 = 0 To int_GM1
            dbl_ID = Val(GM_str_NR(int_GM3))
        Next
        str_Where = " where t01_ID = " + dbl_ID.ToString
        mySelect.CommandText = "select * from t01_Person" & str_Where

        Try

            reader = mySelect.ExecuteReader
            Do While reader.Read()

                myNull = IsDBNull(reader.Item("t01_Id"))
                If myNull = False Then p_int_ID = reader.Item("t01_Id")

                myNull = IsDBNull(reader.Item("t01_Name"))
                If myNull = False Then p_str_Name = reader.Item("t01_Name")

                myNull = IsDBNull(reader.Item("t01_GebName"))
                If myNull = False Then p_str_GebName = reader.Item("t01_GebName")

                myNull = IsDBNull(reader.Item("t01_NameZ"))
                If myNull = False Then p_str_NameZ = reader.Item("t01_NameZ")

                myNull = IsDBNull(reader.Item("t01_Vorname"))
                If myNull = False Then p_str_Vorname = reader.Item("t01_Vorname")

                myNull = IsDBNull(reader.Item("t01_Geschl"))
                If myNull = False Then p_str_Geschl = reader.Item("t01_Geschl")

                myNull = IsDBNull(reader.Item("t01_Vater"))
                If myNull = False Then p_int_Vater = reader.Item("t01_Vater")

                myNull = IsDBNull(reader.Item("t01_Mutter"))
                If myNull = False Then p_int_Mutter = reader.Item("t01_Mutter")

                myNull = IsDBNull(reader.Item("t01_GDat_TT"))
                If myNull = False Then p_str_GDat_TT = reader.Item("t01_GDat_TT")
                int_Old1_T = Val(p_str_GDat_TT)

                myNull = IsDBNull(reader.Item("t01_GDat_MM"))
                If myNull = False Then p_str_GDat_MM = reader.Item("t01_GDat_MM")
                int_Old1_M = Val(p_str_GDat_MM)

                myNull = IsDBNull(reader.Item("t01_GDat_JJ"))
                If myNull = False Then p_str_GDat_JJ = reader.Item("t01_GDat_JJ")
                int_Old1_J = Val(p_str_GDat_JJ)

                myNull = IsDBNull(reader.Item("t01_SDat_TT"))
                If myNull = False Then p_str_SDat_TT = reader.Item("t01_SDat_TT")
                int_Old2_T = Val(p_str_SDat_TT)

                myNull = IsDBNull(reader.Item("t01_SDat_MM"))
                If myNull = False Then p_str_SDat_MM = reader.Item("t01_SDat_MM")
                int_Old2_M = Val(p_str_SDat_MM)

                myNull = IsDBNull(reader.Item("t01_SDat_JJ"))
                If myNull = False Then p_str_SDat_JJ = reader.Item("t01_SDat_JJ")
                int_Old2_J = Val(p_str_SDat_JJ)

                p_str_GDat = p_str_GDat_JJ & p_str_GDat_MM & p_str_GDat_TT
                p_str_GDat = Val(p_str_GDat)
                p_str_SDat = p_str_SDat_JJ & p_str_SDat_MM & p_str_SDat_TT
                p_str_SDat = Val(p_str_SDat)
            Loop
            reader.Close()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten des Vaters                        *
    REM **************************************************************
    Public Shared Sub Person_Read_98_Vater()

        If p_int_Vater > 0 Then
            lng_Pers = p_int_Vater
            Call Person_Read_Rolle()
            v_lng_ID = p_int_Vater
            v_str_Name = r_str_Name
            v_str_GebName = r_str_GebName
            v_str_Vorname = r_str_Vorname
            v_str_GDat_JJ = r_str_GDat_JJ
            v_str_GDat_MM = r_str_GDat_MM
            v_str_GDat_TT = r_str_GDat_TT
            v_str_SDat_JJ = r_str_SDat_JJ
            v_str_SDat_MM = r_str_SDat_MM
            v_str_SDat_TT = r_str_SDat_TT
            v_str_GOrt = r_str_GOrt
            v_str_SOrt = r_str_SOrt
        Else
            v_lng_ID = 0
            v_str_Name = ""
            v_str_GebName = ""
            v_str_Vorname = ""
            v_str_GDat_JJ = ""
            v_str_GDat_MM = ""
            v_str_GDat_TT = ""
            v_str_SDat_JJ = ""
            v_str_SDat_MM = ""
            v_str_SDat_TT = ""
            v_str_GOrt = ""
            v_str_SOrt = ""
        End If

    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten der Mutter                        *
    REM **************************************************************
    Public Shared Sub Person_Read_98_Mutter()

        If p_int_Mutter > 0 Then
            lng_Pers = p_int_Mutter
            Call Person_Read_Rolle()
            m_lng_ID = p_int_Mutter
            m_str_Name = r_str_Name
            m_str_GebName = r_str_GebName
            m_str_Vorname = r_str_Vorname
            m_str_GDat_JJ = r_str_GDat_JJ
            m_str_GDat_MM = r_str_GDat_MM
            m_str_GDat_TT = r_str_GDat_TT
            m_str_SDat_JJ = r_str_SDat_JJ
            m_str_SDat_MM = r_str_SDat_MM
            m_str_SDat_TT = r_str_SDat_TT
            m_str_GOrt = r_str_GOrt
            m_str_SOrt = r_str_SOrt
        Else
            m_lng_ID = 0
            m_str_Name = ""
            m_str_GebName = ""
            m_str_Vorname = ""
            m_str_GDat_JJ = ""
            m_str_GDat_MM = ""
            m_str_GDat_TT = ""
            m_str_SDat_JJ = ""
            m_str_SDat_MM = ""
            m_str_SDat_TT = ""
            m_str_GOrt = ""
            m_str_SOrt = ""
        End If

    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t02)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_98_t02()

        Dim reader As OleDbDataReader

        str_Where = " where t02_ID = " + dbl_ID.ToString
        mySelect.CommandText = "select * from t02_Taufe" & str_Where

        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    myNull = IsDBNull(reader.Item("t02_Konf"))
                    If myNull = False Then p_str_Konf = reader.Item("t02_Konf")

                    myNull = IsDBNull(reader.Item("t02_TDat_TT"))
                    If myNull = False Then p_str_TDat_TT = reader.Item("t02_TDat_TT")

                    myNull = IsDBNull(reader.Item("t02_TDat_MM"))
                    If myNull = False Then p_str_TDat_MM = reader.Item("t02_TDat_MM")

                    myNull = IsDBNull(reader.Item("t02_TDat_JJ"))
                    If myNull = False Then p_str_TDat_JJ = reader.Item("t02_TDat_JJ")

                    myNull = IsDBNull(reader.Item("t02_FDat_TT"))
                    If myNull = False Then p_str_FDat_TT = reader.Item("t02_FDat_TT")

                    myNull = IsDBNull(reader.Item("t02_FDat_MM"))
                    If myNull = False Then p_str_FDat_MM = reader.Item("t02_FDat_MM")

                    myNull = IsDBNull(reader.Item("t02_FDat_JJ"))
                    If myNull = False Then p_str_FDat_JJ = reader.Item("t02_FDat_JJ")

                    myNull = IsDBNull(reader.Item("t02_FDat_Art"))
                    If myNull = False Then p_int_FDat_Art = reader.Item("t02_FDat_Art")

                    int_Merk_Tab_Taufe = 1
                Loop
            End If

            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t03)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_98_t03()

        Dim reader As OleDbDataReader

        str_Where = " where t03_ID = " + dbl_ID.ToString
        mySelect.CommandText = "select * from t03_Beerd" & str_Where

        Try

            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()

                    myNull = IsDBNull(reader.Item("t03_BDat_TT"))
                    If myNull = False Then p_str_BDat_TT = reader.Item("t03_BDat_TT")

                    myNull = IsDBNull(reader.Item("t03_BDat_MM"))
                    If myNull = False Then p_str_BDat_MM = reader.Item("t03_BDat_MM")

                    myNull = IsDBNull(reader.Item("t03_BDat_JJ"))
                    If myNull = False Then p_str_BDat_JJ = reader.Item("t03_BDat_JJ")

                    myNull = IsDBNull(reader.Item("t03_BDat_Art"))
                    If myNull = False Then p_int_BDat_Art = reader.Item("t03_BDat_Art")

                    int_Merk_Tab_Beerd = 1

                Loop
            End If

            reader.Close()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t04)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_98_t04()

        Dim reader As OleDbDataReader
        Dim int_k99 As Integer

        mySelect.CommandText = "select count(*) from t04_Ehe"
        str_Where = " where t04_Partner1 = " + p_int_ID.ToString

        int_Anz = GetNumberOfRecordsTyp(con, "t04_Ehe", str_Where)
        int_Ehe = -1

        If int_Anz = 0 Then
            Exit Sub
        End If

        ReDim lng_Ehe_ID(int_Anz)
        For int_k99 = 0 To 5
            te_lng_ID(int_k99) = 0
            te_str_GDat_JJ(int_k99) = ""
            te_str_GDat_MM(int_k99) = ""
            te_str_GDat_TT(int_k99) = ""
            te_str_GOrt(int_k99) = ""
            te_str_SDat_JJ(int_k99) = ""
            te_str_SDat_MM(int_k99) = ""
            te_str_SDat_TT(int_k99) = ""
            te_str_SOrt(int_k99) = ""
            te_str_Name(int_k99) = ""
            te_str_GebName(int_k99) = ""
            te_str_Vorname(int_k99) = ""
            te_str_Geschl(int_k99) = ""
        Next

        str_Where = " where t04_Partner1 = " + p_int_ID.ToString
        mySelect.CommandText = "select * from t04_Ehe" + str_Where

        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    int_Ehe += 1
                    lng_Ehe_ID(int_Ehe) = reader.Item("t04_Partner2")
                Loop
                int_Merk_Tab_Ehe = 1
            End If
            reader.Close()


        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try

        For int_l01 = 0 To int_Ehe
            int_Pos_E = int_l01
            p_int_Ehe = lng_Ehe_ID(int_l01)
            lng_Pers = p_int_Ehe
            Call Person_Read_Rolle()
            te_lng_ID(int_Pos_E) = p_int_Ehe
            te_str_Name(int_Pos_E) = r_str_Name
            te_str_GebName(int_Pos_E) = r_str_GebName
            te_str_Vorname(int_Pos_E) = r_str_Vorname
            te_str_GDat_TT(int_Pos_E) = r_str_GDat_TT
            te_str_GDat_MM(int_Pos_E) = r_str_GDat_MM
            te_str_GDat_JJ(int_Pos_E) = r_str_GDat_JJ
            te_str_GOrt(int_Pos_E) = r_str_GOrt
            te_str_SDat_TT(int_Pos_E) = r_str_SDat_TT
            te_str_SDat_MM(int_Pos_E) = r_str_SDat_MM
            te_str_SDat_JJ(int_Pos_E) = r_str_SDat_JJ
            te_str_SOrt(int_Pos_E) = r_str_SOrt
            te_str_Geschl(int_Pos_E) = r_str_Geschl
        Next

    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t041)                    *
    REM **************************************************************
    Public Shared Sub Person_Read_EheDaten()

        Dim reader As OleDbDataReader

        str_Where = " where t04_Partner1 = " + p_int_ID.ToString + " and t04_Partner2 = " + p_int_Ehe41.ToString
        mySelect.CommandText = "select * from t04_Ehe" + str_Where

        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    dbl_Ehe41 = reader.Item("t04_FK_ID")
                Loop
            End If
            reader.Close()

        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try

        int_Gedcom = 0

        str_Where = " where t041_ID = " + dbl_Ehe41.ToString
        mySelect.CommandText = "select * from t041_EheDaten" + str_Where

        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()

                    int_Gedcom = 1

                    myNull = IsDBNull(reader.Item("t041_Dat1_TT"))
                    If myNull = False Then p_str_EDat1_TT = reader.Item("t041_Dat1_TT")

                    myNull = IsDBNull(reader.Item("t041_Dat1_MM"))
                    If myNull = False Then p_str_EDat1_MM = reader.Item("t041_Dat1_MM")

                    myNull = IsDBNull(reader.Item("t041_Dat1_JJ"))
                    If myNull = False Then p_str_EDat1_JJ = reader.Item("t041_Dat1_JJ")

                    myNull = IsDBNull(reader.Item("t041_Dat2_TT"))
                    If myNull = False Then p_str_EDat2_TT = reader.Item("t041_Dat2_TT")

                    myNull = IsDBNull(reader.Item("t041_Dat2_MM"))
                    If myNull = False Then p_str_EDat2_MM = reader.Item("t041_Dat2_MM")

                    myNull = IsDBNull(reader.Item("t041_Dat2_JJ"))
                    If myNull = False Then p_str_Edat2_JJ = reader.Item("t041_Dat2_JJ")

                    myNull = IsDBNull(reader.Item("t041_Dat3_TT"))
                    If myNull = False Then p_str_EDat3_TT = reader.Item("t041_Dat3_TT")

                    myNull = IsDBNull(reader.Item("t041_Dat3_MM"))
                    If myNull = False Then p_str_EDat3_MM = reader.Item("t041_Dat3_MM")

                    myNull = IsDBNull(reader.Item("t041_Dat3_JJ"))
                    If myNull = False Then p_str_EDat3_JJ = reader.Item("t041_Dat3_JJ")

                Loop
            End If
            reader.Close()

        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try

    End Sub


    REM **************************************************************
    REM *  Löschen der Speicherwerte                                 *
    REM **************************************************************
    Public Shared Sub Person_Adresse_Clear()
        p_int_Adr_Lfd = 0
        p_str_Adr_Land = ""
        p_str_Adr_ZIP = ""
        p_str_Adr_Ort = ""
        p_str_Adr_Strasse = ""
        p_str_Adr_DatV_TT = ""
        p_str_Adr_DatV_MM = ""
        p_str_Adr_DatV_JJ = ""
        p_str_Adr_DatB_TT = ""
        p_str_Adr_DatB_MM = ""
        p_str_Adr_DatB_JJ = ""
        p_str_Adr_Tel1 = ""
        p_str_Adr_Tel2 = ""
        p_str_Adr_Fax = ""
        p_str_Adr_Mail = ""
        p_str_Adr_www = ""

    End Sub




    REM **************************************************************
    REM *  Lesen der Personendaten der Eltern                        *
    REM **************************************************************
    Public Shared Sub Person_Read_Rolle()

        Dim reader As OleDbDataReader

        str_Where = " where t01_ID = " + lng_Pers.ToString
        mySelect.CommandText = "select * from t01_Person" & str_Where

        r_lng_ID = 0
        r_str_Name = ""
        r_str_GebName = ""
        r_str_Vorname = ""
        r_str_GDat_TT = ""
        r_str_GDat_MM = ""
        r_str_GDat_JJ = ""
        r_str_GOrt = ""
        r_str_SDat_TT = ""
        r_str_SDat_MM = ""
        r_str_SDat_JJ = ""
        r_str_SOrt = ""
        r_str_Geschl = ""

        reader = mySelect.ExecuteReader

        Try
            Do While reader.Read()

                myNull = IsDBNull(reader.Item("t01_Name"))
                If myNull = False Then r_str_Name = reader.Item("t01_Name")

                myNull = IsDBNull(reader.Item("t01_GebName"))
                If myNull = False Then r_str_GebName = reader.Item("t01_GebName")

                myNull = IsDBNull(reader.Item("t01_Vorname"))
                If myNull = False Then r_str_Vorname = reader.Item("t01_Vorname")

                myNull = IsDBNull(reader.Item("t01_GDat_TT"))
                If myNull = False Then r_str_GDat_TT = reader.Item("t01_GDat_TT")

                myNull = IsDBNull(reader.Item("t01_GDat_MM"))
                If myNull = False Then r_str_GDat_MM = reader.Item("t01_GDat_MM")

                myNull = IsDBNull(reader.Item("t01_GDat_JJ"))
                If myNull = False Then r_str_GDat_JJ = reader.Item("t01_GDat_JJ")

                myNull = IsDBNull(reader.Item("t01_GOrt"))
                If myNull = False Then r_str_GOrt = reader.Item("t01_GOrt")

                myNull = IsDBNull(reader.Item("t01_SDat_TT"))
                If myNull = False Then r_str_SDat_TT = reader.Item("t01_SDat_TT")

                myNull = IsDBNull(reader.Item("t01_SDat_MM"))
                If myNull = False Then r_str_SDat_MM = reader.Item("t01_SDat_MM")

                myNull = IsDBNull(reader.Item("t01_SDat_JJ"))
                If myNull = False Then r_str_SDat_JJ = reader.Item("t01_SDat_JJ")

            Loop
            reader.Close()

        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Laden der Personendaten (Tabelle t01)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_Search()

        Dim reader As OleDbDataReader

        s_str_Geschl = ""
        s_int_Vater = 0
        s_int_Mutter = 0
        s_str_GDat_TT = ""
        s_str_GDat_MM = ""
        s_str_GDat_JJ = ""
        s_str_SDat_TT = ""
        s_str_SDat_MM = ""
        s_str_SDat_JJ = ""

        str_Where = " where t01_ID = " + dbl_Sel_ID.ToString
        mySelect.CommandText = "select * from t01_Person" & str_Where

        Try

            reader = mySelect.ExecuteReader
            Do While reader.Read()

                myNull = IsDBNull(reader.Item("t01_Geschl"))
                If myNull = False Then s_str_Geschl = reader.Item("t01_Geschl")

                myNull = IsDBNull(reader.Item("t01_Vater"))
                If myNull = False Then s_int_Vater = reader.Item("t01_Vater")

                myNull = IsDBNull(reader.Item("t01_Mutter"))
                If myNull = False Then s_int_Mutter = reader.Item("t01_Mutter")

                myNull = IsDBNull(reader.Item("t01_GDat_TT"))
                If myNull = False Then s_str_GDat_TT = reader.Item("t01_GDat_TT")

                myNull = IsDBNull(reader.Item("t01_GDat_MM"))
                If myNull = False Then s_str_GDat_MM = reader.Item("t01_GDat_MM")

                myNull = IsDBNull(reader.Item("t01_GDat_JJ"))
                If myNull = False Then s_str_GDat_JJ = reader.Item("t01_GDat_JJ")

                myNull = IsDBNull(reader.Item("t01_SDat_TT"))
                If myNull = False Then s_str_SDat_TT = reader.Item("t01_SDat_TT")

                myNull = IsDBNull(reader.Item("t01_SDat_MM"))
                If myNull = False Then s_str_SDat_MM = reader.Item("t01_SDat_MM")

                myNull = IsDBNull(reader.Item("t01_SDat_JJ"))
                If myNull = False Then s_str_SDat_JJ = reader.Item("t01_SDat_JJ")

                s_str_GDat = s_str_GDat_JJ + s_str_GDat_MM + s_str_GDat_TT
                s_str_GDat = Val(s_str_GDat)
                s_str_SDat = s_str_SDat_JJ + s_str_SDat_MM + s_str_SDat_TT
                s_str_SDat = Val(s_str_SDat)

            Loop
            reader.Close()

        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try

    End Sub


    REM **************************************************************
    REM *  Laden der Konsistenzdaten (Tabelle t98)                   *
    REM **************************************************************
    Public Shared Sub Person_Read_T98()

        Dim reader As OleDbDataReader
        Dim str_TabXX As String = ""
        a_dbl_t99 = 0
        a_int_Lfd = 0
        a_str_Name = ""
        a_str_GebName = ""
        a_str_Vorname = ""
        a_str_GDat = ""
        a_str_TI = "1"
        a_str_Aktion = ""

        NM_Ahnen_ToDo.dgv_401.Rows.Clear()

        mySelect.CommandText = "select * from t98_Aufgabe"
        If lng_HID > 0 Then mySelect.CommandText = "select * from t98_Aufgabe where t98_FK_t01 = " + lng_HID.ToString
        Try

            reader = mySelect.ExecuteReader

            Do While reader.Read()

                myNull = IsDBNull(reader.Item("t98_FK_t01"))
                If myNull = False Then a_dbl_t99 = reader.Item("t98_FK_t01")

                myNull = IsDBNull(reader.Item("t99_LFD"))
                If myNull = False Then a_int_Lfd = reader.Item("t98_LFD")

                myNull = IsDBNull(reader.Item("t99_Name"))
                If myNull = False Then a_str_Name = reader.Item("t98_Name")

                myNull = IsDBNull(reader.Item("t99_GebName"))
                If myNull = False Then a_str_GebName = reader.Item("t98_GebName")

                myNull = IsDBNull(reader.Item("t99_Vorname"))
                If myNull = False Then a_str_Vorname = reader.Item("t98_Vorname")

                myNull = IsDBNull(reader.Item("t98_TabIndex"))
                If myNull = False Then a_str_TI = str_Tab_Text(Val(reader.Item("t98_TabIndex")))

                myNull = IsDBNull(reader.Item("t98_Aktion"))
                If myNull = False Then a_str_Aktion = reader.Item("t98_Aktion")

                REM *--------------------------------------------*
                REM *  Füllen des DataGrids                      *
                REM *--------------------------------------------*
                With NM_Ahnen_ToDo.dgv_401
                    With .Rows
                        .Add(a_dbl_t99.ToString("###0"), a_int_Lfd, a_str_Name, a_str_GebName, a_str_Vorname, a_str_GDat, a_str_Aktion, "OK", a_str_TI)
                    End With
                End With

            Loop

            reader.Close()

        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try

    End Sub

End Class
