﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.Windows.Forms
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Import_GM
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_20_Blaettern
Imports NM_Ahnen.cls_60_Info

Public Class NM_Ahnen_DB

    Private Sub NM_Ahnen_DB_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call DB_Change_Wahl()
        Me.bt_DBC_OK.Focus()
        Me.Show()
        'Call Change_Ini()

    End Sub


    Private Sub Lbx_DBC_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbx_DBC.SelectedIndexChanged

        str_DBName = lbx_DBC.SelectedItem.ToString()

    End Sub

    Private Sub Bt_DBC_OK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_DBC_OK.Click, bt_DBC_OK.Click

        Call Change_Ini()
        Me.Close()
        REM *  Neustart mit neu angelegter Datenbank
        con.Close()
        Call Load_INI()
        Call Open_DB()
        Call Open_Para()
        Call Grundwerte()
        Call Blaettern_First()
        NM_Ahnen.Show()

    End Sub


    Private Sub Bt_DBC_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_DBC_Cancel.Click, bt_DBC_Cancel.Click
        Me.Close()

    End Sub


    REM ***************************************************************
    REM *  Auslesen der INI-Datei und mögliche DB in Listbox anzeigen *
    REM ***************************************************************
    Public Shared Sub DB_Change_Wahl()
        Dim ze As String
        Dim int_in1 As Integer = 1
        Dim int_in5 As Integer

        REM * Lesen der INI-Datei
        str_NM99 = ""
        str_ini = "NM_Ahnen.ini"

        Dim fr As FileStream = New FileStream(str_ini, FileMode.Open)
        Dim sr As StreamReader = New StreamReader(fr)
        REM *  Arbeitstabelle anlegen
        ReDim str_IN1(100)

        REM *  Ermitteln der Datensätze
        Try
            Do Until sr.Peek() = -1
                ze = sr.ReadLine()
                If Mid(ze, 1, 3) = "[N2" And Mid(ze, 6, 2) = "]=" Then
                    str_IN1(int_in1) = Mid(ze, 8, Len(ze) - 7)
                    int_in1 += 1
                End If
            Loop
            sr.Close()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        REM *  Listbox füllen
        NM_Ahnen_DB.lbx_DBC.Items.Clear()
        For int_in5 = 1 To (int_in1 - 1)
            NM_Ahnen_DB.lbx_DBC.Items.Add(str_IN1(int_in5))
        Next int_in5
        NM_Ahnen_DB.lbx_DBC.Visible = True

    End Sub

    Public Shared Sub Change_Ini()
        REM *-------------------------------------------------------------------*
        REM *  ini-Datei aktualisieren                                          *
        REM *-------------------------------------------------------------------*
        Dim ze As String
        Dim str_NMInd As String
        Dim int_ini As Integer = 1
        Dim int_in5 As Integer

        REM *-------------------------------------------------------------------*
        REM *  ini-Datei aktualisieren                                          *
        REM *-------------------------------------------------------------------*

        str_NM99 = ""
        str_ini = "NM_Ahnen.ini"

        Dim fr As FileStream = New FileStream(str_ini, FileMode.Open)
        Dim sr As StreamReader = New StreamReader(fr)
        REM *  Arbeitstabelle anlegen
        ReDim str_IN1(100)

        REM *  Ermitteln der Datensätze
        Try
            Do Until sr.Peek() = -1
                ze = sr.ReadLine()
                str_NMInd = Mid(ze, 1, 6)
                If str_NMInd = "[NM02]" Or str_NMInd = "[NM03]" Then
                    ze = str_NMInd + "=" + str_DBName
                End If
                str_IN1(int_ini) = Mid(ze, 1, Len(ze))
                int_ini += 1

            Loop
            sr.Close()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        REM *  Datei neu anlegen und Tabelle einfügen
        Dim fw As FileStream = New FileStream(str_ini, FileMode.Create)
        Dim sv As New StreamWriter(fw)

        For int_in5 = 1 To int_ini
            ze = str_IN1(int_in5)
            sv.WriteLine(ze)
        Next int_in5
        sv.Close()

    End Sub

End Class