﻿Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.Cls_90_Mask_201
Imports NM_Ahnen.Cls_91_DB_Para
Imports NM_Ahnen.Cls_91_DB_Para_04
Imports NM_Ahnen.Cls_91_DB_Para_06
Imports NM_Ahnen.Cls_91_DB_Para_07
Imports NM_Ahnen.Cls_91_DB_Para_08
Imports NM_Ahnen.Cls_91_DB_Para_09

Public Class NM_Ahnen_Para

    Private Sub NM_Ahnen_Para_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim ToolTip2 As New ToolTip()
        ToolTip2.SetToolTip(Me.bt_201_Cancel, "Abbruch")
        ToolTip2.SetToolTip(Me.bt_201_Neu, "Neuanlage")
        ToolTip2.SetToolTip(Me.bt_201_kpl, "Neuaufbau")
        ToolTip2.SetToolTip(Me.bt_201_Return, "Rücksprung")
        ToolTip2.SetToolTip(Me.bt_201_OK, "Bestätigen")

        Me.Text = "Parameterdaten"
        int_SelPara = 0
        Call Mask_Pos_200()
        Call MenueButtonSicht(False)
        Me.bt_201_Cancel.Visible = True

        int_Para_DB = 0

        Call Para_Datum_Load()
        Call Para_Altersgrenzen_Load()
        Call Para_Konf_Load()
        Call Para_Orte_Load()
    End Sub
    Private Sub Tb_Para_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_Para.SelectedIndexChanged
        Dim int_Help = tb_Para.SelectedIndex
        Call MenueButtonSicht(False)
        Me.grp_Ort_Neu.Visible = False
        Me.bt_201_Cancel.Visible = True
        'tb_Para.TabPages(int_Help).ForeColor() = Color.Red
        Select Case int_Help
            Case 0
                Call Tab_0_Basis()
            Case 1
                Call Tab_1_Datum()
            Case 2
                Call Tab_2_Alter()
            Case 3
                Call Tab_3_Konf()
            Case 4
                Call Tab_4_Namen()
            Case 5
                Call Tab_5_Vornamen()
            Case 6
                Call Tab_6_Beruf()
            Case 7
                Call Tab_7_Ort()
            Case 8
                Call Tab_8_Tod()
            Case 9
                Call Tab_9_Allg()
        End Select
    End Sub


    REM **************************************************************
    REM *  Bearbeitung der selektierten Registerkarten               *
    REM **************************************************************
    Private Sub Tab_0_Basis()
        int_SelPara = 0
        Me.bt_201_OK.Visible = True
        Me.bt_201_Cancel.Visible = True
        Call Para_Zeigen()

    End Sub

    Private Sub Tab_1_Datum()
        int_SelPara = 1
        Me.bt_201_Neu.Visible = True
        'Me.bt_201_OK.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Tab_2_Alter()
        int_SelPara = 2
        Call Para_Zeigen()
    End Sub

    Private Sub Tab_3_Konf()
        int_SelPara = 3
        Me.bt_201_Neu.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Tab_4_Namen()
        int_SelPara = 4
        Call Para_Namen_Load()
        'Me.bt_201_Neu.Visible = True
        Me.bt_201_kpl.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Tab_5_Vornamen()
        int_SelPara = 5
        Call Para_Vornamen_Load()
        'Me.bt_201_Neu.Visible = True
        Me.bt_201_kpl.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Tab_6_Beruf()
        int_SelPara = 6
        Call Para_Beruf_Load()
        'Me.bt_201_Neu.Visible = True
        Me.bt_201_kpl.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Tab_7_Ort()
        int_SelPara = 7
        'Me.bt_201_Neu.Visible = True
        Me.bt_201_kpl.Visible = True
        Call Para_Zeigen()
    End Sub

    Private Sub Tab_8_Tod()
        int_SelPara = 8
        Call Para_Tod_Load()
        'Me.bt_201_Neu.Visible = True
        Me.bt_201_kpl.Visible = True
        Call Para_Zeigen()
    End Sub
    Private Sub Tab_9_Allg()
        int_SelPara = 9
        str_t1 = str_Pfad_Pic
        Me.tx_DokPfad.Text = str_t1
        Me.bt_201_OK.Visible = True
        Me.bt_201_Cancel.Visible = True
        Call Para_Zeigen()
    End Sub

    REM *----------------------------------------------------------------*
    REM *  Bearbeitung mit OK abschließen                                *
    REM *----------------------------------------------------------------*
    Private Sub Bt_201_OK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_201_OK.Click

        If int_SelPara = 1 Then
            If int_Para_DB = 1 Then Call Para_Datum_DB_Insert()
            If int_Para_DB = 2 Then Call Para_Datum_DB_Update()
        End If
        If int_SelPara = 2 Then
            Call Para_Altersgrenze_DB_Update()
        End If
        If int_SelPara = 3 Then
            If int_Para_DB = 1 Then Call Para_Konf_DB_Insert()
            If int_Para_DB = 2 Then Call Para_Konf_DB_Update()
        End If
        If int_SelPara = 4 Then
            If int_Para_DB = 1 Then Call Para_Namen_Insert()
            If int_Para_DB = 2 Then Call Para_Namen_Update2()
        End If
        If int_SelPara = 5 Then
            If int_Para_DB = 1 Then Call Para_Vornamen_Insert()
            If int_Para_DB = 2 Then Call Para_Vornamen_Update2()
        End If
        If int_SelPara = 6 Then
            If int_Para_DB = 1 Then Call Para_Beruf_Insert()
            If int_Para_DB = 2 Then Call Para_Beruf_Update2()
        End If
        If int_SelPara = 7 Then
            If int_Para_DB = 1 Then Call Para_Orte_Insert()
            If int_Para_DB = 2 Then Call Para_Orte_Update()
        End If
        If int_SelPara = 8 Then
            If int_Para_DB = 1 Then Call Para_Tod_Insert()
            If int_Para_DB = 2 Then Call Para_Tod_Update2()
        End If
        If int_SelPara = 9 Then
            Call Para_Pfad_DB_Update()
        End If
    End Sub

    REM *-------------------------------------------------------------*
    REM *  Abbruch der Maskenverarbeitung                             *
    REM *-------------------------------------------------------------*
    Private Sub Bt_201_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_201_Cancel.Click
        Me.Text = "Parameterdaten"
        int_SelPara = 0
        Me.tb_Para.SelectTab(int_SelPara)
        Call MenueButtonSicht(True)
        Me.bt_201_Neu.Visible = False
        Me.bt_201_kpl.Visible = False
        Me.tb_Para.Show()
        Me.Close()
    End Sub

    REM **************************************************************
    REM *  Steuerung bei Datumsvarianten                             *
    REM **************************************************************
    Private Sub Bt_205_Aend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        int_Para_DB = 2
        Call ButtonSicht(True)
        Call Para_Orte_Update()
    End Sub

    Private Sub Tb_Para_Beruf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_Para_Beruf.Click

    End Sub

    REM *---------------------------------------------------------------------*
    REM *  Steuerung bei Neuanlage                                            *
    REM *---------------------------------------------------------------------*
    Private Sub Bt_201_Neu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_201_Neu.Click
        int_Para_DB = 1
        Call ButtonSicht(True)
        If int_SelPara = 1 Then Call Para_Neu(1)
        If int_SelPara = 3 Then Call Para_Neu(2)
        If int_SelPara = 4 Then Call Para_Namen_Neu()
        If int_SelPara = 5 Then Call Para_Vornamen_Neu()
        If int_SelPara = 6 Then Call Para_Beruf_Neu()
        If int_SelPara = 7 Then Call Para_Orte_Neu()
        If int_SelPara = 8 Then Call Para_Tod_Neu()
    End Sub

    REM *---------------------------------------------------------------------*
    REM *  Steuerung bei Datenaufbau                                          *
    REM *---------------------------------------------------------------------*
    Private Sub Bt_201_kpl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_201_kpl.Click
        Me.Cursor = Cursors.WaitCursor
        int_Para_DB = 1
        If int_SelPara = 4 Then Call Para_Namen_Aufbau()
        If int_SelPara = 5 Then Call Para_Vornamen_Aufbau()
        If int_SelPara = 7 Then
            int_Merk_Orte1 = 1
            Call Para_Orte_Aufbau()
            int_Merk_Orte1 = 0
        End If
        'If int_SelPara = 6 Then Call Para_Beruf_Aufbau()
        If int_SelPara = 8 Then Call Para_Tod_Aufbau()
        Me.Cursor = Cursors.Default
    End Sub

    REM **************************************************************
    REM *  Steuerung bei Grid-Auswahl                                *
    REM **************************************************************
    Private Sub Dgv_201_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Datum.CellClick
        'Call ButtonSicht(True)
        int_Para_DB = 2
        int_ID = Me.dgv_Datum.CurrentRow.Cells(0).Value
        Me.lbl_201_Lfdnr1.Text = Me.dgv_Datum.CurrentRow.Cells(1).Value
        Me.tx_201_Z1.Text = Me.dgv_Datum.CurrentRow.Cells(2).Value
        Call Para_Neu(1)
    End Sub
    Private Sub Dgv_203_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Konf.CellClick
        'Call ButtonSicht(True)
        int_Para_DB = 2
        int_ID = Me.dgv_Konf.CurrentRow.Cells(0).Value
        Me.lbl_201_Lfdnr1.Text = Me.dgv_Konf.CurrentRow.Cells(1).Value
        Me.tx_201_Z1.Text = Me.dgv_Konf.CurrentRow.Cells(2).Value
        Me.tx_201_Z2.Text = Me.dgv_Konf.CurrentRow.Cells(3).Value
        Call Para_Neu(2)
    End Sub

    Private Sub Dgv_204_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Name.CellClick
        'Call ButtonSicht(True)
        int_Para_DB = 2
        Call Para_Namen_Update()
    End Sub

    Private Sub Dgv_206_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Vorname.CellClick
        int_Para_DB = 2
        Call ButtonSicht(True)
        Call Para_Vornamen_Update()
    End Sub

    Private Sub Dgv_207_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Tod.CellClick
        Call ButtonSicht(True)
        int_Para_DB = 2
        Call Para_Tod_Update()
    End Sub

    Private Sub Dgv_208_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Beruf.CellClick
        Call ButtonSicht(True)
        int_Para_DB = 2
        Call Para_Beruf_Update()
    End Sub

    REM *---------------------------------------------------------*
    REM *  Label und Texte für Einzeldaten (un)sichtbar stellen   *
    REM *---------------------------------------------------------*
    Private Sub ButtonSicht(ByVal b_Vis As Boolean)
        Me.lbl_201_LfdNr.Visible = b_Vis
        Me.lbl_201_Z1.Visible = b_Vis
        Me.lbl_201_Z2.Visible = b_Vis
        Me.lbl_201_Z3.Visible = b_Vis
    End Sub

    REM *--------------------------------------------------------*
    REM *  Menübersicht ein- bzw. ausblenden                     *
    REM *--------------------------------------------------------*
    Private Sub MenueButtonSicht(ByVal b_Menue As Boolean)
        Me.bt_201_Cancel.Visible = b_Menue
        Me.bt_201_kpl.Visible = b_Menue
        Me.bt_201_Neu.Visible = b_Menue
        Me.bt_201_OK.Visible = b_Menue
        Me.bt_201_Return.Visible = b_Menue
    End Sub

    REM *--------------------------------------------------------*
    REM *  einzelne Tabs anzeigen                                *
    REM *--------------------------------------------------------*
    Private Sub Para_Zeigen()
        'Call ButtonSicht(False)
        'Call MenueButtonSicht(False)
        Me.tb_Para.SelectTab(int_SelPara)
        Me.tb_Para.Show()
    End Sub

    Private Sub Tx_DokPfad_TextChanged(sender As Object, e As EventArgs) Handles tx_DokPfad.TextChanged

    End Sub

    Private Sub Bt_201_Return_Click(sender As Object, e As EventArgs) Handles bt_201_Return.Click
        Me.Text = "Parameterdaten"
        int_SelPara = 0
        Me.tb_Para.SelectTab(int_SelPara)
        'Call MenueButtonSicht(True)
        Me.bt_201_Neu.Visible = False
        Me.bt_201_kpl.Visible = False
        Me.tb_Para.Show()
    End Sub

End Class