﻿Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.Cls_03_DB_Person_Update
Imports NM_Ahnen.Cls_90_Mask_301

Public Class NM_Ahnen_PersK

    Private Sub NM_Ahnen_PersK_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call Mask_Pos_301()
        Call Tab_Pos_PersK()
        Call DB_Tab_High("t01_ID", "t01_Person")
        dbl_Max_ID += 1
        Me.tx_301_ID.Text = dbl_Max_ID.ToString
    End Sub

    REM **************************************************************
    REM *  Erfassung mit OK bestätigt                                *
    REM **************************************************************
    Private Sub Bt_301_OK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_301_OK.Click
        Call Plausi_PersK()
        If int_Merk_Plausi = 1 Then
            Exit Sub
        End If
        Call Person_Aufgabe_Insert()
        Call Person_T01_Aufgabe_Insert()
        dbl_Sel_ID = dbl_Max_ID
        If int_Merk_STyp = 2 Then Call Person_Vater_Update()
        If int_Merk_STyp = 3 Then Call Person_Mutter_Update()
        If int_Merk_STyp = 4 Then Call Person_Paten_Insert()
        If int_Merk_STyp = 5 Then Call Person_Ehe_Insert()
        If int_Merk_STyp = 6 Then int_TZ_Typ = 8 : Call Person_Trauzeugen_Insert()
        If int_Merk_STyp = 7 Then int_TZ_Typ = 9 : Call Person_Trauzeugen_Insert()
        Call Person_Read_01()
        Me.Close()
        NM_Ahnen_Search.Close()
    End Sub

    Private Sub Tab_Pos_PersK()
        With Me
            .tx_301_Name.TabIndex = 0
            .tx_301_GebName.TabIndex = 1
            .tx_301_Vorname.TabIndex = 2
            .tx_301_Geschl.TabIndex = 3
            .tx_301_GDat_TT.TabIndex = 4
            .tx_301_GDat_MM.TabIndex = 5
            .tx_301_GDat_JJ.TabIndex = 6
        End With
    End Sub

    Private Sub Plausi_PersK()
        int_Merk_Plausi = 0
        With Me
            .tx_301_Geschl.Text = .tx_301_Geschl.Text.ToUpper

            If .tx_301_Geschl.Text <> "M" And .tx_301_Geschl.Text <> "F" And .tx_301_Geschl.Text <> "U" Then
                int_Merk_Plausi = 1
                MsgBox("Geschlechtsangabe falsch - nur M, F, oder U erlaubt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
        End With
    End Sub


    Private Sub Bt_301_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_301_Cancel.Click
        Me.Close()
    End Sub
    Private Sub Tx_301_Name_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_301_Name.TextChanged
        If Len(Me.tx_301_Name.Text) = 100 Then
            Me.tx_301_GebName.Focus()
        End If
    End Sub

    Private Sub Tx_301_GebName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_301_GebName.TextChanged
        If Len(Me.tx_301_GebName.Text) = 100 Then
            Me.tx_301_Vorname.Focus()
        End If
    End Sub

    Private Sub Tx_301_Vorname_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_301_Vorname.TextChanged
        If Len(Me.tx_301_Name.Text) = 100 Then
            Me.tx_301_Geschl.Focus()
        End If
    End Sub

    Private Sub Tx_301_Geschl_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_301_Geschl.TextChanged
        If Len(Me.tx_301_Name.Text) = 1 Then
            Me.tx_301_GDat_TT.Focus()
        End If
    End Sub

    Private Sub Tx_301_GDat_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_301_GDat_TT.TextChanged
        If Len(Me.tx_301_GDat_TT.Text) = 2 Then
            Me.tx_301_GDat_MM.Focus()
        End If
    End Sub

    Private Sub Tx_301_GDat_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_301_GDat_MM.TextChanged
        If Len(Me.tx_301_GDat_MM.Text) = 2 Then
            Me.tx_301_GDat_JJ.Focus()
        End If
    End Sub
    Private Sub Tx_301_GDat_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_301_GDat_JJ.TextChanged
        If Len(Me.tx_301_GDat_JJ.Text) = 4 Then
            Me.tx_301_Name.Focus()
        End If
    End Sub

End Class