﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Data.SqlClient
Imports NM_Ahnen.Cls_00_Def
Imports NM_Ahnen.Cls_02_DB
Imports NM_Ahnen.Cls_03_DB_Bilder
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_50_Daten_14
Imports NM_Ahnen.Cls_50_Daten_15

Class Cls_02_DB_Person_Read
    REM **************************************************************
    REM *  Laden der Personendaten (Tabelle t01)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_01()
        int_Merk_Neu = 0
        int_Merk_Tab_Anschr = 0
        int_Merk_Tab_Beerd = 0
        int_Merk_Tab_Beruf = 0
        int_Merk_Tab_Ehe = 0
        int_Merk_Tab_Grund = 0
        int_Merk_Tab_Paten = 0
        int_Merk_Tab_Taufe = 0
        int_Merk_Tab_Text = 0
        Call Mask_Clear()
        Call Mask_Clear_Ehe()
        Call Change_Button(myNein)
        Call Change_Info_10(True)
        If dbl_ID <> lng_ID(int_Zeig_Pers) Then Call Ermitteln_TabPos()
        Call Person_Read_t01_Basis()
        REM *  Dazulesen der Kommentarnummern                        *
        Call Person_Komm_Nr()
        REM *  Dazulesen der Eltern                                  *
        Call Person_Read_Vater()
        Call Person_Read_Mutter()
        REM *  Dazulesen der Tauftabelle                             *
        Call Person_Read_t02()
        REM *  Dazulesen der Beerdigungstabelle                      *
        Call Person_Read_t03()
        REM *  Dazulesen der Ehetabelle                              *
        Call Person_Read_t04()
        Call Person_Read_EheDaten()
        REM *  Dazulesen der Geschwister                             *
        Call Person_Read_t05_Geschwister()
        REM *  Dazulesen der Kinder                                  *
        Call Person_Read_t05_Kinder()
        REM *  Dazulesen der Geschwister                             *
        Call Person_Read_t05_Paten()
        REM *  Dazulesen der Geschwister                             *
        Call Person_Read_t05_Paten1()
        REM *  Dazulesen der Kinder                                  *
        Call Person_Read_t05_Zeugen()
        REM *  Dazulesen der Kinder                                  *
        Call Person_Read_t05_Zeugen1()
        REM *  Dazulesen der Kinder                                  *
        Call Person_Read_t05_Zeugen2()
        REM *  Dazulesen der Adressdaten                             *
        Call Person_Read_Adresse()
        REM *  Dazulesen der Berufe                                  *
        Call Person_Read_Beruf()
        REM *  Dazulesen der Berufe                                  *
        Call Person_Read_t12()
        REM *  Dazulesen der Quellen                                 *
        Call Person_Read_t13()
        REM *  Alle gelesenen Datein in Output-Felder übertragen     *
        Call Mask_Out_Person()
        REM *  Wenn die Bildanzeige aktiv, Bilddatei dazulesen       *
        With NM_Ahnen
            If .rb_01_Pic.Checked = True Then
                .web_Brs1.Visible = False
                '.web_Brs1.Dispose()
                .pbx_01_01.Image = Nothing
                .pbx_01_01.BackColor = Color.GhostWhite
                Call Tab_Bilder()
                If int_PicDir = 0 Then Call Tab_Bilder()
            End If
        End With
        Call Change_Button(myNein)
    End Sub
    REM **************************************************************
    REM *  Ermitteln der aktuellen Position in ID-Tab                *
    REM **************************************************************
    Public Shared Sub Ermitteln_TabPos()
        Dim i88 As Integer
        For i88 = 0 To dbl_Max
            If dbl_ID = lng_ID(i88) Then
                int_Zeig_Pers = i88
                Exit For
            End If
        Next
    End Sub

    REM **************************************************************
    REM *  Lesen der Personenbasisdaten = Tabelle t01                *
    REM **************************************************************
    Public Shared Sub Person_Read_t01_Basis()
        Dim reader As OleDbDataReader
        If p_int_ID = dbl_ID Then Exit Sub
        str_Where = " where t01_ID = " + dbl_ID.ToString
        mySelect.CommandText = "select * from t01_Person" & str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    myNull = IsDBNull(reader.Item("t01_Id"))
                    If myNull = False Then p_int_ID = reader.Item("t01_Id")
                    myNull = IsDBNull(reader.Item("t01_Name"))
                    If myNull = False Then p_str_Name = reader.Item("t01_Name")
                    myNull = IsDBNull(reader.Item("t01_GebName"))
                    If myNull = False Then p_str_GebName = reader.Item("t01_GebName")
                    myNull = IsDBNull(reader.Item("t01_NameZ"))
                    If myNull = False Then p_str_NameZ = reader.Item("t01_NameZ")
                    myNull = IsDBNull(reader.Item("t01_Vorname"))
                    If myNull = False Then p_str_Vorname = reader.Item("t01_Vorname")
                    myNull = IsDBNull(reader.Item("t01_Rufname"))
                    If myNull = False Then p_str_Rufname = reader.Item("t01_Rufname")
                    myNull = IsDBNull(reader.Item("t01_SpitzN"))
                    If myNull = False Then p_str_SpitzN = reader.Item("t01_SpitzN")
                    myNull = IsDBNull(reader.Item("t01_Titel"))
                    If myNull = False Then p_str_Titel = reader.Item("t01_Titel")
                    myNull = IsDBNull(reader.Item("t01_Geschl"))
                    If myNull = False Then p_str_Geschl = reader.Item("t01_Geschl")
                    myNull = IsDBNull(reader.Item("t01_Vater"))
                    If myNull = False Then p_int_Vater = reader.Item("t01_Vater")
                    myNull = IsDBNull(reader.Item("t01_Mutter"))
                    If myNull = False Then p_int_Mutter = reader.Item("t01_Mutter")
                    myNull = IsDBNull(reader.Item("t01_GDat_TT"))
                    If myNull = False Then p_str_GDat_TT = reader.Item("t01_GDat_TT")
                    int_Old1_T = Val(p_str_GDat_TT)
                    myNull = IsDBNull(reader.Item("t01_GDat_MM"))
                    If myNull = False Then p_str_GDat_MM = reader.Item("t01_GDat_MM")
                    int_Old1_M = Val(p_str_GDat_MM)
                    myNull = IsDBNull(reader.Item("t01_GDat_JJ"))
                    If myNull = False Then p_str_GDat_JJ = reader.Item("t01_GDat_JJ")
                    int_Old1_J = Val(p_str_GDat_JJ)
                    myNull = IsDBNull(reader.Item("t01_GDat_Art"))
                    If myNull = False Then p_int_GArt = reader.Item("t01_GDat_Art")
                    myNull = IsDBNull(reader.Item("t01_GOrt"))
                    If myNull = False Then p_str_GOrt = reader.Item("t01_GOrt")
                    myNull = IsDBNull(reader.Item("t01_SDat_TT"))
                    If myNull = False Then p_str_SDat_TT = reader.Item("t01_SDat_TT")
                    int_Old2_T = Val(p_str_SDat_TT)
                    myNull = IsDBNull(reader.Item("t01_SDat_MM"))
                    If myNull = False Then p_str_SDat_MM = reader.Item("t01_SDat_MM")
                    int_Old2_M = Val(p_str_SDat_MM)
                    myNull = IsDBNull(reader.Item("t01_SDat_JJ"))
                    If myNull = False Then p_str_SDat_JJ = reader.Item("t01_SDat_JJ")
                    int_Old2_J = Val(p_str_SDat_JJ)
                    myNull = IsDBNull(reader.Item("t01_SDat_Art"))
                    If myNull = False Then p_int_SArt = reader.Item("t01_SDat_Art")
                    myNull = IsDBNull(reader.Item("t01_SOrt"))
                    If myNull = False Then p_str_SOrt = reader.Item("t01_SOrt")
                    p_str_GDat = p_str_GDat_JJ & p_str_GDat_MM & p_str_GDat_TT
                    p_str_GDat = Val(p_str_GDat)
                    p_str_SDat = p_str_SDat_JJ & p_str_SDat_MM & p_str_SDat_TT
                    p_str_SDat = Val(p_str_SDat)
                    p_int_Vater_Save = p_int_Vater
                    p_int_Mutter_Save = p_int_Mutter
                    int_Merk_Tab_Grund = 1
                    If dbl_ID = dbl_First_ID Then
                        NM_Ahnen.bt_00_First.Enabled = False
                    Else
                        NM_Ahnen.bt_00_First.Enabled = True
                    End If
                    If dbl_ID = dbl_Last_ID Then
                        NM_Ahnen.bt_00_Last.Enabled = False
                    Else
                        NM_Ahnen.bt_00_Last.Enabled = True
                    End If
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Lesen der Kommentar-Nummern-Tabelle                       *
    REM **************************************************************
    Public Shared Sub Person_Komm_Nr()
        Dim reader As OleDbDataReader
        str_Where = " where t10_ID = " + dbl_ID.ToString
        mySelect.CommandText = "select * from t10_KommNr" & str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    REM *------------------------------------------------*
                    REM *  Kommentare für Grunddaten                     *
                    REM *------------------------------------------------*
                    myNull = IsDBNull(reader.Item("t10_Komm01"))
                    If myNull = False Then p_str_Komm_Name = reader.Item("t10_Komm01")
                    myNull = IsDBNull(reader.Item("t10_Komm02"))
                    If myNull = False Then p_str_Komm_NameZ = reader.Item("t10_Komm02")
                    myNull = IsDBNull(reader.Item("t10_Komm03"))
                    If myNull = False Then p_str_Komm_GebName = reader.Item("t10_Komm03")
                    myNull = IsDBNull(reader.Item("t10_Komm04"))
                    If myNull = False Then p_str_Komm_Vorname = reader.Item("t10_Komm04")
                    myNull = IsDBNull(reader.Item("t10_Komm05"))
                    If myNull = False Then p_str_Komm_Rufname = reader.Item("t10_Komm05")
                    myNull = IsDBNull(reader.Item("t10_Komm06"))
                    If myNull = False Then p_str_Komm_SpitzN = reader.Item("t10_Komm06")
                    myNull = IsDBNull(reader.Item("t10_Komm07"))
                    If myNull = False Then p_str_Komm_Titel = reader.Item("t10_Komm07")
                    myNull = IsDBNull(reader.Item("t10_Komm08"))
                    If myNull = False Then p_str_Komm_Geb1 = reader.Item("t10_Komm08")
                    myNull = IsDBNull(reader.Item("t10_Komm09"))
                    If myNull = False Then p_str_Komm_Geb2 = reader.Item("t10_Komm09")
                    myNull = IsDBNull(reader.Item("t10_Komm10"))
                    If myNull = False Then p_str_Komm_Geb1 = reader.Item("t10_Komm10")
                    myNull = IsDBNull(reader.Item("t10_Komm11"))
                    If myNull = False Then p_str_Komm_Geb2 = reader.Item("t10_Komm11")
                    myNull = IsDBNull(reader.Item("t10_Komm12"))
                    If myNull = False Then p_str_Komm_SDat = reader.Item("t10_Komm12")
                    myNull = IsDBNull(reader.Item("t10_Komm13"))
                    If myNull = False Then p_str_Komm_SOrt = reader.Item("t10_Komm13")
                    myNull = IsDBNull(reader.Item("t10_Komm14"))
                    If myNull = False Then p_str_Komm_Sterb1 = reader.Item("t10_Komm14")
                    myNull = IsDBNull(reader.Item("t10_Komm15"))
                    If myNull = False Then p_str_Komm_Sterb2 = reader.Item("t10_Komm15")
                    REM *------------------------------------------------*
                    REM *  Kommentare für Taufdaten                      *
                    REM *------------------------------------------------*
                    myNull = IsDBNull(reader.Item("t10_Komm21"))
                    If myNull = False Then p_str_Komm_TDat = reader.Item("t10_Komm21")
                    myNull = IsDBNull(reader.Item("t10_Komm22"))
                    If myNull = False Then p_str_Komm_TOrt = reader.Item("t10_Komm22")
                    myNull = IsDBNull(reader.Item("t10_Komm23"))
                    If myNull = False Then p_str_Komm_TKirch = reader.Item("t10_Komm23")
                    myNull = IsDBNull(reader.Item("t10_Komm24"))
                    If myNull = False Then p_str_Komm_TKonf = reader.Item("t10_Komm24")
                    myNull = IsDBNull(reader.Item("t10_Komm25"))
                    If myNull = False Then p_str_Komm_TPriester = reader.Item("t10_Komm25")
                    myNull = IsDBNull(reader.Item("t10_Komm26"))
                    If myNull = False Then p_str_Komm_TUrk = reader.Item("t10_Komm26")
                    REM *------------------------------------------------*
                    REM *  Kommentare für Firmdaten                      *
                    REM *------------------------------------------------*
                    myNull = IsDBNull(reader.Item("t10_Komm31"))
                    If myNull = False Then p_str_Komm_FDat = reader.Item("t10_Komm31")
                    myNull = IsDBNull(reader.Item("t10_Komm32"))
                    If myNull = False Then p_str_Komm_FOrt = reader.Item("t10_Komm32")
                    myNull = IsDBNull(reader.Item("t10_Komm33"))
                    If myNull = False Then p_str_Komm_FKirche = reader.Item("t10_Komm33")
                    myNull = IsDBNull(reader.Item("t10_Komm34"))
                    If myNull = False Then p_str_Komm_FPriester = reader.Item("t10_Komm34")
                    myNull = IsDBNull(reader.Item("t10_Komm35"))
                    If myNull = False Then p_str_Komm_FUrk = reader.Item("t10_Komm35")
                    REM *------------------------------------------------*
                    REM *  Kommentare für Beerdigungsdaten               *
                    REM *------------------------------------------------*
                    myNull = IsDBNull(reader.Item("t10_Komm41"))
                    If myNull = False Then p_str_Komm_BDat = reader.Item("t10_Komm41")
                    myNull = IsDBNull(reader.Item("t10_Komm42"))
                    If myNull = False Then p_str_Komm_BOrt = reader.Item("t10_Komm42")
                    myNull = IsDBNull(reader.Item("t10_Komm43"))
                    If myNull = False Then p_str_Komm_BArt = reader.Item("t10_Komm43")
                    myNull = IsDBNull(reader.Item("t10_Komm44"))
                    If myNull = False Then p_str_Komm_BPriester = reader.Item("t10_Komm44")
                    myNull = IsDBNull(reader.Item("t10_Komm45"))
                    If myNull = False Then p_str_Komm_Friedhof = reader.Item("t10_Komm45")
                    myNull = IsDBNull(reader.Item("t10_Komm46"))
                    If myNull = False Then p_str_Komm_Grablage = reader.Item("t10_Komm46")
                    myNull = IsDBNull(reader.Item("t10_Komm47"))
                    If myNull = False Then p_str_Komm_TodUrsache = reader.Item("t10_Komm47")
                    myNull = IsDBNull(reader.Item("t10_Komm48"))
                    If myNull = False Then p_str_Komm_BUrk1 = reader.Item("t10_Komm48")
                    myNull = IsDBNull(reader.Item("t10_Komm49"))
                    If myNull = False Then p_str_Komm_BUrk2 = reader.Item("t10_Komm49")

                    myNull = IsDBNull(reader.Item("t10_Komm51"))
                    If myNull = False Then p_str_Komm_EDat1 = reader.Item("t10_Komm51")
                    myNull = IsDBNull(reader.Item("t10_Komm52"))
                    If myNull = False Then p_str_Komm_EOrt1 = reader.Item("t10_Komm52")
                    myNull = IsDBNull(reader.Item("t10_Komm53"))
                    If myNull = False Then p_str_Komm_EBeamt = reader.Item("t10_Komm53")
                    myNull = IsDBNull(reader.Item("t10_Komm54"))
                    If myNull = False Then p_str_Komm_EUrk1 = reader.Item("t10_Komm54")
                    myNull = IsDBNull(reader.Item("t10_Komm55"))
                    If myNull = False Then p_str_Komm_ETZ1 = reader.Item("t10_Komm55")
                    myNull = IsDBNull(reader.Item("t10_Komm56"))
                    If myNull = False Then p_str_Komm_EDat2 = reader.Item("t10_Komm56")
                    myNull = IsDBNull(reader.Item("t10_Komm57"))
                    If myNull = False Then p_str_Komm_EOrt2 = reader.Item("t10_Komm57")
                    myNull = IsDBNull(reader.Item("t10_Komm58"))
                    If myNull = False Then p_str_Komm_EKirche = reader.Item("t10_Komm58")
                    myNull = IsDBNull(reader.Item("t10_Komm59"))
                    If myNull = False Then p_str_Komm_EPriester = reader.Item("t10_Komm59")
                    myNull = IsDBNull(reader.Item("t10_Komm60"))
                    If myNull = False Then p_str_Komm_EUrk2 = reader.Item("t10_Komm60")
                    myNull = IsDBNull(reader.Item("t10_Komm61"))
                    If myNull = False Then p_str_Komm_ETZ2 = reader.Item("t10_Komm61")
                    myNull = IsDBNull(reader.Item("t10_Komm62"))
                    If myNull = False Then p_str_Komm_EDat3 = reader.Item("t10_Komm62")
                    myNull = IsDBNull(reader.Item("t10_Komm63"))
                    If myNull = False Then p_str_Komm_EUrk3 = reader.Item("t10_Komm53")

                Loop
            End If
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten des Vaters                        *
    REM **************************************************************
    Public Shared Sub Person_Read_Vater()
        If p_int_Vater > 0 Then
            lng_Pers = p_int_Vater
            Call Person_Read_Rolle()
            v_lng_ID = p_int_Vater
            v_str_Name = r_str_Name
            v_str_GebName = r_str_GebName
            v_str_Vorname = r_str_Vorname
            v_str_GDat_JJ = r_str_GDat_JJ
            v_str_GDat_MM = r_str_GDat_MM
            v_str_GDat_TT = r_str_GDat_TT
            v_str_SDat_JJ = r_str_SDat_JJ
            v_str_SDat_MM = r_str_SDat_MM
            v_str_SDat_TT = r_str_SDat_TT
            v_str_GOrt = r_str_GOrt
            v_str_SOrt = r_str_SOrt
        Else
            v_lng_ID = 0
            v_str_Name = ""
            v_str_GebName = ""
            v_str_Vorname = ""
            v_str_GDat_JJ = ""
            v_str_GDat_MM = ""
            v_str_GDat_TT = ""
            v_str_SDat_JJ = ""
            v_str_SDat_MM = ""
            v_str_SDat_TT = ""
            v_str_GOrt = ""
            v_str_SOrt = ""
        End If
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten der Mutter                        *
    REM **************************************************************
    Public Shared Sub Person_Read_Mutter()
        If p_int_Mutter > 0 Then
            lng_Pers = p_int_Mutter
            Call Person_Read_Rolle()
            m_lng_ID = p_int_Mutter
            m_str_Name = r_str_Name
            m_str_GebName = r_str_GebName
            m_str_Vorname = r_str_Vorname
            m_str_GDat_JJ = r_str_GDat_JJ
            m_str_GDat_MM = r_str_GDat_MM
            m_str_GDat_TT = r_str_GDat_TT
            m_str_SDat_JJ = r_str_SDat_JJ
            m_str_SDat_MM = r_str_SDat_MM
            m_str_SDat_TT = r_str_SDat_TT
            m_str_GOrt = r_str_GOrt
            m_str_SOrt = r_str_SOrt
        Else
            m_lng_ID = 0
            m_str_Name = ""
            m_str_GebName = ""
            m_str_Vorname = ""
            m_str_GDat_JJ = ""
            m_str_GDat_MM = ""
            m_str_GDat_TT = ""
            m_str_SDat_JJ = ""
            m_str_SDat_MM = ""
            m_str_SDat_TT = ""
            m_str_GOrt = ""
            m_str_SOrt = ""
        End If
    End Sub


    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t02)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_t02()
        Dim reader As OleDbDataReader
        str_Where = " where t02_ID = " + dbl_ID.ToString
        mySelect.CommandText = "select * from t02_Taufe" & str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    myNull = IsDBNull(reader.Item("t02_Konf"))
                    If myNull = False Then p_str_Konf = reader.Item("t02_Konf")
                    myNull = IsDBNull(reader.Item("t02_TDat_TT"))
                    If myNull = False Then p_str_TDat_TT = reader.Item("t02_TDat_TT")
                    myNull = IsDBNull(reader.Item("t02_TDat_MM"))
                    If myNull = False Then p_str_TDat_MM = reader.Item("t02_TDat_MM")
                    myNull = IsDBNull(reader.Item("t02_TDat_JJ"))
                    If myNull = False Then p_str_TDat_JJ = reader.Item("t02_TDat_JJ")
                    myNull = IsDBNull(reader.Item("t02_TDat_Art"))
                    If myNull = False Then p_int_TDat_Art = reader.Item("t02_TDat_Art")
                    myNull = IsDBNull(reader.Item("t02_TOrt"))
                    If myNull = False Then p_str_TOrt = reader.Item("t02_TOrt")
                    myNull = IsDBNull(reader.Item("t02_TKirche"))
                    If myNull = False Then p_str_TKirche = reader.Item("t02_TKirche")
                    myNull = IsDBNull(reader.Item("t02_TPriester"))
                    If myNull = False Then p_str_TPriester = reader.Item("t02_TPriester")
                    myNull = IsDBNull(reader.Item("t02_FDat_TT"))
                    If myNull = False Then p_str_FDat_TT = reader.Item("t02_FDat_TT")
                    myNull = IsDBNull(reader.Item("t02_FDat_MM"))
                    If myNull = False Then p_str_FDat_MM = reader.Item("t02_FDat_MM")
                    myNull = IsDBNull(reader.Item("t02_FDat_JJ"))
                    If myNull = False Then p_str_FDat_JJ = reader.Item("t02_FDat_JJ")
                    myNull = IsDBNull(reader.Item("t02_FDat_Art"))
                    If myNull = False Then p_int_FDat_Art = reader.Item("t02_FDat_Art")
                    myNull = IsDBNull(reader.Item("t02_FOrt"))
                    If myNull = False Then p_str_FOrt = reader.Item("t02_FOrt")
                    myNull = IsDBNull(reader.Item("t02_FKirche"))
                    If myNull = False Then p_str_FKirche = reader.Item("t02_FKirche")
                    myNull = IsDBNull(reader.Item("t02_FPriester"))
                    If myNull = False Then p_str_FPriester = reader.Item("t02_FPriester")
                    myNull = IsDBNull(reader.Item("t02_Bemerk"))
                    If myNull = False Then p_str_TBemerk = reader.Item("t02_Bemerk")
                    int_Merk_Tab_Taufe = 1
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t03)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_t03()
        Dim reader As OleDbDataReader
        str_Where = " where t03_ID = " + dbl_ID.ToString
        mySelect.CommandText = "select * from t03_Beerd" & str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    myNull = IsDBNull(reader.Item("t03_BDat_TT"))
                    If myNull = False Then p_str_BDat_TT = reader.Item("t03_BDat_TT")
                    myNull = IsDBNull(reader.Item("t03_BDat_MM"))
                    If myNull = False Then p_str_BDat_MM = reader.Item("t03_BDat_MM")
                    myNull = IsDBNull(reader.Item("t03_BDat_JJ"))
                    If myNull = False Then p_str_BDat_JJ = reader.Item("t03_BDat_JJ")
                    myNull = IsDBNull(reader.Item("t03_BDat_Art"))
                    If myNull = False Then p_int_BDat_Art = reader.Item("t03_BDat_Art")
                    myNull = IsDBNull(reader.Item("t03_BOrt"))
                    If myNull = False Then p_str_BOrt = reader.Item("t03_BOrt")
                    myNull = IsDBNull(reader.Item("t03_BArt"))
                    If myNull = False Then p_str_BArt = reader.Item("t03_BArt")
                    myNull = IsDBNull(reader.Item("t03_BPriester"))
                    If myNull = False Then p_str_BPriester = reader.Item("t03_BPriester")
                    myNull = IsDBNull(reader.Item("t03_Friedhof"))
                    If myNull = False Then p_str_Friedhof = reader.Item("t03_Friedhof")
                    myNull = IsDBNull(reader.Item("t03_Grablage"))
                    If myNull = False Then p_str_Grablage = reader.Item("t03_Grablage")
                    myNull = IsDBNull(reader.Item("t03_Tod_Ursache"))
                    If myNull = False Then p_str_TodUrsache = reader.Item("t03_Tod_Ursache")
                    myNull = IsDBNull(reader.Item("t03_Bemerk"))
                    If myNull = False Then p_str_BBemerk = reader.Item("t03_Bemerk")
                    int_Merk_Tab_Beerd = 1
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t04) für GEDCOM-Export   *
    REM **************************************************************
    Public Shared Sub Person_Read_t04_Gedcom()
        Dim int_k99 As Double
        Dim int_k88 As Double
        Dim reader As OleDbDataReader
        Call DB_Tab_High("t04_ID", "t04_Ehe")
        dbl_Max_T04 = dbl_Max_ID / 2
        ReDim Ged_Ehe(dbl_Max_T04)
        ReDim Ged_P1(dbl_Max_T04)
        ReDim Ged_P2(dbl_Max_T04)

        For int_k99 = 0 To dbl_Max_T04
            Ged_Ehe(int_k99) = 0
            Ged_P1(int_k99) = 0
            Ged_P2(int_k99) = 0
        Next
        mySelect.CommandText = "select * from t04_Ehe"
        ' str_Where = " where t04_ID = " + int_k99.ToString
        reader = mySelect.ExecuteReader
        Do While reader.Read
            int_k88 = reader.Item("t04_FK_ID")
            If int_k88 <> int_k99 Then
                Ged_Ehe(int_k88) = int_k88
                Ged_P1(int_k88) = reader.Item("t04_Partner1")
                Ged_P2(int_k88) = reader.Item("t04_Partner2")
                int_k99 = int_k88
            End If
        Loop
        reader.Close()
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t04)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_t04()
        Dim reader As OleDbDataReader
        mySelect.CommandText = "select count(*) from t04_Ehe"
        str_Where = " where t04_Partner1 = " + p_int_ID.ToString
        int_Anz = GetNumberOfRecordsTyp(con, "t04_Ehe", str_Where)
        int_Ehe = -1

        If int_Anz > 0 Then
            ReDim te_lng_ID(int_Anz)
            ReDim te_str_GDat_JJ(int_Anz)
            ReDim te_str_GDat_MM(int_Anz)
            ReDim te_str_GDat_TT(int_Anz)
            ReDim te_str_GOrt(int_Anz)
            ReDim te_str_SDat_JJ(int_Anz)
            ReDim te_str_SDat_MM(int_Anz)
            ReDim te_str_SDat_TT(int_Anz)
            ReDim te_str_SOrt(int_Anz)
            ReDim te_str_Name(int_Anz)
            ReDim te_str_GebName(int_Anz)
            ReDim te_str_Vorname(int_Anz)
            ReDim te_str_Geschl(int_Anz)
            ReDim lng_Ehe_ID(int_Anz)
        Else
            Exit Sub
        End If
        str_Where = " where t04_Partner1 = " + p_int_ID.ToString
        mySelect.CommandText = "select * from t04_Ehe" + str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    int_Ehe += 1
                    lng_Ehe_ID(int_Ehe) = reader.Item("t04_Partner2")
                Loop
                int_Merk_Tab_Ehe = 1
            End If
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        For int_l01 = 0 To int_Ehe
            int_Pos_E = int_l01
            p_int_Ehe = lng_Ehe_ID(int_l01)
            lng_Pers = p_int_Ehe
            Call Person_Read_Rolle()
            te_lng_ID(int_Pos_E) = p_int_Ehe
            te_str_Name(int_Pos_E) = r_str_Name
            te_str_GebName(int_Pos_E) = r_str_GebName
            te_str_Vorname(int_Pos_E) = r_str_Vorname
            te_str_GDat_TT(int_Pos_E) = r_str_GDat_TT
            te_str_GDat_MM(int_Pos_E) = r_str_GDat_MM
            te_str_GDat_JJ(int_Pos_E) = r_str_GDat_JJ
            te_str_GOrt(int_Pos_E) = r_str_GOrt
            te_str_SDat_TT(int_Pos_E) = r_str_SDat_TT
            te_str_SDat_MM(int_Pos_E) = r_str_SDat_MM
            te_str_SDat_JJ(int_Pos_E) = r_str_SDat_JJ
            te_str_SOrt(int_Pos_E) = r_str_SOrt
            te_str_Geschl(int_Pos_E) = r_str_Geschl
        Next
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t041)                    *
    REM **************************************************************
    Public Shared Sub Person_Read_EheDaten()
        Dim reader As OleDbDataReader
        str_Where = " where t04_Partner1 = " + p_int_ID.ToString + " and t04_Partner2 = " + p_int_Ehe41.ToString
        mySelect.CommandText = "select * from t04_Ehe" + str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    dbl_Ehe41 = reader.Item("t04_FK_ID")
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        int_Gedcom = 0
        Call Person_Read_t132()

        If dbl_Ehe41 > 0 Then
            dbl_T41_ID = dbl_Ehe41
            str_Where = " where t041_ID = " + dbl_Ehe41.ToString
            mySelect.CommandText = "select * from t041_EheDaten" + str_Where
            Try
                reader = mySelect.ExecuteReader
                If reader.HasRows Then
                    Do While reader.Read()
                        int_Gedcom = 1
                        myNull = IsDBNull(reader.Item("t041_Dat1_TT"))
                        If myNull = False Then p_str_EDat1_TT = reader.Item("t041_Dat1_TT")
                        myNull = IsDBNull(reader.Item("t041_Dat1_MM"))
                        If myNull = False Then p_str_EDat1_MM = reader.Item("t041_Dat1_MM")
                        myNull = IsDBNull(reader.Item("t041_Dat1_JJ"))
                        If myNull = False Then p_str_EDat1_JJ = reader.Item("t041_Dat1_JJ")
                        myNull = IsDBNull(reader.Item("t041_Dat1_Art"))
                        If myNull = False Then p_int_EDat1_Art = reader.Item("t041_Dat1_Art")
                        myNull = IsDBNull(reader.Item("t041_Dat2_TT"))
                        If myNull = False Then p_str_EDat2_TT = reader.Item("t041_Dat2_TT")
                        myNull = IsDBNull(reader.Item("t041_Dat2_MM"))
                        If myNull = False Then p_str_EDat2_MM = reader.Item("t041_Dat2_MM")
                        myNull = IsDBNull(reader.Item("t041_Dat2_JJ"))
                        If myNull = False Then p_str_Edat2_JJ = reader.Item("t041_Dat2_JJ")
                        myNull = IsDBNull(reader.Item("t041_Dat2_Art"))
                        If myNull = False Then p_int_EDat2_Art = reader.Item("t041_Dat2_Art")
                        myNull = IsDBNull(reader.Item("t041_Dat3_TT"))
                        If myNull = False Then p_str_EDat3_TT = reader.Item("t041_Dat3_TT")
                        myNull = IsDBNull(reader.Item("t041_Dat3_MM"))
                        If myNull = False Then p_str_EDat3_MM = reader.Item("t041_Dat3_MM")
                        myNull = IsDBNull(reader.Item("t041_Dat3_JJ"))
                        If myNull = False Then p_str_EDat3_JJ = reader.Item("t041_Dat3_JJ")
                        myNull = IsDBNull(reader.Item("t041_Dat3_Art"))
                        If myNull = False Then p_int_EDat3_Art = reader.Item("t041_Dat3_Art")
                        myNull = IsDBNull(reader.Item("t041_Ort1"))
                        If myNull = False Then p_str_EOrt1 = reader.Item("t041_Ort1")
                        myNull = IsDBNull(reader.Item("t041_Ort2"))
                        If myNull = False Then p_str_EOrt2 = reader.Item("t041_Ort2")
                        myNull = IsDBNull(reader.Item("t041_Beamter"))
                        If myNull = False Then p_str_EBeamter = reader.Item("t041_Beamter")
                        myNull = IsDBNull(reader.Item("t041_Priester"))
                        If myNull = False Then p_str_EPriester = reader.Item("t041_Priester")
                        myNull = IsDBNull(reader.Item("t041_Kirche"))
                        If myNull = False Then p_str_EKirche = reader.Item("t041_Kirche")
                        myNull = IsDBNull(reader.Item("t041_Bemerkung"))
                        If myNull = False Then p_str_E_Bemerk = reader.Item("t041_Bemerkung")
                        int_Merk_Tab_Ehe = 1
                    Loop
                End If
                reader.Close()
            Catch ex As Exception
                'MsgBox(ex.Message)
            End Try
        End If
    End Sub

    REM **************************************************************
    REM *  Lesen der Textdaten (Tabelle t12)                         *
    REM **************************************************************
    Public Shared Sub Person_Read_t12()
        Dim reader As OleDbDataReader
        p_str_Memo = ""
        str_Where = " where t12_ID = " + dbl_ID.ToString
        mySelect.CommandText = "select * from t12_Text" & str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    myNull = IsDBNull(reader.Item("t12_Text"))
                    If myNull = False Then p_str_Memo = reader.Item("t12_Text")
                    int_Merk_Tab_Text = 1
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Lesen der Quellendatei (Tabelle t13)                      *
    REM **************************************************************
    Public Shared Sub Person_Read_t13()
        For iQ_Event = 1 To 8
            t13_Tab_ID(iQ_Event) = 0
            int_Event_OK(iQ_Event) = 0
            p_str_Quelle(iQ_Event) = ""
            Call Person_Read_t13_Einzel()
        Next
    End Sub
    Public Shared Sub Person_Read_t13_Einzel()
        Dim reader As OleDbDataReader
        str_Where = " where t13_ID_t01 = " + dbl_ID.ToString & " and t13_Typ = " & iQ_Event.ToString & " and t13_Art = 1"
        mySelect.CommandText = "select * from t13_Quelle" & str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    t13_Tab_ID(iQ_Event) = Val(reader.Item("t13_ID"))
                    myNull = IsDBNull(reader.Item("t13_Quelle"))
                    If myNull = False Then p_str_Quelle(iQ_Event) = reader.Item("t13_Quelle")
                    int_Event_OK(iQ_Event) = 1
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Lesen der Quellendatei (Tabelle t13)                      *
    REM **************************************************************
    Public Shared Sub Person_Read_t132()
        For iQ_Event = 9 To 11
            Call Person_Read_t132_Einzel()
        Next
    End Sub
    Public Shared Sub Person_Read_t132_Einzel()
        Dim reader As OleDbDataReader
        int_Event_OK(iQ_Event) = 0
        t13_Tab_ID(iQ_Event) = 0
        p_str_Quelle(iQ_Event) = ""
        str_Where = " where t13_ID_t01 = " + dbl_Ehe41.ToString & " and t13_Typ = " & iQ_Event.ToString & " and t13_Art = 2"
        mySelect.CommandText = "select * from t13_Quelle" & str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()

                    t13_Tab_ID(iQ_Event) = Val(reader.Item("t13_ID"))
                    myNull = IsDBNull(reader.Item("t13_Quelle"))
                    If myNull = False Then p_str_Quelle(iQ_Event) = reader.Item("t13_Quelle")
                    int_Event_OK(iQ_Event) = 1
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t05)                     *
    REM *  werden über ID von Vater und Mutter ermittelt             *
    REM **************************************************************
    Public Shared Sub Person_Read_t05_Geschwister()
        Dim int_Anz1 As Integer = 0
        Dim int_Anz2 As Integer = 0
        Dim int_Anz3 As Integer = 0
        Dim int_Anz4 As Integer = 0
        Dim int_Pers As Integer
        Dim reader As OleDbDataReader
        Dim int_Find As Integer
        int_Anz = 0
        int_Ges = -1
        If p_int_Vater > 0 Then
            mySelect.CommandText = "select count(*) from t05_Rolle"
            str_Where = " where t05_FK_t01 = " + p_int_Vater.ToString + " and t05_Typ = 3"
            int_Anz3 = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        End If
        If p_int_Mutter > 0 Then
            mySelect.CommandText = "select count(*) from t05_Rolle"
            str_Where = " where t05_FK_t01 = " + p_int_Mutter.ToString + " and t05_Typ = 3"
            int_Anz4 = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        End If
        int_Anz = int_Anz3 + int_Anz4
        If int_Anz > 0 Then
            ReDim tg_lng_ID(int_Anz)
            ReDim tg_str_GDat_JJ(int_Anz)
            ReDim tg_str_GDat_MM(int_Anz)
            ReDim tg_str_GDat_TT(int_Anz)
            ReDim tg_str_GOrt(int_Anz)
            ReDim tg_str_SDat_JJ(int_Anz)
            ReDim tg_str_SDat_MM(int_Anz)
            ReDim tg_str_SDat_TT(int_Anz)
            ReDim tg_str_SOrt(int_Anz)
            ReDim tg_str_Name(int_Anz)
            ReDim tg_str_GebName(int_Anz)
            ReDim tg_str_Vorname(int_Anz)
            ReDim tg_str_Geschl(int_Anz)
            ReDim tg_lng_IDV(int_Anz)
            ReDim tg_lng_IDM(int_Anz)
            ReDim lng_Ges_ID(int_Anz)
            ReDim int_Ges_Typ(int_Anz)
        Else
            Exit Sub
        End If
        If int_Anz3 > 0 Then
            REM *--------------------------------------------------------*
            REM *  Lesen der Kindes des Vaters                           *
            REM *--------------------------------------------------------*
            str_Where = " where t05_FK_t01 = " + p_int_Vater.ToString + " and t05_Typ = 3"
            mySelect.CommandText = "select * from t05_Rolle" + str_Where
            Try
                reader = mySelect.ExecuteReader
                If reader.HasRows Then
                    Do While reader.Read()
                        int_Pers = reader.Item("t05_FK_Rolle")
                        If int_Pers <> p_int_ID Then
                            int_Ges += 1
                            lng_Ges_ID(int_Ges) = reader.Item("t05_FK_Rolle")
                            int_Ges_Typ(int_Ges) = 1
                        End If
                    Loop
                End If
                reader.Close()
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
        If int_Anz4 > 0 Then
            REM *--------------------------------------------------------*
            REM *  Lesen der Kindes der Mutter                           *
            REM *--------------------------------------------------------*
            str_Where = " where t05_FK_t01 = " + p_int_Mutter.ToString + " and t05_Typ = 3"
            mySelect.CommandText = "select * from t05_Rolle" + str_Where
            Try
                reader = mySelect.ExecuteReader
                If reader.HasRows Then
                    Do While reader.Read()
                        int_Pers = reader.Item("t05_FK_Rolle")
                        int_Find = 0
                        If int_Pers <> p_int_ID Then
                            For int_Anz1 = 0 To int_Ges
                                If int_Pers = lng_Ges_ID(int_Anz1) Then
                                    int_Ges_Typ(int_Anz1) = 2
                                    int_Find = 1
                                    Exit For
                                End If
                            Next
                            If int_Find = 0 Then
                                int_Ges += 1
                                lng_Ges_ID(int_Ges) = reader.Item("t05_FK_Rolle")
                                int_Ges_Typ(int_Ges) = 1
                            End If
                        End If
                    Loop
                End If
                reader.Close()
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
        If int_Ges < 0 Then
            Exit Sub
        End If
        For int_l01 = 0 To int_Ges
            int_Pos_G = int_l01
            p_int_Ges = lng_Ges_ID(int_l01)
            lng_Pers = p_int_Ges
            Call Person_Read_Rolle()
            tg_lng_ID(int_Pos_G) = p_int_Ges
            tg_str_Name(int_Pos_G) = r_str_Name
            tg_str_GebName(int_Pos_G) = r_str_GebName
            tg_str_Vorname(int_Pos_G) = r_str_Vorname
            tg_str_GDat_TT(int_Pos_G) = r_str_GDat_TT
            tg_str_GDat_MM(int_Pos_G) = r_str_GDat_MM
            tg_str_GDat_JJ(int_Pos_G) = r_str_GDat_JJ
            tg_str_GOrt(int_Pos_G) = r_str_GOrt
            tg_str_SDat_TT(int_Pos_G) = r_str_SDat_TT
            tg_str_SDat_MM(int_Pos_G) = r_str_SDat_MM
            tg_str_SDat_JJ(int_Pos_G) = r_str_SDat_JJ
            tg_str_SOrt(int_Pos_G) = r_str_SOrt
            tg_str_Geschl(int_Pos_G) = r_str_Geschl
            tg_lng_IDV(int_Pos_G) = r_lng_IDV
            tg_lng_IDM(int_Pos_G) = r_lng_IDM
        Next
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t05)                     *
    REM *  werden über ID von Vater und Mutter ermittelt             *
    REM **************************************************************
    Public Shared Sub Person_Read_t05_Kinder()
        Dim reader As OleDbDataReader
        int_Kind = -1
        mySelect.CommandText = "select count(*) from t05_Rolle"
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 3"
        int_Anz = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        If int_Anz > 0 Then
            ReDim tk_lng_ID(int_Anz)
            ReDim tk_str_GDat_JJ(int_Anz)
            ReDim tk_str_GDat_MM(int_Anz)
            ReDim tk_str_GDat_TT(int_Anz)
            ReDim tk_str_GOrt(int_Anz)
            ReDim tk_str_SDat_JJ(int_Anz)
            ReDim tk_str_SDat_MM(int_Anz)
            ReDim tk_str_SDat_TT(int_Anz)
            ReDim tk_str_SOrt(int_Anz)
            ReDim tk_str_Name(int_Anz)
            ReDim tk_str_GebName(int_Anz)
            ReDim tk_str_Vorname(int_Anz)
            ReDim tk_str_Geschl(int_Anz)
            ReDim tk_lng_IDV(int_Anz)
            ReDim tk_lng_IDM(int_Anz)
            ReDim lng_Kind_ID(int_Anz)
        Else
            Exit Sub
        End If
        REM *--------------------------------------------------------*
        REM *  Lesen der Daten                                       *
        REM *--------------------------------------------------------*
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 3"
        mySelect.CommandText = "select * from t05_Rolle" + str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    int_Kind += 1
                    lng_Kind_ID(int_Kind) = reader.Item("t05_FK_Rolle")
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        For int_l01 = 0 To int_Kind
            int_Pos_K = int_l01
            p_int_Kind = lng_Kind_ID(int_l01)
            lng_Pers = p_int_Kind
            Call Person_Read_Rolle()
            tk_lng_ID(int_Pos_K) = p_int_Kind
            tk_str_Name(int_Pos_K) = r_str_Name
            tk_str_GebName(int_Pos_K) = r_str_GebName
            tk_str_Vorname(int_Pos_K) = r_str_Vorname
            tk_str_GDat_TT(int_Pos_K) = r_str_GDat_TT
            tk_str_GDat_MM(int_Pos_K) = r_str_GDat_MM
            tk_str_GDat_JJ(int_Pos_K) = r_str_GDat_JJ
            tk_str_GOrt(int_Pos_K) = r_str_GOrt
            tk_str_SDat_TT(int_Pos_K) = r_str_SDat_TT
            tk_str_SDat_MM(int_Pos_K) = r_str_SDat_MM
            tk_str_SDat_JJ(int_Pos_K) = r_str_SDat_JJ
            tk_str_SOrt(int_Pos_K) = r_str_SOrt
            tk_str_Geschl(int_Pos_K) = r_str_Geschl
            tk_lng_IDV(int_Pos_K) = r_lng_IDV
            tk_lng_IDM(int_Pos_K) = r_lng_IDM
        Next
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t05)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_t05_Paten()
        Dim reader As OleDbDataReader
        int_Pate = -1
        mySelect.CommandText = "select count(*) from t05_Rolle"
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 5"
        int_Anz = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        If int_Anz > 0 Then
            ReDim tp_lng_ID(int_Anz)
            ReDim tp_str_GDat_JJ(int_Anz)
            ReDim tp_str_GDat_MM(int_Anz)
            ReDim tp_str_GDat_TT(int_Anz)
            ReDim tp_str_GOrt(int_Anz)
            ReDim tp_str_SDat_JJ(int_Anz)
            ReDim tp_str_SDat_MM(int_Anz)
            ReDim tp_str_SDat_TT(int_Anz)
            ReDim tp_str_SOrt(int_Anz)
            ReDim tp_str_Name(int_Anz)
            ReDim tp_str_GebName(int_Anz)
            ReDim tp_str_Vorname(int_Anz)
            ReDim tp_str_Geschl(int_Anz)
            ReDim lng_Pate_ID(int_Anz)
        Else
            Exit Sub
        End If
        REM *--------------------------------------------------------*
        REM *  Lesen der Kindes des Vaters                           *
        REM *--------------------------------------------------------*
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 5"
        mySelect.CommandText = "select * from t05_Rolle" + str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    int_Pate += 1
                    lng_Pate_ID(int_Pate) = reader.Item("t05_FK_Rolle")
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        For int_l01 = 0 To int_Pate
            int_Pos_P = int_l01
            p_int_Pate = lng_Pate_ID(int_l01)
            lng_Pers = p_int_Pate
            Call Person_Read_Rolle()
            tp_lng_ID(int_Pos_P) = p_int_Pate
            tp_str_Name(int_Pos_P) = r_str_Name
            tp_str_GebName(int_Pos_P) = r_str_GebName
            tp_str_Vorname(int_Pos_P) = r_str_Vorname
            tp_str_GDat_TT(int_Pos_P) = r_str_GDat_TT
            tp_str_GDat_MM(int_Pos_P) = r_str_GDat_MM
            tp_str_GDat_JJ(int_Pos_P) = r_str_GDat_JJ
            tp_str_GOrt(int_Pos_P) = r_str_GOrt
            tp_str_SDat_TT(int_Pos_P) = r_str_SDat_TT
            tp_str_SDat_MM(int_Pos_P) = r_str_SDat_MM
            tp_str_SDat_JJ(int_Pos_P) = r_str_SDat_JJ
            tp_str_SOrt(int_Pos_P) = r_str_SOrt
            tp_str_Geschl(int_Pos_P) = r_str_Geschl
        Next
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t05)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_t05_Paten1()
        Dim reader As OleDbDataReader
        int_Pate1 = -1
        mySelect.CommandText = "select count(*) from t05_Rolle"
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 6"
        int_Anz = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        If int_Anz > 0 Then
            ReDim tp1_lng_ID(int_Anz)
            ReDim tp1_str_GDat_JJ(int_Anz)
            ReDim tp1_str_GDat_MM(int_Anz)
            ReDim tp1_str_GDat_TT(int_Anz)
            ReDim tp1_str_GOrt(int_Anz)
            ReDim tp1_str_SDat_JJ(int_Anz)
            ReDim tp1_str_SDat_MM(int_Anz)
            ReDim tp1_str_SDat_TT(int_Anz)
            ReDim tp1_str_SOrt(int_Anz)
            ReDim tp1_str_Name(int_Anz)
            ReDim tp1_str_GebName(int_Anz)
            ReDim tp1_str_Vorname(int_Anz)
            ReDim tp1_str_Geschl(int_Anz)
            ReDim lng_Pate1_ID(int_Anz)
        Else
            Exit Sub
        End If
        REM *--------------------------------------------------------*
        REM *  Lesen der Paten                                       *
        REM *--------------------------------------------------------*
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 6"
        mySelect.CommandText = "select * from t05_Rolle" + str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    int_Pate1 += 1
                    lng_Pate1_ID(int_Pate1) = reader.Item("t05_FK_Rolle")
                Loop
            End If
            reader.Close()

        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        int_Merk_Tab_Paten = 1
        For int_l01 = 0 To int_Pate1
            int_Pos_P1 = int_l01
            p_int_Pate1 = lng_Pate1_ID(int_l01)
            lng_Pers = p_int_Pate1
            Call Person_Read_Rolle()
            tp1_lng_ID(int_Pos_P1) = p_int_Pate1
            tp1_str_Name(int_Pos_P1) = r_str_Name
            tp1_str_GebName(int_Pos_P1) = r_str_GebName
            tp1_str_Vorname(int_Pos_P1) = r_str_Vorname
            tp1_str_GDat_TT(int_Pos_P1) = r_str_GDat_TT
            tp1_str_GDat_MM(int_Pos_P1) = r_str_GDat_MM
            tp1_str_GDat_JJ(int_Pos_P1) = r_str_GDat_JJ
            tp1_str_GOrt(int_Pos_P1) = r_str_GOrt
            tp1_str_SDat_TT(int_Pos_P1) = r_str_SDat_TT
            tp1_str_SDat_MM(int_Pos_P1) = r_str_SDat_MM
            tp1_str_SDat_JJ(int_Pos_P1) = r_str_SDat_JJ
            tp1_str_SOrt(int_Pos_P1) = r_str_SOrt
            tp1_str_Geschl(int_Pos_P1) = r_str_Geschl
        Next
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t05)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_t05_Zeugen()
        Dim reader As OleDbDataReader
        int_Zeuge = -1
        mySelect.CommandText = "select count(*) from t05_Rolle"
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 7"
        int_Anz = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        If int_Anz > 0 Then
            ReDim tz_lng_ID(int_Anz)
            ReDim tz_str_GDat_JJ(int_Anz)
            ReDim tz_str_GDat_MM(int_Anz)
            ReDim tz_str_GDat_TT(int_Anz)
            ReDim tz_str_GOrt(int_Anz)
            ReDim tz_str_SDat_JJ(int_Anz)
            ReDim tz_str_SDat_MM(int_Anz)
            ReDim tz_str_SDat_TT(int_Anz)
            ReDim tz_str_SOrt(int_Anz)
            ReDim tz_str_Name(int_Anz)
            ReDim tz_str_GebName(int_Anz)
            ReDim tz_str_Vorname(int_Anz)
            ReDim tz_str_Geschl(int_Anz)
            ReDim lng_Zeuge_ID(int_Anz)
        Else
            Exit Sub
        End If
        REM *--------------------------------------------------------*
        REM *  Lesen der Personen                                    *
        REM *--------------------------------------------------------*
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 7"
        mySelect.CommandText = "select * from t05_Rolle" + str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    int_Zeuge += 1
                    lng_Zeuge_ID(int_Zeuge) = reader.Item("t05_FK_Rolle")
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        int_Merk_Tab_Paten = 1
        For int_l01 = 0 To int_Zeuge
            int_Pos_Z = int_l01
            p_int_Zeuge = lng_Zeuge_ID(int_l01)
            lng_Pers = p_int_Zeuge
            Call Person_Read_Rolle()
            tz_lng_ID(int_Pos_Z) = p_int_Zeuge
            tz_str_Name(int_Pos_Z) = r_str_Name
            tz_str_GebName(int_Pos_Z) = r_str_GebName
            tz_str_Vorname(int_Pos_Z) = r_str_Vorname
            tz_str_GDat_TT(int_Pos_Z) = r_str_GDat_TT
            tz_str_GDat_MM(int_Pos_Z) = r_str_GDat_MM
            tz_str_GDat_JJ(int_Pos_Z) = r_str_GDat_JJ
            tz_str_GOrt(int_Pos_Z) = r_str_GOrt
            tz_str_SDat_TT(int_Pos_Z) = r_str_SDat_TT
            tz_str_SDat_MM(int_Pos_Z) = r_str_SDat_MM
            tz_str_SDat_JJ(int_Pos_Z) = r_str_SDat_JJ
            tz_str_SOrt(int_Pos_Z) = r_str_SOrt
            tz_str_Geschl(int_Pos_Z) = r_str_Geschl
        Next
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t05)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_t05_Zeugen1()
        Dim reader As OleDbDataReader
        int_Zeuge1 = -1
        mySelect.CommandText = "select count(*) from t05_Rolle"
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 8"
        int_Anz = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        If int_Anz > 0 Then
            ReDim tz1_lng_ID(int_Anz)
            ReDim tz1_str_GDat_JJ(int_Anz)
            ReDim tz1_str_GDat_MM(int_Anz)
            ReDim tz1_str_GDat_TT(int_Anz)
            ReDim tz1_str_GOrt(int_Anz)
            ReDim tz1_str_SDat_JJ(int_Anz)
            ReDim tz1_str_SDat_MM(int_Anz)
            ReDim tz1_str_SDat_TT(int_Anz)
            ReDim tz1_str_SOrt(int_Anz)
            ReDim tz1_str_Name(int_Anz)
            ReDim tz1_str_GebName(int_Anz)
            ReDim tz1_str_Vorname(int_Anz)
            ReDim tz1_str_Geschl(int_Anz)
            ReDim lng_Zeuge1_ID(int_Anz)
        Else
            Exit Sub
        End If
        REM *--------------------------------------------------------*
        REM *  Lesen der Personen                                    *
        REM *--------------------------------------------------------*
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 8"
        mySelect.CommandText = "select * from t05_Rolle" + str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    int_Zeuge1 += 1
                    lng_Zeuge1_ID(int_Zeuge1) = reader.Item("t05_FK_Rolle")
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        int_Merk_Tab_Paten = 1
        For int_l01 = 0 To int_Zeuge1
            int_Pos_Z1 = int_l01
            p_int_Zeuge1 = lng_Zeuge1_ID(int_l01)
            lng_Pers = p_int_Zeuge1
            Call Person_Read_Rolle()
            tz1_lng_ID(int_Pos_Z1) = p_int_Zeuge1
            tz1_str_Name(int_Pos_Z1) = r_str_Name
            tz1_str_GebName(int_Pos_Z1) = r_str_GebName
            tz1_str_Vorname(int_Pos_Z1) = r_str_Vorname
            tz1_str_GDat_TT(int_Pos_Z1) = r_str_GDat_TT
            tz1_str_GDat_MM(int_Pos_Z1) = r_str_GDat_MM
            tz1_str_GDat_JJ(int_Pos_Z1) = r_str_GDat_JJ
            tz1_str_GOrt(int_Pos_Z1) = r_str_GOrt
            tz1_str_SDat_TT(int_Pos_Z1) = r_str_SDat_TT
            tz1_str_SDat_MM(int_Pos_Z1) = r_str_SDat_MM
            tz1_str_SDat_JJ(int_Pos_Z1) = r_str_SDat_JJ
            tz1_str_SOrt(int_Pos_Z1) = r_str_SOrt
            tz1_str_Geschl(int_Pos_Z1) = r_str_Geschl
        Next
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t05)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_t05_Zeugen2()
        Dim reader As OleDbDataReader
        int_Zeuge2 = -1
        mySelect.CommandText = "select count(*) from t05_Rolle"
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 9"
        int_Anz = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        If int_Anz > 0 Then
            ReDim tz2_lng_ID(int_Anz)
            ReDim tz2_str_GDat_JJ(int_Anz)
            ReDim tz2_str_GDat_MM(int_Anz)
            ReDim tz2_str_GDat_TT(int_Anz)
            ReDim tz2_str_GOrt(int_Anz)
            ReDim tz2_str_SDat_JJ(int_Anz)
            ReDim tz2_str_SDat_MM(int_Anz)
            ReDim tz2_str_SDat_TT(int_Anz)
            ReDim tz2_str_SOrt(int_Anz)
            ReDim tz2_str_Name(int_Anz)
            ReDim tz2_str_GebName(int_Anz)
            ReDim tz2_str_Vorname(int_Anz)
            ReDim tz2_str_Geschl(int_Anz)
            ReDim lng_Zeuge2_ID(int_Anz)
        Else
            Exit Sub
        End If

        REM *--------------------------------------------------------*
        REM *  Lesen der Personen                                    *
        REM *--------------------------------------------------------*
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 9"
        mySelect.CommandText = "select * from t05_Rolle" + str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    int_Zeuge2 += 1
                    lng_Zeuge2_ID(int_Zeuge2) = reader.Item("t05_FK_Rolle")
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        int_Merk_Tab_Paten = 1
        For int_l01 = 0 To int_Zeuge2
            int_Pos_Z2 = int_l01
            p_int_Zeuge2 = lng_Zeuge2_ID(int_l01)
            lng_Pers = p_int_Zeuge2
            Call Person_Read_Rolle()
            tz2_lng_ID(int_Pos_Z2) = p_int_Zeuge2
            tz2_str_Name(int_Pos_Z2) = r_str_Name
            tz2_str_GebName(int_Pos_Z2) = r_str_GebName
            tz2_str_Vorname(int_Pos_Z2) = r_str_Vorname
            tz2_str_GDat_TT(int_Pos_Z2) = r_str_GDat_TT
            tz2_str_GDat_MM(int_Pos_Z2) = r_str_GDat_MM
            tz2_str_GDat_JJ(int_Pos_Z2) = r_str_GDat_JJ
            tz2_str_GOrt(int_Pos_Z2) = r_str_GOrt
            tz2_str_SDat_TT(int_Pos_Z2) = r_str_SDat_TT
            tz2_str_SDat_MM(int_Pos_Z2) = r_str_SDat_MM
            tz2_str_SDat_JJ(int_Pos_Z2) = r_str_SDat_JJ
            tz2_str_SOrt(int_Pos_Z2) = r_str_SOrt
            tz2_str_Geschl(int_Pos_Z2) = r_str_Geschl
        Next
    End Sub

    REM **************************************************************
    REM *  Lesen der Anschriftendaten (Tabelle t06)                  *
    REM **************************************************************
    Public Shared Sub Person_Read_Adresse()
        Dim reader As OleDbDataReader
        Call Mask14_Clear()
        int_Adr = -1
        int_Adr_Akt = 0
        mySelect.CommandText = "select count(*) from t06_adr"
        str_Where = " where t06_FK_t01 = " + p_int_ID.ToString
        int_Anz = GetNumberOfRecordsTyp(con, "t06_Adr", str_Where)
        If int_Anz > 0 Then
            ReDim ta_lng_ID(int_Anz)
            ReDim ta_int_LFD(int_Anz)
            ReDim ta_dt_DatVon(int_Anz)
            ReDim ta_dt_DatBis(int_Anz)
            ReDim ta_str_PLZ(int_Anz)
            ReDim ta_str_Ort(int_Anz)
            ReDim ta_str_Strasse(int_Anz)
            ReDim ta_str_Land(int_Anz)
            ReDim ta_str_Tel1(int_Anz)
            ReDim ta_str_Tel2(int_Anz)
            ReDim ta_str_Fax(int_Anz)
            ReDim ta_str_Mail(int_Anz)
            ReDim ta_str_www(int_Anz)
        Else
            Call Person_Adresse_Clear()
            Exit Sub
        End If
        REM *--------------------------------------------------------*
        REM *  Lesen der Personen                                    *
        REM *--------------------------------------------------------*
        str_Where = " where t06_FK_t01 = " + p_int_ID.ToString
        mySelect.CommandText = "select * from t06_Adr" + str_Where
        Try
            reader = mySelect.ExecuteReader
            If reader.HasRows Then
                Do While reader.Read()
                    int_Adr += 1
                    myNull = IsDBNull(reader.Item("t06_ID"))
                    If myNull = False Then ta_lng_ID(int_Adr) = reader.Item("t06_ID")
                    myNull = IsDBNull(reader.Item("t06_Lfd"))
                    If myNull = False Then ta_int_LFD(int_Adr) = reader.Item("t06_Lfd")
                    myNull = IsDBNull(reader.Item("t06_Dat_von"))
                    If myNull = False Then ta_dt_DatVon(int_Adr) = reader.Item("t06_Dat_von")
                    myNull = IsDBNull(reader.Item("t06_Dat_bis"))
                    If myNull = False Then ta_dt_DatBis(int_Adr) = reader.Item("t06_Dat_bis")
                    myNull = IsDBNull(reader.Item("t06_ZIP"))
                    If myNull = False Then ta_str_PLZ(int_Adr) = reader.Item("t06_ZIP")
                    myNull = IsDBNull(reader.Item("t06_Ort"))
                    If myNull = False Then ta_str_Ort(int_Adr) = reader.Item("t06_Ort")
                    myNull = IsDBNull(reader.Item("t06_Strasse"))
                    If myNull = False Then ta_str_Strasse(int_Adr) = reader.Item("t06_Strasse")
                    myNull = IsDBNull(reader.Item("t06_Land"))
                    If myNull = False Then ta_str_Land(int_Adr) = reader.Item("t06_Land")
                    myNull = IsDBNull(reader.Item("t06_Dat_bis"))
                    If myNull = False Then ta_str_Tel1(int_Adr) = reader.Item("t06_Telefon1")
                    myNull = IsDBNull(reader.Item("t06_ZIP"))
                    If myNull = False Then ta_str_Tel2(int_Adr) = reader.Item("t06_Telefon2")
                    myNull = IsDBNull(reader.Item("t06_Ort"))
                    If myNull = False Then ta_str_Fax(int_Adr) = reader.Item("t06_Telefax")
                    myNull = IsDBNull(reader.Item("t06_Mail"))
                    If myNull = False Then ta_str_Mail(int_Adr) = reader.Item("t06_Mail")
                    myNull = IsDBNull(reader.Item("t06_Homepage"))
                    If myNull = False Then ta_str_www(int_Adr) = reader.Item("t06_Homepage")
                    REM *   Prüfen auf Zeitletzten Eintrag
                    int_Adr_Akt = int_Adr
                    If int_Adr > 0 Then
                        str_HDat1 = Mid(ta_dt_DatVon(int_Adr), 7, 4) + Mid(ta_dt_DatVon(int_Adr), 5, 2) + Mid(ta_dt_DatVon(int_Adr), 1, 2)
                        str_HDat2 = Mid(ta_dt_DatVon(int_Adr - 1), 7, 4) + Mid(ta_dt_DatVon(int_Adr - 1), 5, 2) + Mid(ta_dt_DatVon(int_Adr - 1), 1, 2)
                        If str_HDat1 > str_HDat2 Then
                            int_Adr_Akt = int_Adr
                        End If
                    End If
                    int_Merk_Tab_Anschr = 1
                Loop
            End If
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        With NM_Ahnen
            .dgv_14_Adr.Rows.Clear()
        End With
        Call Person_Adresse_Zeigen()
    End Sub

    REM **************************************************************
    REM *  ausgewählte Adressdaten in Einzelanzeige darstellen       *
    REM **************************************************************
    Public Shared Sub Person_Adresse_Zeigen()
        With NM_Ahnen
            If int_Adr_Akt > -1 Then
                .tx_14_Land.Text = ta_str_Land(int_Adr_Akt)
                .tx_14_PLZ.Text = ta_str_PLZ(int_Adr_Akt)
                .tx_14_Ort.Text = ta_str_Ort(int_Adr_Akt)
                .tx_14_Strasse.Text = ta_str_Strasse(int_Adr_Akt)
                .tx_14_Dat1_TT.Text = Mid(ta_dt_DatVon(int_Adr_Akt), 1, 2)
                .tx_14_Dat1_MM.Text = Mid(ta_dt_DatVon(int_Adr_Akt), 4, 2)
                .tx_14_Dat1_JJ.Text = Mid(ta_dt_DatVon(int_Adr_Akt), 7, 4)
                .tx_14_Dat2_TT.Text = Mid(ta_dt_DatBis(int_Adr_Akt), 1, 2)
                .tx_14_Dat2_MM.Text = Mid(ta_dt_DatBis(int_Adr_Akt), 4, 2)
                .tx_14_Dat2_JJ.Text = Mid(ta_dt_DatBis(int_Adr_Akt), 7, 4)
                .tx_14_Tel1.Text = ta_str_Tel1(int_Adr_Akt)
                .tx_14_Tel2.Text = ta_str_Tel2(int_Adr_Akt)
                .tx_14_Fax.Text = ta_str_Fax(int_Adr_Akt)
                .tx_14_Mail.Text = ta_str_Mail(int_Adr_Akt)
                .tx_14_www.Text = ta_str_www(int_Adr_Akt)

                REM *----------------------------------------------*
                REM *  Füllen Zwischenspeicher                     *
                REM *----------------------------------------------*
                p_int_Adr_Lfd = ta_int_LFD(int_Adr_Akt)
                p_str_Adr_Land = ta_str_Land(int_Adr_Akt)
                p_str_Adr_ZIP = ta_str_PLZ(int_Adr_Akt)
                p_str_Adr_Ort = ta_str_Ort(int_Adr_Akt)
                p_str_Adr_Strasse = ta_str_Strasse(int_Adr_Akt)
                p_str_Adr_DatV_TT = Mid(ta_dt_DatVon(int_Adr_Akt), 1, 2)
                p_str_Adr_DatV_MM = Mid(ta_dt_DatVon(int_Adr_Akt), 4, 2)
                p_str_Adr_DatV_JJ = Mid(ta_dt_DatVon(int_Adr_Akt), 7, 4)
                p_str_Adr_DatB_TT = Mid(ta_dt_DatBis(int_Adr_Akt), 1, 2)
                p_str_Adr_DatB_MM = Mid(ta_dt_DatBis(int_Adr_Akt), 4, 2)
                p_str_Adr_DatB_JJ = Mid(ta_dt_DatBis(int_Adr_Akt), 7, 4)
                p_str_Adr_Tel1 = ta_str_Tel1(int_Adr_Akt)
                p_str_Adr_Tel2 = ta_str_Tel2(int_Adr_Akt)
                p_str_Adr_Fax = ta_str_Fax(int_Adr_Akt)
                p_str_Adr_Mail = ta_str_Mail(int_Adr_Akt)
                p_str_Adr_www = ta_str_www(int_Adr_Akt)
                int_Merk_Tab_Anschr = 1
            End If
        End With
    End Sub

    REM **************************************************************
    REM *  Löschen der Speicherwerte                                 *
    REM **************************************************************
    Public Shared Sub Person_Adresse_Clear()
        p_int_Adr_Lfd = 0
        p_str_Adr_Land = ""
        p_str_Adr_ZIP = ""
        p_str_Adr_Ort = ""
        p_str_Adr_Strasse = ""
        p_str_Adr_DatV_TT = ""
        p_str_Adr_DatV_MM = ""
        p_str_Adr_DatV_JJ = ""
        p_str_Adr_DatB_TT = ""
        p_str_Adr_DatB_MM = ""
        p_str_Adr_DatB_JJ = ""
        p_str_Adr_Tel1 = ""
        p_str_Adr_Tel2 = ""
        p_str_Adr_Fax = ""
        p_str_Adr_Mail = ""
        p_str_Adr_www = ""
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten (Tabelle t07)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_Beruf()
        Dim int_Brf As Integer = 0
        Dim reader As OleDbDataReader
        Call Mask15_Clear()
        int_Beruf = -1
        mySelect.CommandText = "select count(*) from t07_Beruf"
        str_Where = " where t07_FK_t01 = " + p_int_ID.ToString
        int_Anz = GetNumberOfRecordsTyp(con, "t07_Beruf", str_Where)
        If int_Anz > 0 Then
            ReDim lng_Beruf_ID(int_Anz)
            ReDim tb_lng_ID(int_Anz)
            ReDim tb_int_LFD(int_Anz)
            ReDim tb_str_Beruf(int_Anz)
            ReDim tb_dt_DatVon(int_Anz)
            ReDim tb_dt_DatBis(int_Anz)
        Else
            Call Person_Beruf_Clear()
            Exit Sub
        End If
        int_Merk_Tab_Beruf = 1
        REM *--------------------------------------------------------*
        REM *  Lesen der Personen                                    *
        REM *--------------------------------------------------------*
        str_Where = " where t07_FK_t01 = " + p_int_ID.ToString
        mySelect.CommandText = "select * from t07_Beruf" + str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read()
                int_Beruf += 1
                lng_Beruf_ID(int_Beruf) = reader.Item("t07_LFD")
                tb_int_LFD(int_Beruf) = reader.Item("t07_LFD")

                myNull = IsDBNull(reader.Item("t07_Dat_von"))
                If myNull = False Then tb_dt_DatVon(int_Beruf) = reader.Item("t07_Dat_von")
                myNull = IsDBNull(reader.Item("t07_Dat_bis"))
                If myNull = False Then tb_dt_DatBis(int_Beruf) = reader.Item("t07_Dat_bis")

                myNull = IsDBNull(reader.Item("t07_Beruf_a06"))
                If myNull = False Then int_Brf = reader.Item("t07_Beruf_a06")
                For int_k99 = 0 To dbl_Beruf_Max
                    If int_Brf = tab_Beruf_ID(int_k99) Then
                        tb_str_Beruf(int_Beruf) = tab_Beruf_Bez(int_k99)
                        Exit For
                    End If
                Next
                REM *   Prüfen auf Zeitletzten Eintrag
                int_Adr_Akt = int_Adr
                If int_Adr > 0 Then
                    str_HDat1 = Mid(tb_dt_DatVon(int_Adr), 7, 4) + Mid(tb_dt_DatVon(int_Adr), 5, 2) + Mid(tb_dt_DatVon(int_Adr), 1, 2)
                    str_HDat2 = Mid(tb_dt_DatVon(int_Adr - 1), 7, 4) + Mid(tb_dt_DatVon(int_Adr - 1), 5, 2) + Mid(tb_dt_DatVon(int_Adr - 1), 1, 2)
                    If str_HDat1 > str_HDat2 Then
                        int_Adr_Akt = int_Adr
                    End If
                End If
            Loop
            reader.Close()
            If int_Beruf > -1 Then int_Merk_Tab_Beruf = 1
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
        With NM_Ahnen
            .dgv_15_Beruf.Rows.Clear()
        End With
        Call Person_Beruf_Zeigen()
    End Sub

    REM **************************************************************
    REM *  Anzeigen der Berufsdaten                                  *
    REM **************************************************************
    Public Shared Sub Person_Beruf_Zeigen()
        With NM_Ahnen
            If int_Adr_Akt > -1 Then
                .tx_15_Beruf.Text = tb_str_Beruf(int_Adr_Akt)
                .tx_15_Dat1_TT.Text = Mid(tb_dt_DatVon(int_Adr_Akt), 1, 2)
                .tx_15_Dat1_MM.Text = Mid(tb_dt_DatVon(int_Adr_Akt), 4, 2)
                .tx_15_Dat1_JJ.Text = Mid(tb_dt_DatVon(int_Adr_Akt), 7, 4)
                .tx_15_Dat2_TT.Text = Mid(tb_dt_DatBis(int_Adr_Akt), 1, 2)
                .tx_15_Dat2_MM.Text = Mid(tb_dt_DatBis(int_Adr_Akt), 4, 2)
                .tx_15_Dat2_JJ.Text = Mid(tb_dt_DatBis(int_Adr_Akt), 7, 4)
                REM *----------------------------------------------*
                REM *  Füllen Zwischenspeicher                     *
                REM *----------------------------------------------*
                p_int_Ber_Lfd = tb_int_LFD(int_Adr_Akt)
                p_str_Beruf = tb_str_Beruf(int_Adr_Akt)
                p_str_Ber_DatV_TT = Mid(tb_dt_DatVon(int_Adr_Akt), 1, 2)
                p_str_Ber_DatV_MM = Mid(tb_dt_DatVon(int_Adr_Akt), 4, 2)
                p_str_Ber_DatV_JJ = Mid(tb_dt_DatVon(int_Adr_Akt), 7, 4)
                p_str_Ber_DatB_TT = Mid(tb_dt_DatBis(int_Adr_Akt), 1, 2)
                p_str_Ber_DatB_MM = Mid(tb_dt_DatBis(int_Adr_Akt), 4, 2)
                p_str_Ber_DatB_JJ = Mid(tb_dt_DatBis(int_Adr_Akt), 7, 4)
                int_Merk_Tab_Beruf = 1
            End If
        End With
    End Sub

    REM **************************************************************
    REM *  Loeschen der Zwischenspeicherwerte Berufe                 *
    REM **************************************************************
    Public Shared Sub Person_Beruf_Clear()
        p_int_Ber_Lfd = 0
        p_str_Beruf = ""
        p_str_Ber_DatV_TT = ""
        p_str_Ber_DatV_MM = ""
        p_str_Ber_DatV_JJ = ""
        p_str_Ber_DatB_TT = ""
        p_str_Ber_DatB_MM = ""
        p_str_Ber_DatB_JJ = ""
    End Sub

    REM **************************************************************
    REM *  Lesen der Personendaten der Eltern                        *
    REM **************************************************************
    Public Shared Sub Person_Read_Rolle()

        Dim reader As OleDbDataReader

        str_Where = " where t01_ID = " + lng_Pers.ToString
        mySelect.CommandText = "select * from t01_Person" & str_Where

        r_lng_ID = 0
        r_str_Name = ""
        r_str_GebName = ""
        r_str_Vorname = ""
        r_str_GDat_TT = ""
        r_str_GDat_MM = ""
        r_str_GDat_JJ = ""
        r_str_GOrt = ""
        r_str_SDat_TT = ""
        r_str_SDat_MM = ""
        r_str_SDat_JJ = ""
        r_str_SOrt = ""
        r_str_Geschl = ""
        r_lng_IDV = 0
        r_lng_IDM = 0
        reader = mySelect.ExecuteReader
        Try
            Do While reader.Read()
                myNull = IsDBNull(reader.Item("t01_Name"))
                If myNull = False Then r_str_Name = reader.Item("t01_Name")
                myNull = IsDBNull(reader.Item("t01_GebName"))
                If myNull = False Then r_str_GebName = reader.Item("t01_GebName")
                myNull = IsDBNull(reader.Item("t01_Vorname"))
                If myNull = False Then r_str_Vorname = reader.Item("t01_Vorname")
                myNull = IsDBNull(reader.Item("t01_GDat_TT"))
                If myNull = False Then r_str_GDat_TT = reader.Item("t01_GDat_TT")
                myNull = IsDBNull(reader.Item("t01_GDat_MM"))
                If myNull = False Then r_str_GDat_MM = reader.Item("t01_GDat_MM")
                myNull = IsDBNull(reader.Item("t01_GDat_JJ"))
                If myNull = False Then r_str_GDat_JJ = reader.Item("t01_GDat_JJ")
                myNull = IsDBNull(reader.Item("t01_GOrt"))
                If myNull = False Then r_str_GOrt = reader.Item("t01_GOrt")
                myNull = IsDBNull(reader.Item("t01_SDat_TT"))
                If myNull = False Then r_str_SDat_TT = reader.Item("t01_SDat_TT")
                myNull = IsDBNull(reader.Item("t01_SDat_MM"))
                If myNull = False Then r_str_SDat_MM = reader.Item("t01_SDat_MM")
                myNull = IsDBNull(reader.Item("t01_SDat_JJ"))
                If myNull = False Then r_str_SDat_JJ = reader.Item("t01_SDat_JJ")
                myNull = IsDBNull(reader.Item("t01_Vater"))
                If myNull = False Then r_lng_IDV = Val(reader.Item("t01_Vater"))
                myNull = IsDBNull(reader.Item("t01_Mutter"))
                If myNull = False Then r_lng_IDM = Val(reader.Item("t01_Mutter"))
                myNull = IsDBNull(reader.Item("t01_SOrt"))
                If myNull = False Then r_str_SOrt = reader.Item("t01_SOrt")
                myNull = IsDBNull(reader.Item("t01_Geschl"))
                If myNull = False Then r_str_Geschl = reader.Item("t01_Geschl")
            Loop
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Laden der Personendaten (Tabelle t01)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_Search()
        Dim reader As OleDbDataReader
        s_str_Geschl = ""
        s_int_Vater = 0
        s_int_Mutter = 0
        s_str_GDat_TT = ""
        s_str_GDat_MM = ""
        s_str_GDat_JJ = ""
        s_str_SDat_TT = ""
        s_str_SDat_MM = ""
        s_str_SDat_JJ = ""
        str_Where = " where t01_ID = " + dbl_Sel_ID.ToString
        mySelect.CommandText = "select * from t01_Person" & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read()
                myNull = IsDBNull(reader.Item("t01_Geschl"))
                If myNull = False Then s_str_Geschl = reader.Item("t01_Geschl")
                myNull = IsDBNull(reader.Item("t01_Vater"))
                If myNull = False Then s_int_Vater = reader.Item("t01_Vater")
                myNull = IsDBNull(reader.Item("t01_Mutter"))
                If myNull = False Then s_int_Mutter = reader.Item("t01_Mutter")
                myNull = IsDBNull(reader.Item("t01_GDat_TT"))
                If myNull = False Then s_str_GDat_TT = reader.Item("t01_GDat_TT")
                myNull = IsDBNull(reader.Item("t01_GDat_MM"))
                If myNull = False Then s_str_GDat_MM = reader.Item("t01_GDat_MM")
                myNull = IsDBNull(reader.Item("t01_GDat_JJ"))
                If myNull = False Then s_str_GDat_JJ = reader.Item("t01_GDat_JJ")
                myNull = IsDBNull(reader.Item("t01_SDat_TT"))
                If myNull = False Then s_str_SDat_TT = reader.Item("t01_SDat_TT")
                myNull = IsDBNull(reader.Item("t01_SDat_MM"))
                If myNull = False Then s_str_SDat_MM = reader.Item("t01_SDat_MM")
                myNull = IsDBNull(reader.Item("t01_SDat_JJ"))
                If myNull = False Then s_str_SDat_JJ = reader.Item("t01_SDat_JJ")
                s_str_GDat = s_str_GDat_JJ + s_str_GDat_MM + s_str_GDat_TT
                s_str_GDat = Val(s_str_GDat)
                s_str_SDat = s_str_SDat_JJ + s_str_SDat_MM + s_str_SDat_TT
                s_str_SDat = Val(s_str_SDat)
            Loop
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Laden der Historiendaten (Tabelle t88)                    *
    REM **************************************************************
    Public Shared Sub Person_Read_T88()
        Dim str_HisDate As String
        Dim reader As OleDbDataReader
        a_dbl_t88 = 0
        a_int_t88_Tab = 0
        a_int_t88_Feld = 0
        a_str_t88_Datum = ""
        a_str_t88_Text = ""
        a_str_t88_Feldbez = ""
        a_str_t88_Tabbez = ""
        a_str_t88_Zeit = ""

        mySelect.CommandText = "select * from t88_Historie where t88_FK_t01 = " + p_int_ID.ToString
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read()
                myNull = IsDBNull(reader.Item("t88_FK_t01"))
                If myNull = False Then a_dbl_t88 = reader.Item("t88_FK_t01")
                myNull = IsDBNull(reader.Item("t88_Tab"))
                If myNull = False Then
                    a_int_t88_Tab = Val(reader.Item("t88_Tab"))
                    a_str_t88_Tabbez = str_Tab_Text(a_int_t88_Tab)
                End If
                myNull = IsDBNull(reader.Item("t88_Feld"))
                If myNull = False Then
                    a_int_t88_Feld = Val(reader.Item("t88_Feld"))
                    a_str_t88_Feldbez = str_Feld_Text(a_int_t88_Tab, a_int_t88_Feld)
                End If
                myNull = IsDBNull(reader.Item("t88_Datum"))
                If myNull = False Then
                    str_HisDate = reader.Item("t88_Datum")
                    a_str_t88_Datum = Mid(str_HisDate, 1, 8)
                    a_str_t88_Zeit = Mid(str_HisDate, 9, 6)
                End If
                myNull = IsDBNull(reader.Item("t88_Text"))
                If myNull = False Then a_str_t88_Text = reader.Item("t88_Text")
                REM *--------------------------------------------*
                REM *  Füllen des DataGrids                      *
                REM *--------------------------------------------*
                With NM_Ahnen_His.dgv_His
                    With .Rows
                        .Add(a_str_t88_Tabbez, a_str_t88_Feldbez, a_str_t88_Datum, a_str_t88_Zeit, a_str_t88_Text)
                    End With
                End With
            Loop
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
    End Sub

    REM **************************************************************
    REM *  Laden der Aufgabendaten (Tabelle t99)                     *
    REM **************************************************************
    Public Shared Sub Person_Read_T99()
        Dim reader As OleDbDataReader
        Dim str_TabXX As String = ""
        a_dbl_t99 = 0
        a_int_Lfd = 0
        a_str_Name = ""
        a_str_GebName = ""
        a_str_Vorname = ""
        a_str_GDat = ""
        a_str_TI = "1"
        a_str_Aktion = ""
        NM_Ahnen_ToDo.dgv_401.Rows.Clear()
        mySelect.CommandText = "select * from t99_Aufgabe"
        If lng_HID > 0 Then mySelect.CommandText = "select * from t99_Aufgabe where t99_FK_t01 = " + lng_HID.ToString
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read()
                myNull = IsDBNull(reader.Item("t99_FK_t01"))
                If myNull = False Then a_dbl_t99 = reader.Item("t99_FK_t01")
                myNull = IsDBNull(reader.Item("t99_LFD"))
                If myNull = False Then a_int_Lfd = reader.Item("t99_LFD")
                myNull = IsDBNull(reader.Item("t99_Name"))
                If myNull = False Then a_str_Name = reader.Item("t99_Name")
                myNull = IsDBNull(reader.Item("t99_GebName"))
                If myNull = False Then a_str_GebName = reader.Item("t99_GebName")
                myNull = IsDBNull(reader.Item("t99_Vorname"))
                If myNull = False Then a_str_Vorname = reader.Item("t99_Vorname")
                myNull = IsDBNull(reader.Item("t99_GDat"))
                If myNull = False Then a_str_GDat = reader.Item("t99_GDat")
                myNull = IsDBNull(reader.Item("t99_TabIndex"))
                If myNull = False Then a_str_TI = str_Tab_Text(Val(reader.Item("t99_TabIndex")))
                myNull = IsDBNull(reader.Item("t99_Aktion"))
                If myNull = False Then a_str_Aktion = reader.Item("t99_Aktion")
                REM *--------------------------------------------*
                REM *  Füllen des DataGrids                      *
                REM *--------------------------------------------*
                With NM_Ahnen_ToDo.dgv_401
                    With .Rows
                        .Add(a_dbl_t99.ToString("###0"), a_int_Lfd, a_str_Name, a_str_GebName, a_str_Vorname, a_str_GDat, a_str_Aktion, "OK", a_str_TI)
                    End With
                End With
            Loop
            reader.Close()
        Catch ex As Exception
            'MsgBox(ex.Message)
        End Try
    End Sub

End Class
