﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.Cls_02_DB
Imports NM_Ahnen.PreviewHandler

Public Class Cls_03_DB_Bilder

    REM **************************************************************
    REM *  Füllen der Tabelle Bilder je Person                       *
    REM **************************************************************
    Public Shared Sub Tab_Bilder()

        str_Where = " where t09_FK_t01 = " + dbl_ID.ToString + " and t09_Typ = 1"
        int_AnzPic = GetNumberOfRecordsTyp(con, "t09_Bild", str_Where)
        str_PicDirectory = str_Pfad_Pic
        int_PicDir = 0
        str_FileName = ""
        NM_Ahnen.bt_Pic_Rotation.Visible = False
        If int_PDFZeigen = 1 Then
            'NM_Ahnen.web_Brs1.Navigate("")
            'NM_Ahnen.web_Brs1.Refresh()
            int_PDFZeigen = 0
        End If
        str_PersPic = "#" + dbl_ID.ToString("000000")
        str_PicDirectory += "\" + str_PersPic + "\"
        NM_Ahnen.dgv_Pictures.Rows.Clear()
        If Not Directory.Exists(str_PicDirectory) Then
            Filepdf = str_Pfad_Pic + "\#000000\NoPicDirectory.png"
            Dim picFileStream As New FileStream(Filepdf, FileMode.Open, FileAccess.Read)
            Img_Pers = Image.FromStream(picFileStream)
            picFileStream.Close()
            picFileStream.Dispose()
            int_PicDir = 1
            With NM_Ahnen
                .tx_01_LFD.Text = ""
                .tx_01_Bez.Text = ""
            End With
            Call Bild_Typ01()
            Exit Sub
        End If
        Dim int_NeuPic As Integer = int_AnzPic
        If int_AnzPic = 0 Then int_NeuPic += 1
        Dim reader As OleDbDataReader
        Dim int_i5 As Integer = 0
        Dim str_PicBez1 As String = ""
        ReDim str_PicBez(int_NeuPic * 25)
        ReDim str_PicName(int_NeuPic * 25)
        ReDim int_PicOK(int_NeuPic * 25)
        mySelect.Connection = con
        mySelect.CommandText = "select * from t09_Bild" + str_Where
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            myNull = IsDBNull(reader.Item("t09_lfd"))
            If myNull = False Then int_i5 = reader.Item("t09_lfd")
            myNull = IsDBNull(reader.Item("t09_Text"))
            If myNull = False Then str_PicBez(int_i5) = reader.Item("t09_Text")
            myNull = IsDBNull(reader.Item("t09_FileName"))
            If myNull = False Then str_PicName(int_i5) = reader.Item("t09_FileName")
            'str_FileName = str_PicName(int_i5)
            int_PicOK(int_i5) = int_i5
        Loop
        reader.Close()
        With NM_Ahnen
            .tx_01_LFD.Text = ""
            .tx_01_Bez.Text = ""
        End With
        Call Bild_Auswahl()

        If int_AnzPic > 0 Then
            For int_NeuPic = 0 To int_AnzPic
                If int_PicOK(int_NeuPic) > 0 Then
                    str_Path_2 = str_PicDirectory + str_PicName(int_NeuPic)
                    str_FileName = str_PicName(int_NeuPic)
                    str_PicBez1 = str_PicBez(int_NeuPic)
                    Exit For
                End If
            Next
            With NM_Ahnen
                .tx_01_LFD.Text = int_NeuPic
                .tx_01_Bez.Text = str_PicBez1
            End With
            Call Bild_Aendern_2()
        End If
    End Sub
    REM **************************************************************
    REM *  Bildauswahl aus Directory evtl. dazuladen                 *
    REM **************************************************************
    Public Shared Sub Bild_Auswahl()
        Dim Fil As New IO.DirectoryInfo(str_PicDirectory)
        Dim FNA = Fil.GetFiles
        Dim int_AnzP_Alt As Integer = int_AnzPic
        Dim str_FNA As String
        For Each file In FNA
            str_FNA = file.Name
            For i09 = 1 To int_AnzP_Alt
                If str_PicName(i09) = str_FNA Then str_FNA = "XX"
            Next
            If str_FNA <> "XX" Then
                int_AnzPic += 1
                str_PicName(int_AnzPic) = str_FNA
                str_PicBez(int_AnzPic) = "NEU"
                int_PicOK(int_AnzPic) = int_AnzPic
            End If
        Next
        Call Bilder_Load()
    End Sub
    REM **************************************************************
    REM *  Bildinfos in Grid laden                                   *
    REM **************************************************************
    Public Shared Sub Bilder_Load()
        Dim int_i5 As Integer
        With NM_Ahnen
            .dgv_Pictures.Rows.Clear()              ' Löschen Gridzeilen
            For int_i5 = 1 To int_AnzPic
                .dgv_Pictures.Rows.Add(int_i5.ToString, str_PicBez(int_i5), str_PicName(int_i5))
            Next
            .bt_01_PicDel.Visible = False           ' Löschenbutton ausblenden
        End With
    End Sub
    REM **************************************************************
    REM *  Neu geladenes Bild anzeigen und Bezeichnungstext fordern  *
    REM **************************************************************
    Public Shared Sub Bild_Neu()
        With NM_Ahnen
            int_AnzPic += 1
            .tx_01_LFD.Text = int_AnzPic
            .tx_01_Bez.Text = ""
        End With
    End Sub

    REM **************************************************************
    REM *  aus dem Grid angewähltes Bild markieren                   *
    REM *  dann zur Änderungsroutine 2 schalten                      *
    REM **************************************************************
    Public Shared Sub Bild_Aendern()
        Dim i10 As Integer
        With NM_Ahnen
            .tx_01_LFD.Text = .dgv_Pictures.CurrentRow.Cells(0).Value
            .tx_01_Bez.Text = .dgv_Pictures.CurrentRow.Cells(1).Value
            .web_Brs1.Refresh()
            str_Path_2 = str_PicDirectory + .dgv_Pictures.CurrentRow.Cells(2).Value
            str_FileName = .dgv_Pictures.CurrentRow.Cells(2).Value
            For i10 = 0 To (int_AnzPic - 1)
                .dgv_Pictures.Rows(i10).Cells(0).Style.BackColor = col_Grid1
                .dgv_Pictures.Rows(i10).Cells(1).Style.BackColor = col_Grid1
                .dgv_Pictures.Rows(i10).Cells(2).Style.BackColor = col_Grid1
            Next
            .dgv_Pictures.CurrentRow.Cells(0).Style.BackColor = col_Grid2
            .dgv_Pictures.CurrentRow.Cells(1).Style.BackColor = col_Grid2
            .dgv_Pictures.CurrentRow.Cells(2).Style.BackColor = col_Grid2
            .bt_01_PicDel.Visible = True
            Call Bild_Aendern_2()
        End With
    End Sub

    REM **************************************************************
    REM *  Ausgewähltes Bild laden und anzeigen                      *
    REM **************************************************************
    Public Shared Sub Bild_Aendern_2()
        int_Pic_OK = 0
        Filepdf = str_PicDirectory + str_FileName
        'Filepdf = Replace(Filepdf, "\", "/")
        Dim str_FileName1 = UCase(str_FileName)
        If str_FileName1.EndsWith(".JPG") Then int_Pic_OK = 1
        If str_FileName1.EndsWith(".JPEG") Then int_Pic_OK = 1
        If str_FileName1.EndsWith(".BMP") Then int_Pic_OK = 1
        If str_FileName1.EndsWith(".GIF") Then int_Pic_OK = 1
        If str_FileName1.EndsWith(".PNG") Then int_Pic_OK = 1
        If str_FileName1.EndsWith(".TIF") Then int_Pic_OK = 1
        If str_FileName1.EndsWith(".PDF") Then int_Pic_OK = 2
        If int_Pic_OK = 0 Then
            If MessageBox.Show("Für diesen Dateityp   existiert keine Anzeige", "Dateiendung", MessageBoxButtons.OK) = DialogResult.OK Then
                Exit Sub
            End If
        End If
        If int_Pic_OK = 1 Then
            Call Bild_Typ01()
        End If
        If int_Pic_OK = 2 Then
            Call Bild_Typ02()
        End If
    End Sub

    '******************************************************************
    '*  Bild/Dokument Typ 1 anzeigen                                  *
    '******************************************************************
    Public Shared Sub Bild_Typ01()
        'Dim picFileStream As New FileStream(Filepdf, FileMode.Open, FileAccess.Read)
        'Img_Pers = Image.FromStream(picFileStream)
        'picFileStream.Close()
        'picFileStream.Dispose()
        With NM_Ahnen
                .bt_Pic_Rotation.Visible = True
                .web_Brs1.Visible = False
                .pbx_01_01.Visible = True
            'Preview.ShowPreview("Filepdf")
            '.pbx_01_01.Show()
        End With
    End Sub
    '******************************************************************
    '*  Bild/Dokument Typ 2 anzeigen                                  *
    '******************************************************************
    Public Shared Sub Bild_Typ02()
        With NM_Ahnen
            .pbx_01_01.Visible = False
            .bt_Pic_Rotation.Visible = False
            .web_Brs1.Visible = True
            .web_Brs1.Navigate(Filepdf)
            .web_Brs1.Show()
            int_PDFZeigen = 1
        End With
    End Sub


    'Using FileStream As New IO.FileStream(Filepdf, IO.FileMode.Open)
    '    Using MemoryStream As New IO.MemoryStream
    '        Dim RawBytes = Freeware.Pdf2Png.Convert(FileStream, 1)
    '        MemoryStream.Write(RawBytes, 0, RawBytes.Count)
    '        NM_Ahnen.pbx_01_01.Image = Drawing.Image.FromStream(MemoryStream)
    '        'Dim file As New FileStream(FileName & ".png", FileMode.Create, FileAccess.Write)
    '        'MemoryStream.WriteTo(file)
    '        'File.Close()
    '    End Using
    'End Using




    REM **************************************************************
    REM *  Einfügen von neuen Bildern                                *
    REM **************************************************************
    Public Shared Sub Bild_Insert()
        Call DB_Tab_High("t09_ID", "t09_Bild")
        dbl_Max_ID += 1
        Call Bild_LFD_High()
        int_Max_LFD += 1
        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle t09 (Bilder)                          *
        REM *--------------------------------------------------------*
        str_DBD_t09 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_t09 += "'" + dbl_ID.ToString + "',"
        str_DBD_t09 += "'" + int_Max_LFD.ToString + "',"
        str_DBD_t09 += "'1',"
        str_DBD_t09 += "'" + str_FileName + "',"
        str_DBD_t09 += "'" + NM_Ahnen.tx_01_Bez.Text + "')"
        str_Tab = str_DBS_t09 + str_DBD_t09
        mySelect.Connection = con
        mySelect.CommandText = "insert into t09_Bild " & str_Tab
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        With NM_Ahnen
            .tx_01_LFD.Text = int_Max_LFD.ToString
            .tx_01_Bez.Text = ""
        End With
        If int_Merk_Import = 0 Then
            Call Bild_Aendern_2()
            int_Para_DB = 2
        End If
    End Sub

    REM **************************************************************
    REM *  Ändern von Bildbezeichnungen (Text)                       *
    REM **************************************************************
    Public Shared Sub Bild_Update()
        int_Find = 0
        dbl_x = 0
        str_Where = "t09_FK_t01 = " + dbl_ID.ToString
        str_Where += " and t09_lfd = " + NM_Ahnen.tx_01_LFD.Text + " and t09_Typ = 1"
        Call Read_Bild()
        If int_Find = 0 Then
            Call Bild_Insert()
            Exit Sub
        End If
        str_Tab = "t09_Text = '" + NM_Ahnen.tx_01_Bez.Text + "'"
        mySelect.CommandText = "update t09_Bild set " & str_Tab & " where t09_ID = " & dbl_x.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM ******************************************************************
    REM *  Löschen eines Bildeintrages                                   *
    REM ******************************************************************
    Public Shared Sub Bild_Delete()
        str_Where = "t09_FK_t01 = " + dbl_ID.ToString
        str_Where += " and t09_lfd = " + NM_Ahnen.tx_01_LFD.Text
        Dim int_PicNr As Integer = Val(NM_Ahnen.tx_01_LFD.Text)
        Dim int_PicNrNeu As Integer
        dbl_x = 0
        mySelect.Connection = con
        mySelect.CommandText = "delete * from t09_Bild where " & str_Where
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        Call Bild_LFD_High()
        If int_Max_LFD > int_PicNr Then
            int_PicNr += 1
            For i10 = int_PicNr To int_Max_LFD
                str_Where = "t09_FK_t01 = " + dbl_ID.ToString
                str_Where += " and t09_lfd = " + i10.ToString
                str_Where += " and t09_Typ = 1"
                Call Read_Bild()
                int_PicNrNeu = i10 - 1
                str_Tab = "t09_lfd = " + int_PicNrNeu.ToString
                mySelect.CommandText = "update t09_Bild set " & str_Tab & " where t09_ID = " & dbl_x.ToString + " and t09_Typ = 1"
                Try
                    DB_Anz = mySelect.ExecuteNonQuery
                Catch ex As Exception
                    MsgBox(ex.Message)
                End Try
            Next
        End If
    End Sub

    '*********************************************************************
    '*  gemeinsame Leseoperation bei delete und update                   *
    '*********************************************************************
    Public Shared Sub Read_Bild()
        Dim reader As OleDbDataReader
        mySelect.Connection = con
        mySelect.CommandText = "select * from t09_Bild where " & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("t09_ID"))
                If myNull = False Then dbl_x = reader.Item("t09_ID")
                int_Find = 1
            Loop
            reader.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    REM ******************************************************************
    REM *  Select auf T01 (höchste laufende Nr von ID)                   *
    REM ******************************************************************
    Public Shared Sub Bild_LFD_High()
        mySelect.Connection = con
        mySelect.CommandText = "Select MAX(t09_LFD) from t09_Bild where t09_FK_t01 = " + dbl_ID.ToString
        myAdapter.SelectCommand = mySelect
        Try
            int_Max_LFD = mySelect.ExecuteScalar
        Catch ex As Exception
            int_Max_LFD = 0
        End Try
    End Sub

    Public Shared Function AutoSizeImage(ByVal oBitmap As Image, ByVal maxWidth As Integer, ByVal maxHeight As Integer, Optional ByVal bStretch As Boolean = False) As Image
        ' Größenverhältnis der max. Dimension
        Dim maxRatio As Single = maxWidth / maxHeight

        ' Bildgröße und aktuelles Größenverhältnis
        Dim imgWidth As Integer = oBitmap.Width
        Dim imgHeight As Integer = oBitmap.Height
        Dim imgRatio As Single = imgWidth / imgHeight

        ' Bild anpassen?
        If (imgWidth > maxWidth Or imgHeight > maxHeight) Or (bStretch) Then
            If imgRatio <= maxRatio Then
                ' Größenverhältnis des Bildes ist kleiner als die
                ' maximale Größe, in der das Bild angezeigt werden kann.
                ' In diesem Fall muss die Bildbreite angepasst werden.
                imgWidth = imgWidth / (imgHeight / maxHeight)
                imgHeight = maxHeight
            Else
                ' Größenverhältnis des Bildes ist größer als die 
                ' maximale Größe, in der das Bild angezeigt werden kann.
                ' In diesem Fall muss die Bildhöhe angepasst werden.
                imgHeight = imgHeight / (imgWidth / maxWidth)
                imgWidth = maxWidth
            End If

            ' Bitmap-Objekt in der neuen Größe erstellen
            Dim oImage As New Bitmap(imgWidth, imgHeight)

            ' Bild interpolieren, damit die Qualität erhalten bleibt
            Using g As Graphics = Graphics.FromImage(oImage)
                g.InterpolationMode = Drawing2D.InterpolationMode.HighQualityBicubic
                g.DrawImage(oBitmap, New Rectangle(0, 0, imgWidth, imgHeight))
            End Using

            ' neues Bitmap zurückgeben
            Return oImage
        Else
            ' unverändertes Originalbild zurückgeben
            Return oBitmap
        End If
    End Function
End Class
