﻿Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.cls_03_DB_Person_Neu
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_10_Mask_14
Imports NM_Ahnen.cls_20_Blaettern
Imports NM_Ahnen.cls_30_Search
Imports NM_Ahnen.cls_50_Daten_10
Imports NM_Ahnen.cls_50_Daten_11
Imports NM_Ahnen.cls_50_Daten_12
Imports NM_Ahnen.cls_50_Daten_13
Imports NM_Ahnen.cls_50_Daten_14
Imports NM_Ahnen.cls_50_Daten_15
Imports NM_Ahnen.cls_50_Daten_16
Imports NM_Ahnen.Cls_50_Daten_17
Imports NM_Ahnen.Cls_91_DB_Para
Imports NM_Ahnen.Cls_91_DB_Para_04
Imports System.Drawing.Printing

Public Class Cls_04_Util
    REM **************************************************************
    REM *  Füllen der Grundwerte                                     *
    REM **************************************************************
    Public Shared Sub Grundwerte()
        Dim ToolTip1 As New ToolTip()
        ReDim tab_Reiter(7)

        tab_Reiter(0) = "Basis"
        tab_Reiter(1) = "Taufe"
        tab_Reiter(2) = "Beerdigung"
        tab_Reiter(3) = "Ehen"
        tab_Reiter(4) = "Adressen"
        tab_Reiter(5) = "Berufe"
        tab_Reiter(6) = "Text"
        tab_Reiter(7) = "Paten/Zeugen"

        Call Bild_Visible(False)
        Call Daten_visible(True)

        ToolTip1.SetToolTip(NM_Ahnen.bt_00_DB, "Datenbank")
        ToolTip1.SetToolTip(NM_Ahnen.bt_00_List, "Listen")
        ToolTip1.SetToolTip(NM_Ahnen.bt_00_Search, "Suchen")
        ToolTip1.SetToolTip(NM_Ahnen.bt_00_Para, "Parameter")
        ToolTip1.SetToolTip(NM_Ahnen.bt_00_Todo, "Aufgaben")
        ToolTip1.SetToolTip(NM_Ahnen.bt_00_His, "Historie")
        ToolTip1.SetToolTip(NM_Ahnen.bt_00_Orte, "Orte/Namen")
        ToolTip1.SetToolTip(NM_Ahnen.bt_00_Quelle, "Quellen")
        ToolTip1.SetToolTip(NM_Ahnen.bt_10_QG1, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_10_QG2, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_10_QS1, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_10_QS2, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_11_QT1, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_11_QK1, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_12_QB1, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_12_QB2, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_13_QE1, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_13_QE2, "Quellverwaltung")
        ToolTip1.SetToolTip(NM_Ahnen.bt_13_QS1, "Quellverwaltung")

        ToolTip1.SetToolTip(NM_Ahnen.bt_00_Neu, "Neuanlage")
        ToolTip1.SetToolTip(NM_Ahnen.bt_00_Del, "Löschen")

        str_Sort_tx(1) = "ID"
        str_Sort_tx(2) = "Name"
        str_Sort_tx(3) = "Namenszusatz"
        str_Sort_tx(4) = "Geburtsname"
        str_Sort_tx(5) = "Vorname"
        str_Sort_tx(6) = "Geb.Dat"
        str_Sort_tx(7) = "Geb.Ort"
        str_Sort_tx(8) = "St.Dat"
        str_Sort_tx(9) = "St.Ort"

        str_Sort_Feld(1) = "t01_ID"
        str_Sort_Feld(2) = "t01_Name"
        str_Sort_Feld(3) = "t01_NameZ"
        str_Sort_Feld(4) = "t01_GebName"
        str_Sort_Feld(5) = "t01_Vorname"
        str_Sort_Feld(6) = "t01_GDat_Sort"
        str_Sort_Feld(7) = "t01_GOrt"
        str_Sort_Feld(8) = "t01_SDat_Sort"
        str_Sort_Feld(9) = "t01_SOrt"

        dgv_F.BackColor = Color.Beige
        dgv_M.BackColor = Color.Beige
        dgv_F.ForeColor = Color.Red
        dgv_M.ForeColor = Color.Blue

        str_QuellenTyp(0) = ""
        str_QuellenTyp(1) = "Geburt Kirche"
        str_QuellenTyp(2) = "Geburt Standesamt"
        str_QuellenTyp(3) = "Tod Kirche"
        str_QuellenTyp(4) = "Tod Standesamt"
        str_QuellenTyp(5) = "Taufe Kirche"
        str_QuellenTyp(6) = "Komm. Kirche"
        str_QuellenTyp(7) = "Beerd. Kirche"
        str_QuellenTyp(8) = "Beerd. Standesamt"
        str_QuellenTyp(9) = "Ehe Kirche"
        str_QuellenTyp(10) = "Ehe Standesamt"
        str_QuellenTyp(11) = "Scheidung Standesamt"

        str_Tab_Event(0) = ""
        str_Tab_Event(1) = "Geburt"
        str_Tab_Event(2) = "Taufe"
        str_Tab_Event(3) = "Tod"
        str_Tab_Event(4) = "Beerdigung"
        str_Tab_Event(5) = "Ehe Kirche"
        str_Tab_Event(6) = "Ehe Standesamt"
        str_Tab_Event(7) = "Alle"

    End Sub

    REM **************************************************************
    REM *  Wechsel der Tabellenreiter, Prüfen auf Änderungen         *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Change()

        If int_Sel_Tab <> int_Sel_TabX Or int_Sel_TabY < 0 Then
            REM *----------------------------------------------------*
            REM *  Verlassen der Maske Basisdaten                    *
            REM *----------------------------------------------------*
            If int_Sel_TabX = 0 Then
                Call Tab_Reiter_Change_10()
            End If
            REM *----------------------------------------------------*
            REM *  Verlassen der Maske Taufdaten                     *
            REM *----------------------------------------------------*
            If int_Sel_TabX = 1 Then
                Call Tab_Reiter_Change_11()
            End If
            REM *----------------------------------------------------*
            REM *  Verlassen der Maske Beerdigungsdaten              *
            REM *----------------------------------------------------*
            If int_Sel_TabX = 2 Then
                Call Tab_Reiter_Change_12()
            End If
            REM *----------------------------------------------------*
            REM *  Verlassen der Maske Ehedaten                      *
            REM *----------------------------------------------------*
            If int_Sel_TabX = 3 Then
                Call Tab_Reiter_Change_13()
            End If
            REM *----------------------------------------------------*
            REM *  Verlassen der Maske Anschriften                   *
            REM *----------------------------------------------------*
            If int_Sel_TabX = 4 Then
                Call Tab_Reiter_Change_14()
            End If
            REM *----------------------------------------------------*
            REM *  Verlassen der Maske Berufe                        *
            REM *----------------------------------------------------*
            If int_Sel_TabX = 5 Then
                Call Tab_Reiter_Change_15()
            End If
            REM *----------------------------------------------------*
            REM *  Verlassen der Maske Texte                         *
            REM *----------------------------------------------------*
            If int_Sel_TabX = 6 Then
                Call Tab_Reiter_Change_16()
            End If
            REM *----------------------------------------------------*
            REM *  Verlassen der Maske Paten/Zeugen                  *
            REM *----------------------------------------------------*
            If int_Sel_TabX = 7 Then
                Call Tab_Reiter_Change_17()
            End If
        End If
        int_Sel_TabX = int_Sel_Tab
        Call Tab_Reiter_Neu()
    End Sub

    REM **************************************************************
    REM *  Bei Maskenwechsel evtl. Neu-Button ausblenden             *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Neu()
        With NM_Ahnen
            .bt_00_Neu.Visible = True
            If int_Sel_Tab = 0 Then
                Call TabPos_Mask10()
            End If
            If int_Sel_Tab = 1 Then
                Call TabPos_Mask11()
                'If int_Merk_Tab_Taufe = 1 Then .bt_00_Neu.Visible = False
            End If
            If int_Sel_Tab = 2 Then
                'If int_Merk_Tab_Beerd = 1 Then .bt_00_Neu.Visible = False
                Call TabPos_Mask12()
            End If
            If int_Sel_Tab = 3 Then
                'If int_Merk_Tab_Ehe = 1 Then .bt_00_Neu.Visible = False
                Call TabPos_Mask13()
            End If
            If int_Sel_Tab = 4 Then
                Call Mask_14_Aktiv(False)
                Call TabPos_Mask14()
            End If
            If int_Sel_Tab = 5 Then
                Call TabPos_Mask15()
            End If
            If int_Sel_Tab = 6 Then
                'If int_Merk_Tab_Text = 1 Then .bt_00_Neu.Visible = False
                Call TabPos_Mask16()
            End If
            If int_Sel_Tab = 7 Then
                'If int_Merk_Tab_Paten = 1 Then .bt_00_Neu.Visible = False
                Call TabPos_Mask17()
            End If
        End With
    End Sub

    REM **************************************************************
    REM *  Verlassen der Maske 10 (Basisdaten)                       *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Change_10()
        Call Plausi_Daten_Tab10()
        Call Change_Pruef_Tab10()
        If int_Merk_vgl > 0 Then
            REM *--------------------------------------------*
            REM *  Sicherheitsabfrage                        *
            REM *--------------------------------------------*
            Call Wechselabfrage()
            If response = MsgBoxResult.No Then
                Call Mask_Out_Person()
            End If
            If response = MsgBoxResult.Yes Then
                If int_Merk_Tab_Grund = 1 Then
                    REM *  Update
                    If int_Merk_vgl > 1 Then Call Plausi_DB_Zeichen_Tab10()
                    Call Check_Daten_Tab10()
                    Call Person_Update_T01()
                    If int_His_Count > 0 Then Call Tab_His_Insert()
                Else
                    REM *  Neuanlage
                    Call Plausi_DB_Zeichen_Tab10()
                    Call Person_Insert()
                    Call Blaettern_Last()
                End If
                'Call Person_Read_01()
            End If
        End If

    End Sub

    REM **************************************************************
    REM *  Verlassen der Maske 11 (Taufdaten)                        *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Change_11()
        Call Plausi_Daten_Tab11()
        Call Change_Pruef_Tab11()
        If int_Merk_vgl > 0 Then
            REM *--------------------------------------------*
            REM *  Sicherheitsabfrage                        *
            REM *--------------------------------------------*
            Call Wechselabfrage()
            If response = MsgBoxResult.No Then
                Call Mask_Out_Person()
            End If
            If response = MsgBoxResult.Yes Then
                If int_Merk_Tab_Taufe = 1 Then
                    REM *  Update
                    Call Plausi_DB_Zeichen_Tab11()
                    Call Check_Daten_Tab11()
                    Call Person_Update_T02()
                    Call Person_Update_T01_ADat()
                    If int_His_Count > 0 Then Call Tab_His_Insert()
                Else
                    REM *  Neuanlage
                    Call Plausi_DB_Zeichen_Tab11()
                    Call Person_Taufe_Insert()
                End If
                Call Person_Read_01()
            End If
        End If

    End Sub

    REM **************************************************************
    REM *  Verlassen der Maske 12 (Beerdigungsdaten)                 *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Change_12()
        Call Plausi_Daten_Tab12()
        Call Change_Pruef_Tab12()
        If int_Merk_vgl > 0 Then
            REM *--------------------------------------------*
            REM *  Sicherheitsabfrage                        *
            REM *--------------------------------------------*
            Call Wechselabfrage()
            If response = MsgBoxResult.No Then
                Call Mask_Out_Person()
            End If
            If response = MsgBoxResult.Yes Then
                If int_Merk_Tab_Beerd = 1 Then
                    Call Plausi_DB_Zeichen_Tab12()
                    Call Check_Daten_Tab12()
                    Call Person_Update_T03()
                    Call Person_Update_T01_ADat()
                    If int_His_Count > 0 Then Call Tab_His_Insert()
                Else
                    Call Person_Beerd_Insert()
                End If
                Call Person_Read_01()
            End If
        End If
    End Sub

    REM **************************************************************
    REM *  Verlassen der Maske 13 (Ehedaten)                         *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Change_13()
        Call Change_Pruef_Tab13()
        Call Plausi_Daten_Tab13()
        If int_Merk_vgl > 0 Then
            REM *--------------------------------------------*
            REM *  Sicherheitsabfrage                        *
            REM *--------------------------------------------*
            Call Wechselabfrage()
            If response = MsgBoxResult.No Then
                Call Mask_Out_Person()
            End If
            If response = MsgBoxResult.Yes Then
                If int_Merk_Tab_Ehe = 1 Then
                    Call Plausi_DB_Zeichen_Tab13()
                    Call Check_Daten_Tab13()
                    Call Person_Update_T041()
                    Call Person_Update_T01_ADat()
                    If int_His_Count > 0 Then Call Tab_His_Insert()
                Else
                    Call Person_Ehe_041()
                End If
                Call Person_Read_01()
            End If
        End If
    End Sub

    REM **************************************************************
    REM *  Verlassen der Maske 14 (Anschriften)                      *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Change_14()
        Call Plausi_Daten_Tab14()
        Call Change_Pruef_Tab14()
        If int_Merk_vgl > 0 Then
            REM *--------------------------------------------*
            REM *  Sicherheitsabfrage                        *
            REM *--------------------------------------------*
            Call Wechselabfrage()
            If response = MsgBoxResult.No Then
                Call Mask_Out_Person()
            End If
            If response = MsgBoxResult.Yes Then
                Call Plausi_DB_Zeichen_Tab14()
                Call Check_Daten_Tab14()
                Call Person_Update_T06()
                Call Person_Update_T01_ADat()
                If int_His_Count > 0 Then Call Tab_His_Insert()
                Call Person_Read_01()
            End If
        End If        REM  Daten updaten bzw. Neu
    End Sub

    REM **************************************************************
    REM *  Verlassen der Maske 15 (Berufe)                           *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Change_15()
        Call Plausi_Daten_Tab15()
        Call Change_Pruef_Tab15()
        REM  Daten updaten bzw. Neu
    End Sub

    REM **************************************************************
    REM *  Verlassen der Maske 16 (Texte)                            *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Change_16()
        Call Plausi_Daten_Tab16()
        Call Change_Pruef_Tab16()
        REM  Daten updaten bzw. Neu
    End Sub

    REM **************************************************************
    REM *  Verlassen der Maske 19 (Paten / Zeugen)                   *
    REM **************************************************************
    Public Shared Sub Tab_Reiter_Change_17()
        Call Plausi_Daten_Tab17()
        Call Change_Pruef_Tab17()
        REM  Daten updaten bzw. Neu
    End Sub

    REM **************************************************************
    REM *  Sicherheitsabfrage bei Maskenwechsel und Änderung         *
    REM **************************************************************
    Public Shared Sub Wechselabfrage()
        str_Msg = "Änderungen speichern ?"
        str_Titel = "Maskenwechsel"
        style = MsgBoxStyle.DefaultButton2 Or MsgBoxStyle.Critical Or MsgBoxStyle.YesNo
        response = MsgBox(str_Msg, style, str_Titel)
    End Sub

    REM **************************************************************
    REM *  letztes Komma im Updatestring entfernen                   *
    REM **************************************************************
    Public Shared Sub Komma_Delete()
        Dim i97 As Integer
        Dim i98 As Integer
        i97 = Len(str_UString)
        For i98 = i97 To 1 Step -1
            If Mid(str_UString, i98, 1) = "," Then
                Mid(str_UString, i98, 1) = " "
                Exit For
            End If
        Next
    End Sub

    REM **************************************************************
    REM *  Zeichenprüfung auf DB-Unverträglichkeit                   *
    REM **************************************************************
    Public Shared Function DB_ZeichenString(ByVal str_File As String)
        Dim in7 As Integer
        Dim in8 As Integer
        Dim str_x As String
        Dim str_x1 As String
        Dim str_x2 As String
        in7 = Len(str_File)
        For in8 = in7 To 1 Step -1
            str_x = Mid(str_File, in8, 1)
            'If str_x = "'" Or str_x = "," Or str_x = ";" Or str_x = "/" Then
            If str_x = "'" Or str_x = "," Then
                str_x1 = Mid(str_File, 1, in8 - 1)
                str_x2 = Mid(str_File, in8, in7 - in8 + 1)
                str_File = str_x1 + str_x + str_x2
                in7 += 1
            End If
        Next
        Return str_File
    End Function

    REM **************************************************************
    REM *  Ermitteln des Alters der angezeigte Person                *
    REM ************************************************************** 
    Public Shared Sub Altersermittlung()
        int_Diff_J = 0
        int_Diff_M = 0
        int_Diff_T = 0
        If int_Old1_J = 0 And int_Old1_M = 0 And int_Old1_T = 0 Then
            Exit Sub
        End If
        If int_Old2_J = 0 And int_Old2_M = 0 And int_Old2_T = 0 Then
            int_Old2_J = str_AktJahr
            int_Old2_M = str_AktMon
            int_Old2_T = str_AktTag
        End If
        int_Diff_J = int_Old2_J - int_Old1_J
        int_Diff_M = int_Old2_M - int_Old1_M
        int_Diff_T = int_Old2_T - int_Old1_T
        If int_Diff_T < 0 Then int_Diff_M -= 1
        If int_Diff_M < 0 Then int_Diff_J -= 1
    End Sub

    REM **************************************************************
    REM *  Controls für Bildanzeige aktivieren / deaktivieren        *
    REM **************************************************************
    Public Shared Sub Bild_Visible(ByVal b_OK As Boolean)
        With NM_Ahnen
            .dgv_Pictures.Visible = b_OK
            .pbx_01_01.Visible = b_OK
            .bt_01_PicOK.Visible = b_OK
            .bt_01_PicDel.Visible = b_OK
            .lbl_01_LFD.Visible = b_OK
            .lbl_01_Bez.Visible = b_OK
            .tx_01_LFD.Visible = b_OK
            .tx_01_Bez.Visible = b_OK
        End With
    End Sub

    REM **************************************************************
    REM *  Controls für Datenanzeige aktivieren / deaktivieren       *
    REM **************************************************************
    Public Shared Sub Daten_visible(ByVal b_OK As Boolean)
        With NM_Ahnen
            .lbx_01_Mutter1.Visible = b_OK
            .lbx_01_Mutter2.Visible = b_OK
            .lbx_01_Vater1.Visible = b_OK
            .lbx_01_Vater2.Visible = b_OK
            .lbl_01_Vater.Visible = b_OK
            .lbl_01_Mutter.Visible = b_OK
            .lbl_01_Geschwister.Visible = b_OK
            .lbl_01_Ehen.Visible = b_OK
            .lbl_01_Kinder.Visible = b_OK
            .bt_01_Vater.Visible = b_OK
            .bt_01_Mutter.Visible = b_OK
            .dgv_Geschwister.Visible = b_OK
            .dgv_Ehen.Visible = b_OK
            .dgv_Kinder.Visible = b_OK
        End With
    End Sub

    REM **************************************************************
    REM *  Controls für Datenänderung aktivieren / deaktivieren      *
    REM **************************************************************
    Public Shared Sub Change_Button(ByVal b_OK As Boolean)
        With NM_Ahnen
            '.bt_xx_OK.Visible = b_OK
            '.bt_xx_Cancel.Visible = b_OK
        End With
    End Sub

    REM **************************************************************
    REM *  Infobutton aktivieren / deaktivieren Basisdaten           *
    REM **************************************************************
    Public Shared Sub Change_Info_10(ByVal b_OK As Boolean)
        With NM_Ahnen
            .bt_10_01_Name.Visible = b_OK
            .bt_10_03_NameZ.Visible = b_OK
            .bt_10_02_GebName.Visible = b_OK
            .bt_10_04_Vorname.Visible = b_OK
            .bt_10_06_Spitzn.Visible = b_OK
            .bt_10_09_Geb.Visible = b_OK
            .bt_10_13_Sterb.Visible = b_OK
            .bt_10_10_GUrk.Visible = b_OK
            .bt_10_14_SUrk.Visible = b_OK
            .bt_10_11_Gurk2.Visible = b_OK
            .bt_10_15_SUrk2.Visible = b_OK
            .bt_10_05_Rufname.Visible = b_OK
            .bt_10_07_Titel.Visible = b_OK
            .bt_10_08_GDat.Visible = b_OK
            .bt_10_12_SDat.Visible = b_OK
        End With
    End Sub

    REM **************************************************************
    REM *  Infobutton aktivieren / deaktivieren Taufdaten            *
    REM **************************************************************
    Public Shared Sub Change_Info_11(ByVal b_OK As Boolean)
        With NM_Ahnen
            .bt_11_01_Tauf_Dat.Visible = b_OK
            .bt_11_02_Tauf_Ort.Visible = b_OK
            .bt_11_03_Tauf_Kirche.Visible = b_OK
            .bt_11_04_Konf.Visible = b_OK
            .bt_11_05_Priester.Visible = b_OK
            .bt_11_06_Tauf_Urk.Visible = b_OK
            .bt_11_07_TaufPaten.Visible = b_OK
            .bt_11_08_FDat.Visible = b_OK
            .bt_11_09_FOrt.Visible = b_OK
            .bt_11_10_FKirche.Visible = b_OK
            .bt_11_11_FPriester.Visible = b_OK
            .bt_11_12_FUrk.Visible = b_OK
        End With
    End Sub

    REM **************************************************************
    REM *  Infobutton aktivieren / deaktivieren Taufdaten            *
    REM **************************************************************
    Public Shared Sub Change_Info_12(ByVal b_OK As Boolean)
        With NM_Ahnen
            .bt_12_01_BDat.Visible = b_OK
            .bt_12_02_BOrt.Visible = b_OK
            .bt_12_03_Bart.Visible = b_OK
            .bt_12_04_Friedhof.Visible = b_OK
            .bt_12_05_Grablage.Visible = b_OK
            .bt_12_06_TodUr.Visible = b_OK
            .bt_12_07_StUrk.Visible = b_OK
            .bt_12_08_StUrk2.Visible = b_OK
            .bt_12_09_Priester.Visible = b_OK
        End With
    End Sub

    REM **************************************************************
    REM *  Infobutton aktivieren / deaktivieren Ehedaten             *  
    REM **************************************************************
    Public Shared Sub Change_Info_13(ByVal b_OK As Boolean)
        With NM_Ahnen
            .bt_13_01_Dat1.Visible = b_OK
            .bt_13_02_Ort1.Visible = b_OK
            .bt_13_03_Beamter.Visible = b_OK
            .bt_13_04_Urk1.Visible = b_OK
            .bt_13_05_TZ1.Visible = b_OK
            .bt_13_06_Dat2.Visible = b_OK
            .bt_13_07_Ort2.Visible = b_OK
            .bt_13_08_Kirche.Visible = b_OK
            .bt_13_09_Priester.Visible = b_OK
            .bt_13_10_Urk2.Visible = b_OK
            .bt_13_11_TZ2.Visible = b_OK
            .bt_13_12_Dat3.Visible = b_OK
            .bt_13_13_Urk3.Visible = b_OK
        End With
    End Sub

    REM **************************************************************
    REM *  Infobutton aktivieren / deaktivieren Anschrift            *  
    REM **************************************************************
    Public Shared Sub Change_Info_14(ByVal b_OK As Boolean)
        With NM_Ahnen
        End With
    End Sub

    REM **************************************************************
    REM *  Infobutton aktivieren / deaktivieren Anschrift            *  
    REM **************************************************************
    Public Shared Sub Change_Info_15(ByVal b_OK As Boolean)
        With NM_Ahnen
        End With
    End Sub

    REM **************************************************************
    REM *  Infobutton aktivieren / deaktivieren Anschrift            *  
    REM **************************************************************
    Public Shared Sub Change_Info_16(ByVal b_OK As Boolean)
        With NM_Ahnen

        End With
    End Sub

    REM **************************************************************
    REM *  Infobutton aktivieren / deaktivieren Anschrift            *  
    REM **************************************************************
    Public Shared Sub Change_Info_17(ByVal b_OK As Boolean)
        With NM_Ahnen
        End With
    End Sub

    REM **************************************************************
    REM *  Automatisierte Ergänzung der Ortsnamen                    *
    REM **************************************************************
    Public Shared Sub Orte_Add()
        Dim i98 As Integer = 0
        For i99 = 1 To int_AnzOrte
            If str_TX_Ort1 = str_Para_Ort1_Bez(i99) Then
                i98 = i99
            End If
        Next
        If i98 = 0 Then Call Para_Orte_DB_Insert_Auto()
    End Sub

    REM **************************************************************
    REM *  Ermitteln des Pfades der Bilddatei                        *
    REM **************************************************************
    Public Shared Sub Pfad_Ermittlung()
        Dim i11 As Integer
        Dim i12 As Integer
        i11 = Len(str_Path_1)
        For i12 = i11 To 0 Step -1
            If Mid(str_Path_1, i12, 1) = "\" Then
                str_FileName = Mid(str_Path_1, i12 + 1, i11 - i12)
                str_Path_2 = str_PicDirectory + str_FileName
                i12 = 0
            End If
        Next
    End Sub

    REM **************************************************************
    REM *  Sprung zur Maske Search                                   *
    REM **************************************************************
    Public Shared Sub Maskenwechsel_Search()
        Call Clear_91()
        NM_Ahnen_Search.Show()
    End Sub

    REM **************************************************************
    REM *  Sprung zur Maske Parameterdaten                           *
    REM **************************************************************
    Public Shared Sub Maskenwechsel_Para()
        NM_Ahnen_Para.Show()
    End Sub

    REM **************************************************************
    REM *  Sprung zur Maske ToDo                                     *
    REM **************************************************************
    Public Shared Sub Maskenwechsel_ToDo()
        NM_Ahnen_ToDo.Show()
    End Sub

    REM **************************************************************
    REM *  Sprung zur Maske Historiendaten                           *
    REM **************************************************************
    Public Shared Sub Maskenwechsel_His()
        NM_Ahnen_His.Show()
    End Sub

    REM **************************************************************
    REM *  Sprung zur Maske Kommentar                                *
    REM **************************************************************
    Public Shared Sub Maskenwechsel_Komm()
        NM_Ahnen_Komm.Show()
    End Sub
    Public Shared Sub Maskenwechel_Orte()
        NM_Ahnen_Orte.Show()
    End Sub

    Public Shared Sub Maskenwechsel_Quelle()
        NM_Ahnen_Quelle.Show()
    End Sub

    REM **************************************************************
    REM *  Plausiprüfung für Vatereintrag                            *
    REM **************************************************************
    Public Shared Sub Plausi_Vater()
        Dim lng_P1_Alter As Long
        Dim lng_P2_Alter As Long
        REM *-------------------------------------------------------*
        REM *  Plausi-schalter auf Null setzten                     *
        REM *-------------------------------------------------------*
        int_Merk_Plausi_Search = 0
        REM *-------------------------------------------------------*
        REM *  Daten der Bezugsperson lesen                         *
        REM *-------------------------------------------------------*
        Call Person_Read_Search()
        REM *-------------------------------------------------------*
        REM *  Prüfung auf Geschlecht                               *
        REM *-------------------------------------------------------*
        If s_str_Geschl <> "M" Then
            MsgBox("Geschlechtsangabe Vater falsch", MsgBoxStyle.OkOnly)
            int_Merk_Plausi_Search = 1
            Exit Sub
        End If
        REM *-------------------------------------------------------*
        REM *  Prüfung auf Alter                                    *
        REM *-------------------------------------------------------*
        If s_str_GDat_JJ <> "" Then
            If p_str_GDat_JJ <> "" Then
                If s_str_SDat_JJ > "" Then
                    s_str_SDat = s_str_SDat_JJ + s_str_SDat_MM + s_str_SDat_TT
                    s_str_SDat = Val(s_str_SDat)
                    lng_P1_Alter = s_str_SDat + 9600
                    lng_P2_Alter = p_str_GDat
                    If lng_P1_Alter < lng_P2_Alter Then
                        MsgBox("Vater bereits vor Zeugungstermin verstorben", MsgBoxStyle.OkOnly)
                        int_Merk_Plausi_Search = 1
                        Exit Sub
                    End If
                End If
                lng_P1_Alter = Val(s_str_GDat_JJ)
                lng_P2_Alter = Val(p_str_GDat_JJ) - int_Delta_Vater_Min
                If lng_P1_Alter > lng_P2_Alter Then
                    MsgBox("Vater ist zu jung", MsgBoxStyle.OkOnly)
                    int_Merk_Plausi_Search = 1
                    Exit Sub
                End If
                lng_P1_Alter = Val(s_str_GDat_JJ)
                lng_P2_Alter = Val(p_str_GDat_JJ) - int_Delta_Vater_Max
                If lng_P1_Alter < lng_P2_Alter Then
                    MsgBox("Vater ist zu alt", MsgBoxStyle.OkOnly)
                    int_Merk_Plausi_Search = 1
                    Exit Sub
                End If
            End If
        End If
    End Sub

    REM **************************************************************
    REM *  Plausiprüfung für Muttereintrag                           *
    REM **************************************************************
    Public Shared Sub Plausi_Mutter()
        Dim lng_P1_Alter As Integer
        Dim lng_P2_Alter As Integer
        REM *-------------------------------------------------------*
        REM *  Plausi-schalter auf Null setzten                     *
        REM *-------------------------------------------------------*
        int_Merk_Plausi_Search = 0
        REM *-------------------------------------------------------*
        REM *  Daten der Bezugsperson lesen                         *
        REM *-------------------------------------------------------*
        Call Person_Read_Search()
        REM *-------------------------------------------------------*
        REM *  Prüfung auf Geschlecht                               *
        REM *-------------------------------------------------------*
        If s_str_Geschl <> "W" Then
            MsgBox("Geschlechtsangabe Mutter falsch", MsgBoxStyle.OkOnly)
            int_Merk_Plausi_Search = 1
            Exit Sub
        End If
        REM *-------------------------------------------------------*
        REM *  Prüfung auf Alter                                    *
        REM *-------------------------------------------------------*
        If s_str_GDat_JJ <> "" Then
            If p_str_GDat_JJ <> "" Then
                If s_str_SDat_JJ > "" Then
                    s_str_SDat = s_str_SDat_JJ + s_str_SDat_MM + s_str_SDat_TT
                    s_str_SDat = Val(s_str_SDat)
                    lng_P1_Alter = s_str_SDat + 9600
                    lng_P2_Alter = p_str_GDat
                    If lng_P1_Alter < lng_P2_Alter Then
                        MsgBox("Mutter bereits vor Geburtstermin verstorben", MsgBoxStyle.OkOnly)
                        int_Merk_Plausi_Search = 1
                        Exit Sub
                    End If
                End If
                lng_P1_Alter = Val(s_str_GDat_JJ)
                lng_P2_Alter = Val(p_str_GDat_JJ) - int_Delta_Mutter_Min
                If lng_P1_Alter > lng_P2_Alter Then
                    MsgBox("Mutter ist zu jung", MsgBoxStyle.OkOnly)
                    int_Merk_Plausi_Search = 1
                    Exit Sub
                End If
                lng_P1_Alter = Val(s_str_GDat_JJ)
                lng_P2_Alter = Val(p_str_GDat_JJ) - int_Delta_Mutter_Max
                If lng_P1_Alter < lng_P2_Alter Then
                    MsgBox("Mutter ist zu alt", MsgBoxStyle.OkOnly)
                    int_Merk_Plausi_Search = 1
                    Exit Sub
                End If
            End If
        End If
    End Sub

    REM **************************************************************
    REM *  Plausiprüfung für Muttereintrag                           *
    REM **************************************************************
    Public Shared Sub Plausi_Ehe()
        Dim lng_P1_Alter As Integer
        REM *-------------------------------------------------------*
        REM *  Plausi-schalter auf Null setzten                     *
        REM *-------------------------------------------------------*
        int_Merk_Plausi_Search = 0
        REM *-------------------------------------------------------*
        REM *  Daten der Bezugsperson lesen                         *
        REM *-------------------------------------------------------*
        Call Person_Read_Search()
        REM *-------------------------------------------------------*
        REM *  Prüfung auf Geschlecht                               *
        REM *-------------------------------------------------------*
        If p_str_Geschl = "M" Then
            If s_str_Geschl <> "F" Then
                MsgBox("Geschlecht Braut falsch", MsgBoxStyle.OkOnly)
                int_Merk_Plausi_Search = 1
                Exit Sub
            End If
        End If
        If p_str_Geschl = "F" Then
            If s_str_Geschl <> "M" Then
                MsgBox("Geschlecht Bräutigam falsch", MsgBoxStyle.OkOnly)
                int_Merk_Plausi_Search = 1
                Exit Sub
            End If
        End If
        REM *-------------------------------------------------------*
        REM *  Prüfung auf Alter                                    *
        REM *-------------------------------------------------------*
        REM * !!!! Geburtsdatum in Abhängigkeit von Heiratsdatum !!!!
        If s_str_GDat_JJ <> "" Then
            If p_str_GDat_JJ <> "" Then
                lng_P1_Alter = s_str_GDat_JJ - p_str_GDat_JJ
                If lng_P1_Alter < 0 Then lng_P1_Alter = lng_P1_Alter * -1
                If lng_P1_Alter > int_Delta_Ehe_Max Then
                    MsgBox("Partner - Altersunterschied", MsgBoxStyle.OkOnly)
                    int_Merk_Plausi_Search = 1
                    Exit Sub
                End If
            End If
        End If
    End Sub

    REM **************************************************************
    REM *  Plausiprüfung für Pateneintrag                            *
    REM **************************************************************
    Public Shared Sub Plausi_Taufpate()
        Dim lng_P1_Alter As Integer
        Dim lng_P2_Alter As Integer
        REM *-------------------------------------------------------*
        REM *  Plausi-schalter auf Null setzten                     *
        REM *-------------------------------------------------------*
        int_Merk_Plausi_Search = 0
        REM *-------------------------------------------------------*
        REM *  Daten der Bezugsperson lesen                         *
        REM *-------------------------------------------------------*
        Call Person_Read_Search()
        REM *-------------------------------------------------------*
        REM *  Prüfung auf Alter                                    *
        REM *-------------------------------------------------------*
        If s_str_GDat_JJ <> "" Then
            If p_str_GDat_JJ <> "" Then
                If s_str_SDat_JJ > "" Then
                    s_str_SDat = s_str_SDat_JJ + s_str_SDat_MM + s_str_SDat_TT
                    s_str_SDat = Val(s_str_SDat)
                    lng_P1_Alter = s_str_SDat + 9600
                    lng_P2_Alter = p_str_GDat
                    If lng_P1_Alter < lng_P2_Alter Then
                        MsgBox("Pate bereits vor Geburtstermin verstorben", MsgBoxStyle.OkOnly)
                        int_Merk_Plausi_Search = 1
                        Exit Sub
                    End If
                End If
                lng_P1_Alter = Val(s_str_GDat_JJ)
                lng_P2_Alter = Val(p_str_GDat_JJ) - int_Delta_Pate_Min
                If lng_P1_Alter > lng_P2_Alter Then
                    MsgBox("Pate ist zu jung", MsgBoxStyle.OkOnly)
                    int_Merk_Plausi_Search = 1
                    Exit Sub
                End If
                lng_P1_Alter = Val(s_str_GDat_JJ)
                lng_P2_Alter = Val(p_str_GDat_JJ) - int_Delta_Pate_Max
                If lng_P1_Alter < lng_P2_Alter Then
                    MsgBox("Pate ist zu alt", MsgBoxStyle.OkOnly)
                    int_Merk_Plausi_Search = 1
                    Exit Sub
                End If
            End If
        End If
    End Sub

    REM **************************************************************
    REM *  Plausiprüfung für Trauzeuge                               *
    REM **************************************************************
    Public Shared Sub Plausi_Trauzeuge()
        Dim lng_P1_Alter As Integer
        Dim lng_P2_Alter As Integer
        REM *-------------------------------------------------------*
        REM *  Plausi-schalter auf Null setzten                     *
        REM *-------------------------------------------------------*
        int_Merk_Plausi_Search = 0
        REM *-------------------------------------------------------*
        REM *  Daten der Bezugsperson lesen                         *
        REM *-------------------------------------------------------*
        Call Person_Read_Search()

        REM *-------------------------------------------------------*
        REM *  Prüfung auf Alter                                    *
        REM *-------------------------------------------------------*
        If s_str_GDat_JJ <> "" Then
            If p_str_GDat_JJ <> "" Then
                If s_str_SDat_JJ > "" Then
                    s_str_SDat = s_str_SDat_JJ + s_str_SDat_MM + s_str_SDat_TT
                    s_str_SDat = Val(s_str_SDat)
                    lng_P1_Alter = s_str_SDat + 9600
                    lng_P2_Alter = p_str_GDat
                    If lng_P1_Alter < lng_P2_Alter Then
                        MsgBox("Trauzeuge bereits vor Geburtstermin verstorben", MsgBoxStyle.OkOnly)
                        int_Merk_Plausi_Search = 1
                        Exit Sub
                    End If
                End If
                'lng_P1_Alter = Val(s_str_GDat_JJ)
                'lng_P2_Alter = Val(p_str_GDat_JJ) - int_Delta_Zeuge_Min
                'If lng_P1_Alter > lng_P2_Alter Then
                ' MsgBox("Trauzeuge ist zu jung", MsgBoxStyle.OkOnly)
                ' int_Merk_Plausi_Search = 1
                ' Exit Sub
                'End If

                'lng_P1_Alter = Val(s_str_GDat_JJ)
                'lng_P2_Alter = Val(p_str_GDat_JJ) - int_Delta_Zeuge_Min
                'If lng_P1_Alter < lng_P2_Alter Then
                'MsgBox("Trauzeuge ist zu alt", MsgBoxStyle.OkOnly)
                'int_Merk_Plausi_Search = 1
                'Exit Sub
                'End If
            End If
        End If
    End Sub

    REM **************************************************************
    REM *  Ermitteln der Zeilenposition für Maskenoutput             *
    REM **************************************************************
    Public Shared Sub PosDef()
        int_Pos_x = int_x
        int_Pos_y = (int_Zeil * int_y) + (int_Zeil * int_ZDiff)
    End Sub

    REM **************************************************************
    REM *  Löschen der temporären Historientabelle                   *
    REM **************************************************************
    Public Shared Sub ClearHis()
        Dim i88 As Integer = 0
        For i88 = 0 To 50
            int_His_Nr(i88) = 0
            str_His(i88) = ""
        Next i88
        int_His_Tab = 0
    End Sub

    REM **************************************************************
    REM *  Füllen der temporären Historientabelle                    *
    REM **************************************************************
    Public Shared Sub HisTab(ByVal int_Hfeld As Integer, ByVal str_HFeld As String)
        int_His_Count += 1
        int_His_Nr(int_His_Count) = int_Hfeld
        str_His(int_His_Count) = str_HFeld
    End Sub

    REM **************************************************************
    REM *  Daten in Historien-Tabelle inserten                       *
    REM **************************************************************
    Public Shared Sub Tab_His_Insert()
        Dim i88 As Integer
        Dim dateHis = DateTime.Now
        Call DB_Tab_High("t88_ID", "t88_Historie")
        Call Datum_Date(str_AktDatP, True)
        For i88 = 1 To int_His_Count
            dbl_Max_ID += 1
            str_DBD_t88 = " values (" + dbl_Max_ID.ToString + ", "
            str_DBD_t88 += "'" + p_int_ID.ToString + "', "
            str_DBD_t88 += "'" + int_Sel_TabX.ToString + "', "
            str_DBD_t88 += "'" + int_His_Nr(i88).ToString + "', "
            str_DBD_t88 += "'" + str_AktDatP + "', "
            str_DBD_t88 += "'" + str_His(i88) + "' "
            str_DBD_t88 += ")"
            mySelect.CommandText = "insert into t88_Historie " + str_DBS_t88 & str_DBD_t88
            Call DB_Execute()
        Next
    End Sub

    REM **************************************************************
    REM *  Datumsumwandlung und Prüfung in Date-Format               *
    REM **************************************************************
    Public Shared Sub Datum_Date(ByVal str_DD As String, ByVal min As Boolean)
        Dim str_XX1 As String
        Dim str_XX2 As String
        Dim str_XX3 As String
        str_XX1 = Mid(str_DD, 1, 2)
        str_XX2 = Mid(str_DD, 4, 2)
        str_XX3 = Mid(str_DD, 7, 4)
        If IsNumeric(str_XX1) = False Then str_XX1 = "00"
        If IsNumeric(str_XX2) = False Then str_XX2 = "00"
        If IsNumeric(str_XX3) = False Then str_XX3 = "0000"
        REM * Tageswerte
        If str_XX1 < "01" Then
            If min = True Then
                str_XX1 = "01"
            Else
                str_XX1 = "31"
                If str_XX2 = "02" Then str_XX1 = "28"
            End If
        End If
        If str_XX1 > "31" Then
            If min = True Then
                str_XX1 = "01"
            Else
                str_XX1 = "31"
            End If
        End If
        REM * Monatswerte
        If str_XX2 < "01" Then
            If min = True Then
                str_XX2 = "01"
            Else
                str_XX2 = "12"
            End If
        End If
        If str_XX2 > "12" Then
            If min = True Then
                str_XX2 = "01"
            Else
                str_XX2 = "12"
            End If
        End If
        REM * Jahreswerte
        If str_XX3 < "0001" Then
            If min = True Then
                str_XX3 = "0001"
            Else
                str_XX3 = "9999"
            End If
        End If
        If str_XX3 > "9999" Then
            If min = True Then
                str_XX3 = "0001"
            Else
                str_XX3 = "9999"
            End If
        End If
        str_Dat_H = str_XX1 + "." + str_XX2 + "." + str_XX3
        dt_Date = CType(str_Dat_H, Date)
    End Sub

End Class
