﻿Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.Cls_90_Mask_201
Public Class Cls_91_DB_Para_04

    REM ***********************************************************
    REM *  Bearbeitung Tabelle a04 (Ortsbezeichnungen)            *
    REM ***********************************************************
    Public Shared Sub Para_Orte_Load()
        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Ort.Rows.Clear()
            For int_i5 = 1 To int_AnzOrte
                .dgv_Ort.Rows.Add(int_i5.ToString("0000"), str_Para_Ort1_Bez(int_i5), str_Para_Ort2_Bez(int_i5), str_Para_Ort3_Bez(int_i5), str_Para_Ort_Anz0(int_i5), str_Para_Ort_Anz1(int_i5), str_Para_Ort_Anz2(int_i5), str_Para_Ort_Anz3(int_i5), str_Para_Ort_Anz4(int_i5), str_Para_Ort_Anz5(int_i5), str_Para_Ort_Anz6(int_i5), str_Para_Ort_Anz7(int_i5))
            Next
            .dgv_Ort.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic
        End With
    End Sub

    REM ***********************************************************
    REM *  Felder für Neuerfassung leeren                         *
    REM ***********************************************************
    Public Shared Sub Para_Orte_Neu()
        With NM_Ahnen_Para
            int_AnzOrte += 1
            .lbl_201_Lfdnr1.Text = int_AnzOrte
            .tx_201_Z1.Text = ""
            .tx_201_Z2.Text = ""
            .tx_201_Z3.Text = ""
        End With
    End Sub

    REM **************************************************************
    REM *  Einfügen von neuen Orten                                  *
    REM **************************************************************
    Public Shared Sub Para_Orte_DB_Insert()
        Dim int_a04_Typ As Integer = 1
        Dim int_Null As Integer = 0
        Call DB_Tab_High("a04_ID", "a04_Orte")
        dbl_Max_ID += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle a04 anlegen (Orte)                    *
        REM *--------------------------------------------------------*
        NM_Ahnen_Para.tx_201_Z1.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z1.Text)
        NM_Ahnen_Para.tx_201_Z2.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z2.Text)
        NM_Ahnen_Para.tx_201_Z3.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z3.Text)
        str_DBD_a04 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a04 += "'" + int_a04_Typ.ToString + "',"
        str_DBD_a04 += "'" + int_AnzOrte.ToString + "',"
        str_DBD_a04 += "'" + NM_Ahnen_Para.tx_201_Z1.Text + "', "
        str_DBD_a04 += "'" + NM_Ahnen_Para.tx_201_Z2.Text + "', "
        str_DBD_a04 += "'" + NM_Ahnen_Para.tx_201_Z3.Text + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "')"
        str_Tab = str_DBS_a04 + str_DBD_a04
        mySelect.CommandText = "insert into a04_Orte " & str_Tab
        Call DB_Execute()
        Call Tab_Orte()
        Call Para_Orte_Load()
    End Sub

    REM ***************************************************************
    REM *  Update bestehender Ortsbezeichnungen                       *
    REM ***************************************************************
    Public Shared Sub Para_Orte_Update()
        Dim reader As OleDbDataReader
        Dim int_i88 As Integer
        With NM_Ahnen_Para
            .lbl_201_Lfdnr1.Text = .dgv_Ort.CurrentRow.Cells(0).Value
            .tx_201_Z1.Text = .dgv_Ort.CurrentRow.Cells(1).Value
            .tx_201_Z2.Text = .dgv_Ort.CurrentRow.Cells(2).Value
            .tx_201_Z3.Text = .dgv_Ort.CurrentRow.Cells(3).Value
            For int_i88 = 0 To int_Anz_Ort
                If .tx_201_Z1.Text = str_Para_Ort1_Bez(int_i88) Then
                    dbl_x = int_Para_Ort_Nr(int_i88)
                    Exit For
                End If
            Next
        End With

        str_Where = "a04_ID = " + dbl_x.ToString
        mySelect.CommandText = "select * from a04_Orte where " & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a04_ID"))
                If myNull = False Then dbl_x = reader.Item("a04_ID")
            Loop
            reader.Close()
        Catch ex As Exception

        End Try
    End Sub

    REM **************************************************************
    REM *  Ändern von Ortsbezeichnungen                              *
    REM **************************************************************
    Public Shared Sub Para_Orte_Update2()
        NM_Ahnen_Para.tx_201_Z1.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z1.Text)
        NM_Ahnen_Para.tx_201_Z2.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z2.Text)
        NM_Ahnen_Para.tx_201_Z3.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z3.Text)
        str_Tab = "a04_Ort1 = '" + NM_Ahnen_Para.tx_201_Z1.Text + "',"
        str_Tab = "a04_Ort2 = '" + NM_Ahnen_Para.tx_201_Z2.Text + "',"
        str_Tab = "a04_Ort3 = '" + NM_Ahnen_Para.tx_201_Z3.Text + "'"
        mySelect.CommandText = "update a04_Orte set " & str_Tab & " where a04_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Orte()
        Call Para_Orte_Load()
    End Sub

    REM **************************************************************
    REM *  Einfügen von neuen Orten                                  *
    REM **************************************************************
    Public Shared Sub Para_Orte_DB_Insert_Auto()
        Dim int_a04_Typ As Integer = 1
        Dim int_Null As Integer = 0
        If int_Merk_Orte1 = 0 Then Call DB_Tab_High("a04_ID", "a04_Orte")
        dbl_Max_ID += 1
        int_AnzOrte += 1

        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle a04 anlegen (Orte)                    *
        REM *--------------------------------------------------------*
        str_TX_Ort1 = DB_ZeichenString(str_TX_Ort1)
        str_TX_Ort2 = DB_ZeichenString(str_TX_Ort2)
        str_TX_Ort3 = DB_ZeichenString(str_TX_Ort3)
        str_DBD_a04 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a04 += "'" + int_a04_Typ.ToString + "',"
        str_DBD_a04 += "'" + int_AnzOrte.ToString + "',"
        str_DBD_a04 += "'" + str_TX_Ort1 + "', "
        str_DBD_a04 += "'" + str_TX_Ort2 + "', "
        str_DBD_a04 += "'" + str_TX_Ort3 + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "',"
        str_DBD_a04 += "'" + int_Null.ToString + "')"
        str_Tab = str_DBS_a04 + str_DBD_a04

        mySelect.CommandText = "insert into a04_Orte " & str_Tab
        Call DB_Execute()
        Call Tab_Orte()
    End Sub

    REM ******************************************************************
    REM *  Ortstabelle gesamt neu aufbauen                               *
    REM ******************************************************************
    Public Shared Sub Para_Orte_Aufbau()
        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Dim str_O1 As String
        Dim str_O2 As String
        Dim reader As OleDbDataReader
        ReDim str_Tab_Orte(int_Anz * 2)
        ReDim int_Anz_Ort0(int_Anz * 2)
        ReDim int_Anz_Ort1(int_Anz * 2)
        ReDim int_Anz_Ort2(int_Anz * 2)
        ReDim int_Anz_Ort3(int_Anz * 2)
        ReDim int_Anz_Ort4(int_Anz * 2)
        ReDim int_Anz_Ort5(int_Anz * 2)
        ReDim int_Anz_Ort6(int_Anz * 2)
        ReDim int_Anz_Ort7(int_Anz * 2)
        int_Anz_Ort = 1
        REM *------------------------------------------------------------*
        REM *  Einlesen der Tabelle t01 (Geburts- und Sterbeorte)        *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t01_Person"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            str_O1 = ""
            str_O2 = ""
            myNull = IsDBNull(reader.Item("t01_GOrt"))
            If myNull = False Then str_O1 = reader.Item("t01_GOrt")
            myNull = IsDBNull(reader.Item("t01_SOrt"))
            If myNull = False Then str_O2 = reader.Item("t01_SOrt")
            str_O1 = Trim(str_O1)
            str_O2 = Trim(str_O2)
            If str_O1 > "" Then Call Para_Orte_Tabelle(str_O1, 1)
            If str_O2 > "" Then Call Para_Orte_Tabelle(str_O2, 2)
        Loop
        reader.Close()
        REM *------------------------------------------------------------*
        REM *  Einlesen der Tabelle t02 (Tauf- und Firmorte)             *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t02_Taufe"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            str_O1 = ""
            str_O2 = ""
            myNull = IsDBNull(reader.Item("t02_TOrt"))
            If myNull = False Then str_O1 = reader.Item("t02_TOrt")
            myNull = IsDBNull(reader.Item("t02_FOrt"))
            If myNull = False Then str_O1 = reader.Item("t02_FOrt")
            str_O1 = Trim(str_O1)
            str_O2 = Trim(str_O2)
            If str_O1 > "" Then Call Para_Orte_Tabelle(str_O1, 3)
            If str_O2 > "" Then Call Para_Orte_Tabelle(str_O2, 4)
        Loop
        reader.Close()
        REM *------------------------------------------------------------*
        REM *  Einlesen der Tabelle t03 (Beerdigungsorte)                *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t03_Beerd"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            str_O1 = ""
            myNull = IsDBNull(reader.Item("t03_BOrt"))
            If myNull = False Then str_O1 = reader.Item("t03_BOrt")
            str_O1 = Trim(str_O1)
            If str_O1 > "" Then Call Para_Orte_Tabelle(str_O1, 5)
        Loop
        reader.Close()
        REM *------------------------------------------------------------*
        REM *  Einlesen der Tabelle t041 (Eheorte)                       *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "select * from t041_Ehedaten"
        reader = mySelect.ExecuteReader
        Do While reader.Read()
            str_O1 = ""
            str_O2 = ""
            myNull = IsDBNull(reader.Item("t041_Ort1"))
            If myNull = False Then str_O1 = reader.Item("t041_Ort1")
            myNull = IsDBNull(reader.Item("t041_Ort2"))
            If myNull = False Then str_O2 = reader.Item("t041_Ort2")
            str_O1 = Trim(str_O1)
            str_O2 = Trim(str_O2)
            If str_O1 > "" Then Call Para_Orte_Tabelle(str_O1, 6)
            If str_O2 > "" Then Call Para_Orte_Tabelle(str_O2, 7)
        Loop
        reader.Close()
        REM *------------------------------------------------------------*
        REM *  Tabelle löschen, wird neu aufgebaut                       *
        REM *------------------------------------------------------------*
        mySelect.CommandText = "delete * from a04_Orte"
        Call DB_Execute()
        Call Para_Orte_Insert()
        REM *------------------------------------------------------------*
        REM *  Tabelle neu füllen                                        *
        REM *------------------------------------------------------------*
        int_AnzOrte = 0
        dbl_a04_ID = 0
        Call Para_Orte_DB_Insert()
        Call Tab_Orte()
        Call Para_Orte_Load()
    End Sub

    REM **************************************************************
    REM *  Füllen der Listview für Orte                              *
    REM **************************************************************
    Public Shared Sub Para_Orte_Tabelle(ByVal str_H As String, ByVal ITyp As Integer)
        Dim int_Vorhanden As Integer = 0
        Dim int_OM As Integer = 0
        str_TX_Ort2 = ""
        str_TX_Ort3 = ""
        str_H = LTrim(str_H)
        str_H = RTrim(str_H)
        If int_Anz_Ort = 1 Then
            str_Tab_Orte(1) = str_H
            int_Anz_Ort += 1
        End If
        For int_i09 = 1 To int_Anz_Ort - 1
            If str_Tab_Orte(int_i09) = str_H Then
                int_Vorhanden = 1
                int_OM = int_i09
                Exit For
            End If
        Next
        If int_Vorhanden = 0 Then
            str_Tab_Orte(int_Anz_Ort) = str_H
            int_OM = int_Anz_Ort
            int_Anz_Ort += 1
        End If
        int_Anz_Ort0(int_OM) += 1
        If ITyp = 1 Then int_Anz_Ort1(int_OM) += 1
        If ITyp = 2 Then int_Anz_Ort2(int_OM) += 1
        If ITyp = 3 Then int_Anz_Ort3(int_OM) += 1
        If ITyp = 4 Then int_Anz_Ort4(int_OM) += 1
        If ITyp = 5 Then int_Anz_Ort5(int_OM) += 1
        If ITyp = 6 Then int_Anz_Ort6(int_OM) += 1
        If ITyp = 7 Then int_Anz_Ort7(int_OM) += 1
    End Sub

    REM **************************************************************
    REM *  Einfügen von neuen Orten                                  *
    REM **************************************************************
    Public Shared Sub Para_Orte_Insert()
        Dim int_a04_Typ As Integer = 1
        Dim int_zz As Integer = 0
        int_AnzOrte = 0
        If int_Merk_Orte1 = 0 Then Call DB_Tab_High("a04_ID", "a04_Orte")
        For int_zz = 1 To int_Anz_Ort - 1
            dbl_Max_ID += 1
            int_AnzOrte += 1
            REM *--------------------------------------------------------*
            REM *  Satz in Tabelle a04 anlegen (Orte)                    *
            REM *--------------------------------------------------------*
            str_Tab_Orte(int_zz) = DB_ZeichenString(str_Tab_Orte(int_zz))
            str_TX_Ort2 = DB_ZeichenString(str_TX_Ort2)
            str_TX_Ort3 = DB_ZeichenString(str_TX_Ort3)
            str_DBD_a04 = " values ('" + dbl_Max_ID.ToString + "',"
            str_DBD_a04 += "'" + int_a04_Typ.ToString + "',"
            str_DBD_a04 += "'" + int_AnzOrte.ToString + "',"
            str_DBD_a04 += "'" + str_Tab_Orte(int_zz) + "', "
            str_DBD_a04 += "'" + str_TX_Ort2 + "', "
            str_DBD_a04 += "'" + str_TX_Ort3 + "',"
            str_DBD_a04 += "'" + int_Anz_Ort0(int_zz).ToString + "',"
            str_DBD_a04 += "'" + int_Anz_Ort1(int_zz).ToString + "',"
            str_DBD_a04 += "'" + int_Anz_Ort2(int_zz).ToString + "',"
            str_DBD_a04 += "'" + int_Anz_Ort3(int_zz).ToString + "',"
            str_DBD_a04 += "'" + int_Anz_Ort4(int_zz).ToString + "',"
            str_DBD_a04 += "'" + int_Anz_Ort5(int_zz).ToString + "',"
            str_DBD_a04 += "'" + int_Anz_Ort6(int_zz).ToString + "',"
            str_DBD_a04 += "'" + int_Anz_Ort7(int_zz).ToString + "')"
            str_Tab = str_DBS_a04 + str_DBD_a04
            mySelect.CommandText = "insert into a04_Orte " & str_Tab
            Call DB_Execute()
        Next
    End Sub

End Class
